unit PCI_pwd;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons;

type
  TfPassword = class(TForm)
    OKButton: TBitBtn;
    CancelButton: TBitBtn;
    Label1: TLabel;
    PwdEntry: TEdit;
    procedure OKButtonClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  fPassword: TfPassword;
  sRequiredPwd: string;
  sModeName: string;

implementation

{$R *.DFM}

procedure TfPassword.OKButtonClick(Sender: TObject);
begin
  if (PwdEntry.Text <> sRequiredPwd) then begin
    MessageDlg('Incorrect password.', mtInformation, [mbOK], 0);
    ModalResult := 0;
    PwdEntry.SetFocus;
    PwdEntry.SelectAll;
  end
  else
    ModalResult := mrOK
end;

procedure TfPassword.FormActivate(Sender: TObject);
begin
  Label1.Caption := 'Enter password for ' + sModeName + ' mode:';
  PwdEntry.Text := '';
  PwdEntry.SelectAll;
end;

end.
