unit Pci_program;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  WIForms, WIItemSpy, Buttons, StdCtrls, WSpinEdit, WISpinEdit, WICheckBox,
  WLabel, WILabel, WEnumComboBox, WIEnumComboBox, WIStringEdit, ExtCtrls,
  ComCtrls, WContainer, Spin, WWriteComponents, W5009SpinEdit,
  W5009SpinTune, Printers, WIItem, WIServlinkItem, WIBoxLabel, WIDAOneShotButton,
  WIDAMomentaryButton, WIOneShotButton, WIMomentaryButton, WIToggleButton,
  WIStatusText, WINumberEdit;

type
  TFProgramMode = class(TWIForm)
    PageControl1: TWIPageControl;
    WPApplication: TWITabSheet;
    WIPanel1: TWIPanel;
    LTurbineType: TLabel;
    PRatioLimiterMode: TWIPanel;
    LRatioLimiterMode: TLabel;
    WRatioLimiterMode: TWIEnumComboBox;
    WPStartSettings: TWITabSheet;
    WPSpeedControl: TWITabSheet;
    WPExtractionControl: TWITabSheet;
    WPAdmissionControl: TWITabSheet;
    PAdmCntrlSetpointValuesAndPIDSettings: TWIPanel;
    WPExtrAdmControl: TWITabSheet;
    PExtrAdmSetpointValuesAndPIDSettings: TWIPanel;
    WPDriverConfig: TWITabSheet;
    WPAnalogInputs: TWITabSheet;
    WPContactInputs: TWITabSheet;
    WPDCPLControl: TWITabSheet;
    PDCPLControl: TWIPanel;
    WPCascadeControl: TWITabSheet;
    WPReadouts: TWITabSheet;
    WPCommunications: TWITabSheet;
    WTurbineType: TWIEnumComboBox;
    PExtrCntrlSetpointValuesAndPIDSettings: TWIPanel;
    GExtractionControlSettings: TWIGroupBox;
    LExtrLPValveLimiterRate: TLabel;
    LExtrLPValveLimiterRateUnits: TLabel;
    LExtractionPermSpeed: TLabel;
    LExtractionPermSpeedUnits: TLabel;
    WExtrLPValveLimiterRate: TW5009SpinEdit;
    WExtractionPermSpeed: TW5009SpinEdit;
    WPRelays: TWITabSheet;
    SRelays: TWIScrollBox;
    GRelayTesting: TWIGroupBox;
    LTestFrequency: TLabel;
    WTestFrequency: TW5009SpinEdit;
    LTestFrequencyUnits: TLabel;
    GTripRelay1Settings: TWIGroupBox;
    LRelay1Test: TLabel;
    LRelay1Config: TLabel;
    WRelay1Test: TWIEnumComboBox;
    WRelay1Config: TWIEnumComboBox;
    WResetClearsTripRelayOutput: TWICheckBox;
    WUseExternalTrips: TWICheckBox;
    WTripRelayEnergizesForTrip: TWICheckBox;
    GAlarmRelay2Settings: TWIGroupBox;
    LRelay2Config: TLabel;
    LRelay2Test: TLabel;
    WRelay2Config: TWIEnumComboBox;
    WRelay2Test: TWIEnumComboBox;
    GRelay3Settings: TWIGroupBox;
    GRelay4Settings: TWIGroupBox;
    GRelay5Settings: TWIGroupBox;
    GRelay6Settings: TWIGroupBox;
    GRelay7Settings: TWIGroupBox;
    GRelay8Settings: TWIGroupBox;
    GRelay9Settings: TWIGroupBox;
    GRelay10Settings: TWIGroupBox;
    GRelay11Settings: TWIGroupBox;
    GRelay12Settings: TWIGroupBox;
    PRelay3Config: TWIPanel;
    LRelay3Test: TLabel;
    LRelay3Config: TLabel;
    WRelay3Test: TWIEnumComboBox;
    WRelay3Config: TWIEnumComboBox;
    EndOfRelay: TPanel;
    SStartSettings: TWIScrollBox;
    PStartSettings: TWIPanel;
    LStartRoutine: TLabel;
    LHPValveLimiterRateUints: TLabel;
    LHPValveLimiterRate: TLabel;
    WStartRoutine: TWIEnumComboBox;
    WHPValveLimiterRate: TW5009SpinEdit;
    PV1InitPosition: TWIPanel;
    V: TLabel;
    LV1InitPositionUnits: TLabel;
    WV1InitPosition: TW5009SpinEdit;
    PCriticalSpeed: TWIPanel;
    PUseCriticalSpeedAvoidance: TWIPanel;
    WUseCriticalSpeedAvoidance: TWICheckBox;
    PCriticalSpeedAvoidance: TWIPanel;
    EndOfStartSettings: TPanel;
    GAutoSequence: TWIGroupBox;
    PAutoSequenceHourTrippedFor: TWIPanel;
    LColdStart: TLabel;
    WColdStart: TW5009SpinEdit;
    LColdStartUints: TLabel;
    LHotStart: TLabel;
    LHotStartUints: TLabel;
    GAutoSequenceLowIdle: TWIGroupBox;
    LLowIdleSetpoint: TLabel;
    LLowIdleSetpointUints: TLabel;
    LLowIdleDelayTimeCold: TLabel;
    LLowIdleDelayTimeColdUints: TLabel;
    LLowIdleDelayTimeHot: TLabel;
    LLowIdleDelayTimeHotUints: TLabel;
    WLowIdleSetpoint: TW5009SpinEdit;
    WLowIdleDelayTimeCold: TW5009SpinEdit;
    PRelay4Config: TWIPanel;
    LRelay4Test: TLabel;
    LRelay4Config: TLabel;
    WRelay4Test: TWIEnumComboBox;
    WRelay4Config: TWIEnumComboBox;
    PRelay4LevelSW: TWIPanel;
    LRelay4OnLevel: TLabel;
    LRelay4OnLevelUnits: TLabel;
    LRelay4OffLevel: TLabel;
    LRelay4OffLevelUnits: TLabel;
    LRelay4LevelSW: TLabel;
    WRelay4OnLevel: TW5009SpinEdit;
    WRelay4OffLevel: TW5009SpinEdit;
    PRelay4Function: TWIPanel;
    LRelay4Function: TLabel;
    WRelay4Function: TWIEnumComboBox;
    PRelay4Indication: TWIPanel;
    LRelay4IndicationOf: TLabel;
    WRelay4IndicationOf: TWIEnumComboBox;
    PRelay5Config: TWIPanel;
    LRelay5Test: TLabel;
    LRelay5Config: TLabel;
    WRelay5Test: TWIEnumComboBox;
    WRelay5Config: TWIEnumComboBox;
    PRelay5LevelSW: TWIPanel;
    LRelay5OnLevel: TLabel;
    LRelay5OnLevelUnits: TLabel;
    LRelay5OffLevel: TLabel;
    LRelay5OffLevelUnits: TLabel;
    LRelay5LevelSW: TLabel;
    WRelay5OnLevel: TW5009SpinEdit;
    WRelay5OffLevel: TW5009SpinEdit;
    PRelay5Function: TWIPanel;
    LRelay5Function: TLabel;
    WRelay5Function: TWIEnumComboBox;
    PRelay5Indication: TWIPanel;
    LRelay5IndicationOf: TLabel;
    PRelay6Config: TWIPanel;
    LRelay6Test: TLabel;
    LRelay6Config: TLabel;
    WRelay6Test: TWIEnumComboBox;
    WRelay6Config: TWIEnumComboBox;
    PRelay6LevelSW: TWIPanel;
    LRelay6OnLevel: TLabel;
    LRelay6OnLevelUnits: TLabel;
    LRelay6OffLevel: TLabel;
    LRelay6OffLevelUnits: TLabel;
    LRelay6LevelSW: TLabel;
    WRelay6OnLevel: TW5009SpinEdit;
    WRelay6OffLevel: TW5009SpinEdit;
    PRelay6Function: TWIPanel;
    LRelay6Function: TLabel;
    WRelay6Function: TWIEnumComboBox;
    PRelay6Indication: TWIPanel;
    LRelay6IndicationOf: TLabel;
    PRelay7Config: TWIPanel;
    LRelay7Test: TLabel;
    LRelay7Config: TLabel;
    WRelay7Test: TWIEnumComboBox;
    WRelay7Config: TWIEnumComboBox;
    PRelay7LevelSW: TWIPanel;
    LRelay7OnLevel: TLabel;
    LRelay7OnLevelUnits: TLabel;
    LRelay7OffLevel: TLabel;
    LRelay7OffLevelUnits: TLabel;
    LRelay7LevelSW: TLabel;
    WRelay7OnLevel: TW5009SpinEdit;
    WRelay7OffLevel: TW5009SpinEdit;
    PRelay7Function: TWIPanel;
    LRelay7Function: TLabel;
    WRelay7Function: TWIEnumComboBox;
    PRelay7Indication: TWIPanel;
    LRelay7IndicationOf: TLabel;
    PRelay8Config: TWIPanel;
    LRelay8Test: TLabel;
    LRelay8Config: TLabel;
    WRelay8Test: TWIEnumComboBox;
    WRelay8Config: TWIEnumComboBox;
    PRelay8LevelSW: TWIPanel;
    LRelay8OnLevel: TLabel;
    LRelay8OnLevelUnits: TLabel;
    LRelay8OffLevel: TLabel;
    LRelay8OffLevelUnits: TLabel;
    LRelay8LevelSW: TLabel;
    WRelay8OnLevel: TW5009SpinEdit;
    WRelay8OffLevel: TW5009SpinEdit;
    PRelay8Function: TWIPanel;
    LRelay8Function: TLabel;
    WRelay8Function: TWIEnumComboBox;
    PRelay8Indication: TWIPanel;
    LRelay8IndicationOf: TLabel;
    PRelay9Config: TWIPanel;
    LRelay9Test: TLabel;
    LRelay9Config: TLabel;
    WRelay9Test: TWIEnumComboBox;
    WRelay9Config: TWIEnumComboBox;
    PRelay9LevelSW: TWIPanel;
    LRelay9OnLevel: TLabel;
    LRelay9OnLevelUnits: TLabel;
    LRelay9OffLevel: TLabel;
    LRelay9OffLevelUnits: TLabel;
    LRelay9LevelSW: TLabel;
    WRelay9OnLevel: TW5009SpinEdit;
    WRelay9OffLevel: TW5009SpinEdit;
    PRelay9Function: TWIPanel;
    LRelay9Function: TLabel;
    WRelay9Function: TWIEnumComboBox;
    PRelay9Indication: TWIPanel;
    LRelay9IndicationOf: TLabel;
    PRelay10Config: TWIPanel;
    LRelay10Test: TLabel;
    LRelay10Config: TLabel;
    WRelay10Test: TWIEnumComboBox;
    WRelay10Config: TWIEnumComboBox;
    PRelay10LevelSW: TWIPanel;
    LRelay10OnLevel: TLabel;
    LRelay10OnLevelUnits: TLabel;
    LRelay10OffLevel: TLabel;
    LRelay10OffLevelUnits: TLabel;
    LRelay10LevelSW: TLabel;
    WRelay10OnLevel: TW5009SpinEdit;
    WRelay10OffLevel: TW5009SpinEdit;
    PRelay10Function: TWIPanel;
    LRelay10Function: TLabel;
    WRelay10Function: TWIEnumComboBox;
    PRelay10Indication: TWIPanel;
    LRelay10IndicationOf: TLabel;
    PRelay11Config: TWIPanel;
    LRelay11Test: TLabel;
    LRelay11Config: TLabel;
    WRelay11Test: TWIEnumComboBox;
    WRelay11Config: TWIEnumComboBox;
    PRelay11LevelSW: TWIPanel;
    LRelay11OnLevel: TLabel;
    LRelay11OnLevelUnits: TLabel;
    LRelay11OffLevel: TLabel;
    LRelay11OffLevelUnits: TLabel;
    LRelay11LevelSW: TLabel;
    WRelay11OnLevel: TW5009SpinEdit;
    WRelay11OffLevel: TW5009SpinEdit;
    PRelay11Function: TWIPanel;
    LRelay11Function: TLabel;
    WRelay11Function: TWIEnumComboBox;
    PRelay11Indication: TWIPanel;
    LRelay11IndicationOf: TLabel;
    PRelay12Config: TWIPanel;
    LRelay12Test: TLabel;
    LRelay12Config: TLabel;
    WRelay12Test: TWIEnumComboBox;
    WRelay12Config: TWIEnumComboBox;
    PRelay12LevelSW: TWIPanel;
    LRelay12OnLevel: TLabel;
    LRelay12OnLevelUnits: TLabel;
    LRelay12OffLevel: TLabel;
    LRelay12OffLevelUnits: TLabel;
    LRelay12LevelSW: TLabel;
    WRelay12OnLevel: TW5009SpinEdit;
    WRelay12OffLevel: TW5009SpinEdit;
    PRelay12Function: TWIPanel;
    LRelay12Function: TLabel;
    WRelay12Function: TWIEnumComboBox;
    PRelay12Indication: TWIPanel;
    LRelay12IndicationOf: TLabel;
    WHotStart: TW5009SpinEdit;
    WLowIdleDelayTimeHot: TW5009SpinEdit;
    WPEnd: TWITabSheet;
    SCascadeControl: TWIScrollBox;
    GCascadeControlSettings: TWIGroupBox;
    PSetpointPIDValues: TWIPanel;
    GCascadeControlPIDSettings: TWIGroupBox;
    LCasCntrlProportionalGain: TLabel;
    LCasCntrlProportionalGainUnits: TLabel;
    LCasCntrlIntegralGainUnits: TLabel;
    LCasCntrlDerivativeRatioUnits: TLabel;
    LCasCntrlDroopUnits: TLabel;
    LCasCntrlIntegralGain: TLabel;
    LCasCntrlDroop: TLabel;
    LCasCntrlDerivativeRatio: TLabel;
    WCasCntrlProportionalGain: TW5009SpinEdit;
    WCasCntrlDroop: TW5009SpinEdit;
    WCasCntrlIntegralGain: TW5009SpinEdit;
    WCasCntrlDerivativeRatio: TW5009SpinEdit;
    WInvertCascadeInput: TWICheckBox;
    GCascadeControlSpeedSetpointValues: TWIGroupBox;
    LCasCntrlMaxSpdSetpt: TLabel;
    LCasCntrlMaxSpdSetptUnits: TLabel;
    LCasCntrlMinSpdSetptUnits: TLabel;
    LCasCntrlMinSpdSetpt: TLabel;
    WCasCntrlMaxSpdSetpt: TW5009SpinEdit;
    WCasCntrlMinSpdSetpt: TW5009SpinEdit;
    GCascadeControlSetpointValues: TWIGroupBox;
    LCasCntrlMinCascSetpt: TLabel;
    LCasCntrlMaxCascSetpt: TLabel;
    LCasCntrlSetpointRate: TLabel;
    WCasCntrlMinCascSetpt: TW5009SpinEdit;
    WCasCntrlMaxCascSetpt: TW5009SpinEdit;
    WCasCntrlSetpointRate: TW5009SpinEdit;
    WUseRemoteCascadeSetpoint: TWICheckBox;
    WCasCntrlUseSetpointTracking: TWICheckBox;
    PCasCntrlRmtSetptMaxRate: TWIPanel;
    LCasCntrlRmtSetptMaxRate: TLabel;
    WCasCntrlRmtSetptMaxRate: TW5009SpinEdit;
    WIScrollBox1: TWIScrollBox;
    GSpdCntrlSpeedSensorSettings: TWIGroupBox;
    LTeethSeenBySppedProbe: TLabel;
    LSpeedProbeGearRatio: TLabel;
    LSpeedInput1: TLabel;
    LSpeedInput2: TLabel;
    LSpeedInput3: TLabel;
    WTeethSeenBySppedProbe: TW5009SpinEdit;
    WSpeedProbeGearRatio: TW5009SpinEdit;
    WSpeedInput3: TWIEnumComboBox;
    WSpeedInput2: TWIEnumComboBox;
    WSpeedInput1: TWIEnumComboBox;
    WIPanel3: TWIPanel;
    GSpdCntrlSetpointValues: TWIGroupBox;
    LOverspeedTestLimit: TLabel;
    LOverspeedTestLimitUnits: TLabel;
    LOverspeedTripLevelUints: TLabel;
    LMaxControlSetptUints: TLabel;
    LMinControlSetptUints: TLabel;
    LMinControlSetpt: TLabel;
    LMaxControlSetpt: TLabel;
    LOverspeedTripLevel: TLabel;
    WOverspeedTestLimit: TW5009SpinEdit;
    WSpdCntrlUseRemoteSpeedSetpoint: TWICheckBox;
    WOverspeedTripLevel: TW5009SpinEdit;
    WMaxControlSetpt: TW5009SpinEdit;
    WMinControlSetpt: TW5009SpinEdit;
    EndOfSpeedControl: TPanel;
    WPExtractionSteamMap: TWITabSheet;
    WPAdmissionSteamMap: TWITabSheet;
    WPExtrAdmSteamMap: TWITabSheet;
    PExtrCntrlSteamMapDataSettings: TWIPanel;
    GExtrCntrlMaximumValues: TWIGroupBox;
    LExtrCntrlMaxPower: TLabel;
    LExtrCntrlMaxPowerUnits: TLabel;
    LExtrCntrlMaxHPFlow: TLabel;
    LExtrCntrlMaxHPFlowUnits: TLabel;
    WExtrCntrlMaxPower: TW5009SpinEdit;
    WExtrCntrlMaxHPFlow: TW5009SpinEdit;
    GExtrCntrlPointBValues: TWIGroupBox;
    LExtrContrlMinPowerAtMaxExtr: TLabel;
    LExtrContrlMinPowerAtMaxExtrUnits: TLabel;
    LExtrCntrlMinHPFlowAtMaxExtr: TLabel;
    LExtrCntrlMinHPFlowAtMaxExtrUnits: TLabel;
    WExtrContrlMinPowerAtMaxExtr: TW5009SpinEdit;
    WExtrCntrlMinHPFlowAtMaxExtr: TW5009SpinEdit;
    GExtrCntrlPointCValues: TWIGroupBox;
    LExtrContrlMinPowerAtMinExtr: TLabel;
    LExtrContrlMinPowerAtMinExtrUnits: TLabel;
    LExtrCntrlMinHPFlowAtMinExtr: TLabel;
    LExtrCntrlMinHPFlowAtMinExtrUnits: TLabel;
    WExtrContrlMinPowerAtMinExtr: TW5009SpinEdit;
    WExtrCntrlMinHPFlowAtMinExtr: TW5009SpinEdit;
    GExtrCntrlPointAValues: TWIGroupBox;
    LExtrContrlMaxPowerAtMinExtr: TLabel;
    LExtrContrlMaxPowerAtMinExtrUnits: TLabel;
    LExtrCntrlMaxHPFlowAtMinExtr: TLabel;
    LExtrCntrlMaxHPFlowAtMinExtrUnits: TLabel;
    WExtrContrlMaxPowerAtMinExtr: TW5009SpinEdit;
    WExtrCntrlMaxHPFlowAtMinExtr: TW5009SpinEdit;
    WIPanel4: TWIPanel;
    GExtrCntrlSetpointValues: TWIGroupBox;
    LExtrCntrlMinSetpoint: TLabel;
    LExtrCntrlMaxSetpoint: TLabel;
    LExtrCntrlSetpointRate: TLabel;
    LExtrCntrlSetptInitValue: TLabel;
    WExtrCntrlMinSetpoint: TW5009SpinEdit;
    WExtrCntrlMaxSetpoint: TW5009SpinEdit;
    WExtrCntrlSetpointRate: TW5009SpinEdit;
    WExtrCntrlSetptInitValue: TW5009SpinEdit;
    WExtrCntrlUseRemoteSetpoint: TWICheckBox;
    GExtrCntrlPIDSetting: TWIGroupBox;
    LExtrCntrlProportionalGain: TLabel;
    LExtrCntrlProportionalGainUnits: TLabel;
    LExtrCntrlIntegralGain: TLabel;
    LExtrCntrlIntegralGainUnits: TLabel;
    LExtrCntrlDerivativeRatio: TLabel;
    LExtrCntrlDerivativeRatioUnits: TLabel;
    LExtrCntrlDroop: TLabel;
    LExtrCntrlDroopUnits: TLabel;
    WExtrCntrlProportionalGain: TW5009SpinEdit;
    WExtrCntrlIntegralGain: TW5009SpinEdit;
    WExtrCntrlDerivativeRatio: TW5009SpinEdit;
    WExtrCntrlDroop: TW5009SpinEdit;
    WInvertExtractionInput: TWICheckBox;
    PAdmCntrlSteamMapDataSettings: TWIPanel;
    GAdmCntrlPointCValues: TWIGroupBox;
    LMaxPowerAtMinAdmission: TLabel;
    LMaxPowerAtMinAdmissionUnits: TLabel;
    LMaxHPFlowAtMinAdmission: TLabel;
    LMaxHPFlowAtMinAdmissionUnits: TLabel;
    WMaxPowerAtMinAdmission: TW5009SpinEdit;
    WMaxHPFlowAtMinAdmission: TW5009SpinEdit;
    GAdmCntrlPointBValues: TWIGroupBox;
    LMinPowerAtMinAdmission: TLabel;
    LMinPowerAtMinAdmissionUnits: TLabel;
    LMinHPFlowAtMinAdmission: TLabel;
    LMinHPFlowAtMinAdmissionUnits: TLabel;
    WMinPowerAtMinAdmission: TW5009SpinEdit;
    WMinHPFlowAtMinAdmission: TW5009SpinEdit;
    GAdmCntrlPointAValues: TWIGroupBox;
    LMaxPowerAtMaxAdmission: TLabel;
    LMaxPowerAtMaxAdmissionUnits: TLabel;
    LMaxHPFlowAtMaxAdmission: TLabel;
    LMaxHPFlowAtMaxAdmissionUnits: TLabel;
    WMaxPowerAtMaxAdmission: TW5009SpinEdit;
    WMaxHPFlowAtMaxAdmission: TW5009SpinEdit;
    WIGroupBox3: TWIGroupBox;
    LAdmCntrlMaximumPower: TLabel;
    LAdmCntrlMaximumPowerUnits: TLabel;
    LAdmCntrlMaximumHPFlow: TLabel;
    LAdmCntrlMaximumHPFlowUnits: TLabel;
    WAdmCntrlMaximumPower: TW5009SpinEdit;
    WAdmCntrlMaximumHPFlow: TW5009SpinEdit;
    PExtrAdmSteamMapDataSettings: TWIPanel;
    GExtrAdmPointCValues: TWIGroupBox;
    LExtrAdmMinPowerAt0ExtrAdm: TLabel;
    LExtrAdmMinPowerAt0ExtrAdmUnits: TLabel;
    LExtrAdmMinHPFlowAt0ExtrAdm: TLabel;
    LExtrAdmMinHPFlowAt0ExtrAdmUnits: TLabel;
    WExtrAdmMinPowerAt0ExtrAdm: TW5009SpinEdit;
    WExtrAdmMinHPFlowAt0ExtrAdm: TW5009SpinEdit;
    GExtrAdmPointBValues: TWIGroupBox;
    LExtrAdmMinPowerAtMaxExtr: TLabel;
    LExtrAdmMinPowerAtMaxExtrUnits: TLabel;
    LExtrAdmMinHPFlowAtMaxExtr: TLabel;
    LExtrAdmMinHPFlowAtMaxExtrUnits: TLabel;
    WExtrAdmMinPowerAtMaxExtr: TW5009SpinEdit;
    WExtrAdmMinHPFlowAtMaxExtr: TW5009SpinEdit;
    GExtrAdmPointAValues: TWIGroupBox;
    LExtrAdmMaxPowerAt0ExtrAdm: TLabel;
    LExtrAdmMaxPowerAt0ExtrAdmUnits: TLabel;
    LExtrAdmMaxHPFlowAt0ExtrAdm: TLabel;
    LExtrAdmMaxHPFlowAt0ExtrAdmUnits: TLabel;
    WExtrAdmMaxPowerAt0ExtrAdm: TW5009SpinEdit;
    WExtrAdmMaxHPFlowAt0ExtrAdm: TW5009SpinEdit;
    GExtrAdmMaximumValues: TWIGroupBox;
    LExtrAdmMaxPower: TLabel;
    LExtrAdmMaxPowerUnits: TLabel;
    LExtrAdmMaxHPFlow: TLabel;
    LExtrAdmMaxHPFlowUnits: TLabel;
    LExtrAdmMaxAdmFlow: TLabel;
    LExtrAdmMaxAdmFlowUnits: TLabel;
    WExtrAdmMaxPower: TW5009SpinEdit;
    WExtrAdmMaxHPFlow: TW5009SpinEdit;
    WExtrAdmMaxAdmFlow: TW5009SpinEdit;
    WSDriverConfigLinkToTurbineType: TWIItemSpy;
    WExtrCntrlUseSetpointTracking: TWICheckBox;
    PApplication3: TWIPanel;
    WICheckBox137: TWICheckBox;
    WICheckBox1: TWICheckBox;
    WICheckBox2: TWICheckBox;
    WCommunicationsScroll: TWIScrollBox;
    GComPort1Settings: TWIGroupBox;
    Label1: TLabel;
    PComPort1ModbusSettings: TWIPanel;
    LComPort1BaudRate: TLabel;
    LComPort1Parity: TLabel;
    LComPort1StopBits: TLabel;
    WComPort1BaudRate: TWIEnumComboBox;
    WComPort1StopBits: TWIEnumComboBox;
    WComPort1Parity: TWIEnumComboBox;
    PComPort1Type: TWIPanel;
    LComPort1Type: TLabel;
    WComPort1Type: TWIEnumComboBox;
    GComPort2Settings: TWIGroupBox;
    PComPrt2printer: TWIPanel;
    LComPort2BaudRate: TLabel;
    LComPort2Parity: TLabel;
    LComPort2StopBits: TLabel;
    WComPort2BaudRate: TWIEnumComboBox;
    WComPort2StopBits: TWIEnumComboBox;
    WComPort2Parity: TWIEnumComboBox;
    PComPort2Type: TWIPanel;
    LComPort2Type: TLabel;
    WComPort2Type: TWIEnumComboBox;
    WPCIToRevertToPortBOnPortCFault: TWICheckBox;
    WIGroupBox1: TWIGroupBox;
    WICheckBox3: TWICheckBox;
    LServiceModeChange: TLabel;
    LProgrammingChange: TLabel;
    LFileSaveDate: TLabel;
    LFileName: TLabel;
    WFileName: TWILabel;
    WFileSaveDate: TWILabel;
    WProgrammingChange: TWILabel;
    WServiceModeChange: TWILabel;
    ExitProgramModeButton: TBitBtn;
    SaveButton: TBitBtn;
    LoadButton: TBitBtn;
    LOSVersionDate: TLabel;
    LAppFilenameDate: TLabel;
    WAppFilenameDate: TWILabel;
    WOSVersionDate: TWILabel;
    SAnalogInputs: TWIScrollBox;
    PAnalogInputs2: TWIPanel;
    GAnalogInput7: TWIGroupBox;
    PAnalogInput7Values: TWIPanel;
    GAnalogInput8: TWIGroupBox;
    PAnalogInput8Values: TWIPanel;
    GAnalogInput6: TWIGroupBox;
    GAnalogInput5: TWIGroupBox;
    PAnalogInput5Values: TWIPanel;
    PAnalogInputs1: TWIPanel;
    GAnalogInput1: TWIGroupBox;
    PAnalogInput1Values: TWIPanel;
    GAnalogInput2: TWIGroupBox;
    PAnalogInput2Values: TWIPanel;
    GAnalogInput3: TWIGroupBox;
    PAnalogInput3Values: TWIPanel;
    GAnalogInput4: TWIGroupBox;
    PAnalogInput4Values: TWIPanel;
    LInput4PwrCnfg: TLabel;
    WIAnalogInput4PwrOption: TWIEnumComboBox;
    PAnalogInput6Values: TWIPanel;
    EndOfAnalogIn: TPanel;
    WIAnalogInput2PwrOption: TWIEnumComboBox;
    WIAnalogInput3PwrOption: TWIEnumComboBox;
    WIAnalogInput6PwrOption: TWIEnumComboBox;
    WIAnalogInput7PwrOption: TWIEnumComboBox;
    WIAnalogInput8PwrOption: TWIEnumComboBox;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label11: TLabel;
    Label14: TLabel;
    WIAnalogInput1PwrOption: TWIEnumComboBox;
    WIAnalogInput5PwrOption: TWIEnumComboBox;
    ScrollContctIn: TWIScrollBox;
    GContactInputs: TWIGroupBox;
    LContactInput1: TLabel;
    LContactInput2: TLabel;
    LContactInput3: TLabel;
    LContactInput4: TLabel;
    LContactInput5: TLabel;
    LContactInput6: TLabel;
    LContactInput7: TLabel;
    LContactInput8: TLabel;
    LContactInput9: TLabel;
    LContactInput10: TLabel;
    LContactInput11: TLabel;
    LContactInput12: TLabel;
    LContactInput17: TLabel;
    LContactInput16: TLabel;
    LContactInput15: TLabel;
    LContactInput14: TLabel;
    LContactInput13: TLabel;
    LContactInput18: TLabel;
    LContactInput19: TLabel;
    LContactInput20: TLabel;
    LContactInput21: TLabel;
    LContactInput22: TLabel;
    LContactInput23: TLabel;
    LContactInput24: TLabel;
    WContactInput8: TWIEnumComboBox;
    TContactInput1: TEdit;
    TContactInput2: TEdit;
    TContactInput3: TEdit;
    TContactInput4: TEdit;
    GContactPowerCnfg: TWIGroupBox;
    LContactInputPower: TLabel;
    WContactIn13Power: TWIEnumComboBox;
    EndOfContctIn: TPanel;
    WContactIn46Power: TWIEnumComboBox;
    WContactIn79Power: TWIEnumComboBox;
    WContactIn1315Power: TWIEnumComboBox;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    WContactIn1618Power: TWIEnumComboBox;
    WContactIn1012Power: TWIEnumComboBox;
    WContactIn1921Power: TWIEnumComboBox;
    WContactIn2224Power: TWIEnumComboBox;
    Label18: TLabel;
    Label19: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    WISIOB4disa: TWICheckBox;
    M1GEN: TWIGroupBox;
    LComDriver1Type: TLabel;
    LComPort1DeviceType: TLabel;
    WComDriver1Type: TWIEnumComboBox;
    WComPort1DeviceType: TW5009SpinEdit;
    printer: TWIGroupBox;
    PComPort2PrinterSettings: TWIPanel;
    LComPort2EndLineCharater: TLabel;
    LComPort2IgnoreCR: TLabel;
    LComPort2Flow: TLabel;
    LComPort2Echo: TLabel;
    LComPort2DataBits: TLabel;
    Label5: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    WPtrPort2Baud: TWIEnumComboBox;
    WPtrPort2DataBits: TWIEnumComboBox;
    WPtrPort2StopBits: TWIEnumComboBox;
    WPtrPort2Parity: TWIEnumComboBox;
    WPtrPort2Echo: TWIEnumComboBox;
    WPtrPort2Flow: TWIEnumComboBox;
    WPtrPort2EndLineCharacter: TWIEnumComboBox;
    WPtrPort2IgnoreCR: TWIEnumComboBox;
    WISpySIOBserv: TWIItemSpy;
    WISpySIOAserv: TWIItemSpy;
    commsiobname: TLabel;
    RSSIO4B: TWIEnumComboBox;
    RSSIO3A: TWIEnumComboBox;
    commsioaname: TLabel;
    WPSIOCOM: TWITabSheet;
    M2SET_R: TWIGroupBox;
    Label22: TLabel;
    Label23: TLabel;
    WComDriver2Type: TWIEnumComboBox;
    WComPort2DeviceType: TW5009SpinEdit;
    WISIOACH4: TWIGroupBox;
    Label24: TLabel;
    WISIOAP4: TWIPanel;
    Label25: TLabel;
    Label26: TLabel;
    Label27: TLabel;
    WComM2_1BaudRate: TWIEnumComboBox;
    WComM2_1stopbit: TWIEnumComboBox;
    WComM2_1parity: TWIEnumComboBox;
    WIPanel8: TWIPanel;
    Label29: TLabel;
    WSIOAPort4Type: TWIEnumComboBox;
    WISIOBCH4: TWIGroupBox;
    WISIOBP4: TWIPanel;
    Label30: TLabel;
    Label31: TLabel;
    Label32: TLabel;
    WComM2_2BaudRate: TWIEnumComboBox;
    WComM2_2stopbit: TWIEnumComboBox;
    WComM2_2parity: TWIEnumComboBox;
    WIPanel10: TWIPanel;
    WSIOBPort4Type: TWIEnumComboBox;
    Label34: TLabel;
    M2GEN: TWIGroupBox;
    Label28: TLabel;
    Label33: TLabel;
    WIEnumComboBox3: TWIEnumComboBox;
    W5009SpinEdit1: TW5009SpinEdit;
    M1SET_R: TWIGroupBox;
    Label35: TLabel;
    Label36: TLabel;
    WIEnumComboBox4: TWIEnumComboBox;
    W5009SpinEdit2: TW5009SpinEdit;
    RSSIO3B: TWIEnumComboBox;
    Label37: TLabel;
    RSSIO4A: TWIEnumComboBox;
    Label38: TLabel;
    CPUAbypass: TLabel;
    CPUBbypass: TLabel;
    EndofCommunicationpage: TPanel;
    EndofSIOcommunication: TPanel;
    WItype: TWIItemSpy;
    SAN: TWIBoxLabel;
    HAN: TWIBoxLabel;
    Label52: TLabel;
    Label53: TLabel;
    WIBoxLabel1: TWIBoxLabel;
    WIBoxLabel2: TWIBoxLabel;
    WIBoxLabel3: TWIBoxLabel;
    WIBoxLabel4: TWIBoxLabel;
    Label54: TLabel;
    Label55: TLabel;
    Label60: TLabel;
    Label61: TLabel;
    ADSAN: TWIBoxLabel;
    ADSbN: TWIBoxLabel;
    ADSCN: TWIBoxLabel;
    ADHAN: TWIBoxLabel;
    ADHBN: TWIBoxLabel;
    ADHCN: TWIBoxLabel;
    Label62: TLabel;
    Label63: TLabel;
    Label64: TLabel;
    Label65: TLabel;
    Label66: TLabel;
    Label67: TLabel;
    EXADSAN: TWIBoxLabel;
    EXADSBN: TWIBoxLabel;
    EXADSCN: TWIBoxLabel;
    EXADHAN: TWIBoxLabel;
    EXADHBN: TWIBoxLabel;
    EXADHCN: TWIBoxLabel;
    Label68: TLabel;
    Label69: TLabel;
    Label70: TLabel;
    Label71: TLabel;
    Label72: TLabel;
    Label73: TLabel;
    WIbypassextr: TWICheckBox;
    TContactInput5: TEdit;
    TContactInput6: TEdit;
    TContactInput7: TEdit;
    WUseNonLatchingAlarmIndication: TWICheckBox;
    WIstickyrotor: TWICheckBox;
    GCriticalSpeedAvoidanceBand1: TWIGroupBox;
    LBand1Minimum: TLabel;
    LBand1MinimumUints: TLabel;
    LBand1MaximumUints: TLabel;
    LBand1Maximum: TLabel;
    WBand1Minimum: TW5009SpinEdit;
    WBand1Maximum: TW5009SpinEdit;
    WCriticalRate: TW5009SpinEdit;
    LCriticalRate: TLabel;
    LCriticalRateUnits: TLabel;
    WUseCriticalSpeedAvoidanceBand2: TWICheckBox;
    WIfixerate1: TWICheckBox;
    GCriticalSpeedAvoidanceBand2: TWIGroupBox;
    LBand2Minimum: TLabel;
    LBand2Maximum: TLabel;
    LBand2MaximumUints: TLabel;
    LBand2MinimumUints: TLabel;
    LCriticalRateUnits2: TLabel;
    LCriticalRate2: TLabel;
    WBand2Minimum: TW5009SpinEdit;
    WBand2Maximum: TW5009SpinEdit;
    WCriticalRate2: TW5009SpinEdit;
    WIfixerate2: TWICheckBox;
    WIminhighcritical: TWICheckBox;
    WIlowildrate: TWIGroupBox;
    Label41: TLabel;
    Label42: TLabel;
    Label43: TLabel;
    Label44: TLabel;
    Wratelowcold: TW5009SpinEdit;
    Wratelowhot: TW5009SpinEdit;
    GAutoSequenceathhidle: TWIGroupBox;
    Label45: TLabel;
    Label46: TLabel;
    Label47: TLabel;
    Label48: TLabel;
    Label49: TLabel;
    Label50: TLabel;
    WhhighIdleDelayTimeCold: TW5009SpinEdit;
    WhhighIdleSetpoint: TW5009SpinEdit;
    WhhighIdleDelayTimehot: TW5009SpinEdit;
    GAutoSequencegotohilde: TWIGroupBox;
    Label51: TLabel;
    Label56: TLabel;
    Label57: TLabel;
    Label58: TLabel;
    WHighIdleToRatedRatecold: TW5009SpinEdit;
    WHighIdleToRatedRateHot: TW5009SpinEdit;
    WIGAutoSequenceathilde: TWIGroupBox;
    Label59: TLabel;
    Label74: TLabel;
    Label75: TLabel;
    Label76: TLabel;
    Label77: TLabel;
    Label78: TLabel;
    WhighIdleDelayTimeCold: TW5009SpinEdit;
    WhighIdleSetpoint: TW5009SpinEdit;
    WhighIdleDelayTimehot: TW5009SpinEdit;
    GAutoSequencegotohhidle: TWIGroupBox;
    Label79: TLabel;
    Label80: TLabel;
    Label81: TLabel;
    Label82: TLabel;
    W5009SpinEdit13: TW5009SpinEdit;
    W5009SpinEdit14: TW5009SpinEdit;
    WIremtimer: TWIGroupBox;
    minmatimer: TLabel;
    Wremhot4ma: TW5009SpinEdit;
    WWremhot20ma: TW5009SpinEdit;
    maxmatimer: TLabel;
    remotetimerrange: TLabel;
    Wcoldlevel: TW5009SpinEdit;
    Whotlevel: TW5009SpinEdit;
    Label39: TLabel;
    Label40: TLabel;
    lecelrem: TLabel;
    Whotspeed: TW5009SpinEdit;
    Whottime: TW5009SpinEdit;
    Wuseremhotcold: TWICheckBox;
    Label83: TLabel;
    Label84: TLabel;
    Label85: TLabel;
    Label86: TLabel;
    WIatrated: TWIGroupBox;
    Label88: TLabel;
    Wrated: TW5009SpinEdit;
    GAutoSequencegotorated: TWIGroupBox;
    Label91: TLabel;
    Label92: TLabel;
    Label93: TLabel;
    Label94: TLabel;
    W5009SpinEdit5: TW5009SpinEdit;
    W5009SpinEdit6: TW5009SpinEdit;
    Wusehidle: TWICheckBox;
    Wusehhidle: TWICheckBox;
    Wdcpl: TWIItemSpy;
    Wnulllspeed: TWIGroupBox;
    Label98: TLabel;
    WSpeedInput4: TWIEnumComboBox;
    Lmaxnull: TLabel;
    Lwarningnullspeed: TLabel;
    Wmaxnullspeed: TW5009SpinEdit;
    Wstuck: TWICheckBox;
    Wdeltaspeed: TW5009SpinEdit;
    Label96: TLabel;
    Lrpm: TLabel;
    Label97: TLabel;
    Wdiffarmdly: TW5009SpinEdit;
    Lseconds: TLabel;
    Wlosstrip: TWICheckBox;
    GSpdCntrlPIDSettings: TWIGroupBox;
    LOffLinePropGainUints: TLabel;
    LOffLinePropGain: TLabel;
    LOnLinePropGain: TLabel;
    LOnLinePropGainUints: TLabel;
    LOffLineIntegralGain: TLabel;
    LOffLineIntegralGainUints: TLabel;
    LOnLineIntGain: TLabel;
    LOnLineIntGainUints: TLabel;
    LOffLineDerivRatio: TLabel;
    LOffLineDerivRatioUints: TLabel;
    LOnLineDerivRatio: TLabel;
    LOnLineDerivRatioUints: TLabel;
    Lspeeddb: TLabel;
    Lunitdb: TLabel;
    WOffLinePropGain: TW5009SpinEdit;
    WOnLinePropGain: TW5009SpinEdit;
    WOffLineIntegralGain: TW5009SpinEdit;
    WOnLineIntGain: TW5009SpinEdit;
    WOffLineDerivRatio: TW5009SpinEdit;
    WOnLineDerivRatio: TW5009SpinEdit;
    Wspeeddb: TW5009SpinEdit;
    Wusedeadband: TWICheckBox;
    Wdbdcpl: TWICheckBox;
    WIunderspeed: TWIGroupBox;
    Lunderspeed: TLabel;
    Lunderalmdly: TLabel;
    WIuseunderspeed: TWICheckBox;
    Wunderspeed: TW5009SpinEdit;
    Walmunder: TW5009SpinEdit;
    Wuseundertrip: TWICheckBox;
    W5undertrip: TW5009SpinEdit;
    Ltripunder: TLabel;
    Lrpm2: TLabel;
    Lseconds2: TLabel;
    Lseconds3: TLabel;
    wholdspeed: TWICheckBox;
    Wloadgradient: TWIGroupBox;
    Label87: TLabel;
    Label89: TLabel;
    Label90: TLabel;
    Label95: TLabel;
    W5009SpinEdit4: TW5009SpinEdit;
    W5009SpinEdit7: TW5009SpinEdit;
    Wdlyon: TW5009SpinEdit;
    Ldlyzero: TLabel;
    Lseconds4: TLabel;
    Wnullofflevel: TW5009SpinEdit;
    Lrpm5: TLabel;
    Lnullof: TLabel;
    WCasCntrlUnits: TWIEnumComboBox;
    LCasCntrlUnits: TLabel;
    Wcasusage: TWIEnumComboBox;
    Lcasusage: TLabel;
    Wcas4: TW5009SpinEdit;
    Wcas20: TW5009SpinEdit;
    Label99: TLabel;
    Label100: TLabel;
    Label101: TLabel;
    Lunitscas2: TLabel;
    Lunitscas3: TLabel;
    Lwarningcas: TLabel;
    WCasCntrlSetptInitValue: TW5009SpinEdit;
    LCasCntrlSetptInitValue: TLabel;
    Label102: TLabel;
    Label103: TLabel;
    W5009SpinEdit8: TW5009SpinEdit;
    Lcasratemul: TLabel;
    Wcasfstdly: TW5009SpinEdit;
    Lfstcassp: TLabel;
    Lfstdly: TLabel;
    Lremcassensor: TLabel;
    Wremcas4: TW5009SpinEdit;
    Wremcas20: TW5009SpinEdit;
    Lrencas4: TLabel;
    Lremcas20: TLabel;
    Wcasdb: TW5009SpinEdit;
    Lcasdb: TLabel;
    Lcasdbunits: TLabel;
    Wcasfwdroop: TW5009SpinEdit;
    Lcadbfw: TLabel;
    Label104: TLabel;
    Lrancasfwdb: TLabel;
    Wnofw: TWIItemSpy;
    Lwarningcasspeed: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    WAnalogInput1Option: TWIEnumComboBox;
    WRelay4LevelSW: TWIEnumComboBox;
    WIScrollBox2: TWIScrollBox;
    endofdriver: TPanel;
    WIHP: TWIGroupBox;
    WHPact1: TWIGroupBox;
    WIHP1range: TWIEnumComboBox;
    LHPrange: TLabel;
    WIhptype: TWIEnumComboBox;
    LHPtype: TLabel;
    Whp420: TWIPanel;
    Whpmax: TW5009SpinEdit;
    Whpmin: TW5009SpinEdit;
    Lhpmin: TLabel;
    Lhpmax: TLabel;
    Label105: TLabel;
    Label106: TLabel;
    Whp20160: TWIPanel;
    Label107: TLabel;
    Label108: TLabel;
    Label109: TLabel;
    Label110: TLabel;
    W5009SpinEdit9: TW5009SpinEdit;
    W5009SpinEdit10: TW5009SpinEdit;
    Whpdith: TW5009SpinEdit;
    Label111: TLabel;
    WICheckBox4: TWICheckBox;
    WHPact2: TWIGroupBox;
    Label112: TLabel;
    Label113: TLabel;
    Label114: TLabel;
    WIHP2range: TWIEnumComboBox;
    WIhp2type: TWIEnumComboBox;
    Whp4202: TWIPanel;
    Label115: TLabel;
    Label116: TLabel;
    Label117: TLabel;
    Label118: TLabel;
    W5009SpinEdit11: TW5009SpinEdit;
    W5009SpinEdit12: TW5009SpinEdit;
    Whp201602: TWIPanel;
    Label119: TLabel;
    Label120: TLabel;
    Label121: TLabel;
    Label122: TLabel;
    W5009SpinEdit15: TW5009SpinEdit;
    W5009SpinEdit16: TW5009SpinEdit;
    Whpdith2: TW5009SpinEdit;
    WICheckBox5: TWICheckBox;
    WHPact2fdbk: TWIGroupBox;
    WIhp2fdbktype: TWIGroupBox;
    WIGroupBox7: TWIGroupBox;
    Wtypehp2: TWIGroupBox;
    Label172: TLabel;
    Label173: TLabel;
    Label174: TLabel;
    Whhdfbktypehp2: TWIEnumComboBox;
    WIEnumComboBox16: TWIEnumComboBox;
    W5009SpinEdit42: TW5009SpinEdit;
    wlvdthp2A: TWIGroupBox;
    Label175: TLabel;
    WIEnumComboBox17: TWIEnumComboBox;
    pidsettingshp2: TWIGroupBox;
    WProphp2: TWIGroupBox;
    Label179: TLabel;
    Label180: TLabel;
    Label181: TLabel;
    Label182: TLabel;
    Label183: TLabel;
    W5009SpinEdit43: TW5009SpinEdit;
    W5009SpinEdit44: TW5009SpinEdit;
    W5009SpinEdit45: TW5009SpinEdit;
    WICheckBox12: TWICheckBox;
    WICheckBox13: TWICheckBox;
    WPIhp2: TWIGroupBox;
    Label184: TLabel;
    Label185: TLabel;
    Label186: TLabel;
    Label187: TLabel;
    Label188: TLabel;
    Label189: TLabel;
    Label190: TLabel;
    Label191: TLabel;
    W5009SpinEdit46: TW5009SpinEdit;
    W5009SpinEdit47: TW5009SpinEdit;
    W5009SpinEdit48: TW5009SpinEdit;
    WICheckBox14: TWICheckBox;
    W5009SpinEdit49: TW5009SpinEdit;
    W5009SpinEdit50: TW5009SpinEdit;
    WIEnumComboBox21: TWIEnumComboBox;
    wphp2: TWIGroupBox;
    Label192: TLabel;
    Label193: TLabel;
    Label194: TLabel;
    Label195: TLabel;
    Label196: TLabel;
    Label197: TLabel;
    Label198: TLabel;
    W5009SpinEdit51: TW5009SpinEdit;
    W5009SpinEdit52: TW5009SpinEdit;
    W5009SpinEdit53: TW5009SpinEdit;
    WICheckBox15: TWICheckBox;
    W5009SpinEdit54: TW5009SpinEdit;
    WIEnumComboBox22: TWIEnumComboBox;
    WPILEADhp2LAG: TWIGroupBox;
    Label199: TLabel;
    Label200: TLabel;
    Label201: TLabel;
    Label202: TLabel;
    Label203: TLabel;
    Label204: TLabel;
    Label205: TLabel;
    Label206: TLabel;
    Label207: TLabel;
    Label208: TLabel;
    Label209: TLabel;
    Label210: TLabel;
    W5009SpinEdit55: TW5009SpinEdit;
    W5009SpinEdit56: TW5009SpinEdit;
    W5009SpinEdit57: TW5009SpinEdit;
    WICheckBox16: TWICheckBox;
    W5009SpinEdit58: TW5009SpinEdit;
    W5009SpinEdit59: TW5009SpinEdit;
    WIEnumComboBox23: TWIEnumComboBox;
    W5009SpinEdit60: TW5009SpinEdit;
    W5009SpinEdit61: TW5009SpinEdit;
    WPILLAGhp2: TWIGroupBox;
    Label211: TLabel;
    Label212: TLabel;
    Label213: TLabel;
    Label214: TLabel;
    Label215: TLabel;
    Label216: TLabel;
    Label217: TLabel;
    Label218: TLabel;
    Label219: TLabel;
    Label220: TLabel;
    W5009SpinEdit62: TW5009SpinEdit;
    W5009SpinEdit63: TW5009SpinEdit;
    W5009SpinEdit64: TW5009SpinEdit;
    WICheckBox17: TWICheckBox;
    W5009SpinEdit65: TW5009SpinEdit;
    W5009SpinEdit66: TW5009SpinEdit;
    WIEnumComboBox24: TWIEnumComboBox;
    W5009SpinEdit67: TW5009SpinEdit;
    WHPact1fdbk: TWIGroupBox;
    WIhpfdbktype: TWIGroupBox;
    WIGroupBox4: TWIGroupBox;
    Wtypehp: TWIGroupBox;
    Label128: TLabel;
    Label129: TLabel;
    Label130: TLabel;
    Whhdfbktype: TWIEnumComboBox;
    WIEnumComboBox5: TWIEnumComboBox;
    WHPexcitation: TW5009SpinEdit;
    wlvdthp1A: TWIGroupBox;
    Label168: TLabel;
    WIEnumComboBox6: TWIEnumComboBox;
    pidsettingshp: TWIGroupBox;
    WIprop: TWIGroupBox;
    Label123: TLabel;
    Label125: TLabel;
    Label126: TLabel;
    Label124: TLabel;
    Label127: TLabel;
    W5009SpinEdit17: TW5009SpinEdit;
    W5009SpinEdit18: TW5009SpinEdit;
    W5009SpinEdit19: TW5009SpinEdit;
    WICheckBox6: TWICheckBox;
    WICheckBox7: TWICheckBox;
    WIPI: TWIGroupBox;
    Label131: TLabel;
    Label132: TLabel;
    Label133: TLabel;
    Label134: TLabel;
    Label135: TLabel;
    Label136: TLabel;
    Label137: TLabel;
    Label138: TLabel;
    W5009SpinEdit20: TW5009SpinEdit;
    W5009SpinEdit21: TW5009SpinEdit;
    W5009SpinEdit22: TW5009SpinEdit;
    WICheckBox9: TWICheckBox;
    W5009SpinEdit23: TW5009SpinEdit;
    W5009SpinEdit24: TW5009SpinEdit;
    WIEnumComboBox10: TWIEnumComboBox;
    WIP: TWIGroupBox;
    Label139: TLabel;
    Label140: TLabel;
    Label141: TLabel;
    Label142: TLabel;
    Label143: TLabel;
    Label145: TLabel;
    Label146: TLabel;
    W5009SpinEdit25: TW5009SpinEdit;
    W5009SpinEdit26: TW5009SpinEdit;
    W5009SpinEdit27: TW5009SpinEdit;
    WICheckBox8: TWICheckBox;
    W5009SpinEdit29: TW5009SpinEdit;
    WIEnumComboBox11: TWIEnumComboBox;
    WPILEADLAG: TWIGroupBox;
    Label144: TLabel;
    Label147: TLabel;
    Label148: TLabel;
    Label149: TLabel;
    Label150: TLabel;
    Label151: TLabel;
    Label152: TLabel;
    Label153: TLabel;
    Label163: TLabel;
    Label164: TLabel;
    Label165: TLabel;
    Label166: TLabel;
    W5009SpinEdit28: TW5009SpinEdit;
    W5009SpinEdit30: TW5009SpinEdit;
    W5009SpinEdit31: TW5009SpinEdit;
    WICheckBox10: TWICheckBox;
    W5009SpinEdit32: TW5009SpinEdit;
    W5009SpinEdit33: TW5009SpinEdit;
    WIEnumComboBox12: TWIEnumComboBox;
    W5009SpinEdit40: TW5009SpinEdit;
    W5009SpinEdit41: TW5009SpinEdit;
    WPILAG: TWIGroupBox;
    Label154: TLabel;
    Label155: TLabel;
    Label156: TLabel;
    Label157: TLabel;
    Label158: TLabel;
    Label159: TLabel;
    Label160: TLabel;
    Label161: TLabel;
    Label162: TLabel;
    Label167: TLabel;
    W5009SpinEdit34: TW5009SpinEdit;
    W5009SpinEdit35: TW5009SpinEdit;
    W5009SpinEdit36: TW5009SpinEdit;
    WICheckBox11: TWICheckBox;
    W5009SpinEdit37: TW5009SpinEdit;
    W5009SpinEdit38: TW5009SpinEdit;
    WIEnumComboBox13: TWIEnumComboBox;
    W5009SpinEdit39: TW5009SpinEdit;
    WIspyact1: TWIItemSpy;
    wspyact2: TWIItemSpy;
    Wspyact1fb: TWIItemSpy;
    Wspyact2fb: TWIItemSpy;
    WIspylp2: TWIItemSpy;
    Whpcompensated: TWIGroupBox;
    Whp4: TW5009SpinEdit;
    Whp20: TW5009SpinEdit;
    Label221: TLabel;
    Label222: TLabel;
    Label223: TLabel;
    Label224: TLabel;
    W5009SpinEdit68: TW5009SpinEdit;
    W5009SpinEdit69: TW5009SpinEdit;
    W5009SpinEdit70: TW5009SpinEdit;
    W5009SpinEdit71: TW5009SpinEdit;
    W5009SpinEdit72: TW5009SpinEdit;
    W5009SpinEdit73: TW5009SpinEdit;
    W5009SpinEdit74: TW5009SpinEdit;
    W5009SpinEdit75: TW5009SpinEdit;
    W5009SpinEdit76: TW5009SpinEdit;
    W5009SpinEdit77: TW5009SpinEdit;
    W5009SpinEdit78: TW5009SpinEdit;
    W5009SpinEdit79: TW5009SpinEdit;
    Label225: TLabel;
    Label226: TLabel;
    Label227: TLabel;
    Label228: TLabel;
    Label229: TLabel;
    Label230: TLabel;
    Label231: TLabel;
    Label232: TLabel;
    Label233: TLabel;
    Label234: TLabel;
    Label235: TLabel;
    Label236: TLabel;
    WICheckBox18: TWICheckBox;
    Wlpcompensated: TWIGroupBox;
    Label239: TLabel;
    Label240: TLabel;
    Label241: TLabel;
    Label242: TLabel;
    Label243: TLabel;
    Label244: TLabel;
    Label245: TLabel;
    Label246: TLabel;
    Label247: TLabel;
    Label248: TLabel;
    Label249: TLabel;
    Label250: TLabel;
    Label251: TLabel;
    Label252: TLabel;
    Label253: TLabel;
    Label254: TLabel;
    Wlp4: TW5009SpinEdit;
    Wlp20: TW5009SpinEdit;
    W5009SpinEdit82: TW5009SpinEdit;
    W5009SpinEdit83: TW5009SpinEdit;
    W5009SpinEdit84: TW5009SpinEdit;
    W5009SpinEdit85: TW5009SpinEdit;
    W5009SpinEdit86: TW5009SpinEdit;
    W5009SpinEdit87: TW5009SpinEdit;
    W5009SpinEdit88: TW5009SpinEdit;
    W5009SpinEdit89: TW5009SpinEdit;
    W5009SpinEdit90: TW5009SpinEdit;
    W5009SpinEdit91: TW5009SpinEdit;
    W5009SpinEdit92: TW5009SpinEdit;
    W5009SpinEdit93: TW5009SpinEdit;
    WICheckBox19: TWICheckBox;
    WIselvalve: TWIGroupBox;
    WIHPselection: TWIGroupBox;
    WIselhpvalve: TWIEnumComboBox;
    WItwohp: TWICheckBox;
    Whpcomp: TWICheckBox;
    WIHP2selection: TWIGroupBox;
    Loffsethp: TLabel;
    Lunitoffsethp: TLabel;
    Whp2sel: TWIEnumComboBox;
    WoffsetHP: TW5009SpinEdit;
    WILPselection: TWIGroupBox;
    Wlpsel: TWIEnumComboBox;
    lposfset: TWICheckBox;
    Wlpcomp: TWICheckBox;
    WILP2selection: TWIGroupBox;
    Llpoffset: TLabel;
    Llposetunit: TLabel;
    Wlp2sel: TWIEnumComboBox;
    wlpoffset: TW5009SpinEdit;
    Wmonitor1: TWIGroupBox;
    W5009SpinEdit80: TW5009SpinEdit;
    W5009SpinEdit81: TW5009SpinEdit;
    Label257: TLabel;
    Label258: TLabel;
    Label259: TLabel;
    Label260: TLabel;
    WIEnumComboBox14: TWIEnumComboBox;
    WIEnumComboBox15: TWIEnumComboBox;
    Label261: TLabel;
    Wmonitor2: TWIGroupBox;
    Label262: TLabel;
    Label263: TLabel;
    Label264: TLabel;
    Label265: TLabel;
    Label266: TLabel;
    W5009SpinEdit94: TW5009SpinEdit;
    W5009SpinEdit95: TW5009SpinEdit;
    WIEnumComboBox25: TWIEnumComboBox;
    WIEnumComboBox26: TWIEnumComboBox;
    Wmonitor3: TWIGroupBox;
    Label267: TLabel;
    Label268: TLabel;
    Label269: TLabel;
    Label270: TLabel;
    Label271: TLabel;
    W5009SpinEdit96: TW5009SpinEdit;
    W5009SpinEdit97: TW5009SpinEdit;
    WIEnumComboBox27: TWIEnumComboBox;
    WIEnumComboBox28: TWIEnumComboBox;
    Wmonitor4: TWIGroupBox;
    Label272: TLabel;
    Label273: TLabel;
    Label274: TLabel;
    Label275: TLabel;
    Label276: TLabel;
    W5009SpinEdit98: TW5009SpinEdit;
    W5009SpinEdit99: TW5009SpinEdit;
    WIEnumComboBox29: TWIEnumComboBox;
    WIEnumComboBox30: TWIEnumComboBox;
    Wspymon1: TWIItemSpy;
    Wspymon2: TWIItemSpy;
    Wspymon3: TWIItemSpy;
    Wspymon4: TWIItemSpy;
    remotespeed: TWIPanel;
    Lremspdsensor: TLabel;
    Wremmin: TW5009SpinEdit;
    WWremmax: TW5009SpinEdit;
    Lrem4: TLabel;
    Lrem20: TLabel;
    Label289: TLabel;
    WIRmtMinSpd: TW5009SpinEdit;
    Label291: TLabel;
    Label290: TLabel;
    Label293: TLabel;
    Label292: TLabel;
    W5009SpinEdit108: TW5009SpinEdit;
    WUseCascadePID: TWIEnumComboBox;
    LUseCascadePID: TLabel;
    WIsite: TWIStringEdit;
    WIturbine: TWIStringEdit;
    WItag: TWIStringEdit;
    Label294: TLabel;
    Label295: TLabel;
    Label296: TLabel;
    WIEnumComboBox31: TWIEnumComboBox;
    Label297: TLabel;
    WIEnumComboBox32: TWIEnumComboBox;
    Label298: TLabel;
    WIEnumComboBox33: TWIEnumComboBox;
    Label299: TLabel;
    WIEnumComboBox34: TWIEnumComboBox;
    Label300: TLabel;
    WIEnumComboBox35: TWIEnumComboBox;
    Label301: TLabel;
    WIEnumComboBox36: TWIEnumComboBox;
    WIEnumComboBox37: TWIEnumComboBox;
    WIEnumComboBox38: TWIEnumComboBox;
    WIEnumComboBox39: TWIEnumComboBox;
    WIEnumComboBox40: TWIEnumComboBox;
    Label302: TLabel;
    Label303: TLabel;
    Label304: TLabel;
    Label305: TLabel;
    Label306: TLabel;
    WRelay5LevelSW: TWIEnumComboBox;
    WRelay6LevelSW: TWIEnumComboBox;
    WRelay7LevelSW: TWIEnumComboBox;
    WRelay10LevelSW: TWIEnumComboBox;
    WRelay12LevelSW: TWIEnumComboBox;
    WRelay9LevelSW: TWIEnumComboBox;
    WRelay8LevelSW: TWIEnumComboBox;
    WRelay11LevelSW: TWIEnumComboBox;
    WContactInput9: TWIEnumComboBox;
    WContactInput10: TWIEnumComboBox;
    WContactInput11: TWIEnumComboBox;
    WContactInput12: TWIEnumComboBox;
    WContactInput13: TWIEnumComboBox;
    WContactInput14: TWIEnumComboBox;
    WContactInput15: TWIEnumComboBox;
    WContactInput16: TWIEnumComboBox;
    WContactInput17: TWIEnumComboBox;
    WContactInput18: TWIEnumComboBox;
    WContactInput19: TWIEnumComboBox;
    WContactInput20: TWIEnumComboBox;
    WContactInput21: TWIEnumComboBox;
    WContactInput22: TWIEnumComboBox;
    WContactInput23: TWIEnumComboBox;
    WContactInput24: TWIEnumComboBox;
    Label307: TLabel;
    WIusered1: TWIEnumComboBox;
    Wusefeedforward: TWIEnumComboBox;
    Label558: TLabel;
    Label283: TLabel;
    WAnalogInput2Option: TWIEnumComboBox;
    WAnalogInput3Option: TWIEnumComboBox;
    WAnalogInput4Option: TWIEnumComboBox;
    WAnalogInput5Option: TWIEnumComboBox;
    WAnalogInput6Option: TWIEnumComboBox;
    WAnalogInput7Option: TWIEnumComboBox;
    WAnalogInput8Option: TWIEnumComboBox;
    WRelay5IndicationOf: TWIEnumComboBox;
    WRelay6IndicationOf: TWIEnumComboBox;
    WRelay7IndicationOf: TWIEnumComboBox;
    WRelay9IndicationOf: TWIEnumComboBox;
    WRelay10IndicationOf: TWIEnumComboBox;
    WRelay11IndicationOf: TWIEnumComboBox;
    WRelay12IndicationOf: TWIEnumComboBox;
    WRelay8IndicationOf: TWIEnumComboBox;
    WPdualredund: TWITabSheet;
    WIareadout: TWIScrollBox;
    GAnalogReadout1: TWIGroupBox;
    LReadout1Option: TLabel;
    WReadout1Option: TWIEnumComboBox;
    PAnalogReadout1Values: TWIPanel;
    LReadout14mAValue: TLabel;
    LReadout120mAValue: TLabel;
    WReadout14mAValue: TW5009SpinEdit;
    WReadout120mAValue: TW5009SpinEdit;
    GAnalogReadout2: TWIGroupBox;
    LReadout2Option: TLabel;
    PAnalogReadout2Values: TWIPanel;
    LReadout24mAValue: TLabel;
    LReadout220mAValue: TLabel;
    WReadout24mAValue: TW5009SpinEdit;
    WReadout220mAValue: TW5009SpinEdit;
    WReadout2Option: TWIEnumComboBox;
    GAnalogReadout3: TWIGroupBox;
    LReadout3Option: TLabel;
    PAnalogReadout3Values: TWIPanel;
    LReadout34mAValue: TLabel;
    LReadout320mAValue: TLabel;
    WReadout34mAValue: TW5009SpinEdit;
    WReadout320mAValue: TW5009SpinEdit;
    WReadout3Option: TWIEnumComboBox;
    GAnalogReadout4: TWIGroupBox;
    LReadout4Option: TLabel;
    PAnalogReadout4Values: TWIPanel;
    LReadout44mAValue: TLabel;
    LReadout420mAValue: TLabel;
    WReadout44mAValue: TW5009SpinEdit;
    WReadout420mAValue: TW5009SpinEdit;
    WReadout4Option: TWIEnumComboBox;
    Wlevels1: TWIGroupBox;
    Label277: TLabel;
    WIPlsw1: TWIPanel;
    Label278: TLabel;
    Label279: TLabel;
    W5009SpinEdit100: TW5009SpinEdit;
    W5009SpinEdit101: TW5009SpinEdit;
    WICheckBox20: TWICheckBox;
    WICheckBox21: TWICheckBox;
    WICheckBox22: TWICheckBox;
    WICheckBox23: TWICheckBox;
    WICheckBox24: TWICheckBox;
    Wlswen1: TWIEnumComboBox;
    Wlevels2: TWIGroupBox;
    Label280: TLabel;
    WIPlsw2: TWIPanel;
    Label281: TLabel;
    Label282: TLabel;
    W5009SpinEdit102: TW5009SpinEdit;
    W5009SpinEdit103: TW5009SpinEdit;
    WICheckBox25: TWICheckBox;
    WICheckBox26: TWICheckBox;
    WICheckBox27: TWICheckBox;
    WICheckBox28: TWICheckBox;
    WICheckBox29: TWICheckBox;
    Wlevels3: TWIGroupBox;
    Label309: TLabel;
    WIPlsw3: TWIPanel;
    Label284: TLabel;
    Label285: TLabel;
    W5009SpinEdit104: TW5009SpinEdit;
    W5009SpinEdit105: TW5009SpinEdit;
    WICheckBox30: TWICheckBox;
    WICheckBox31: TWICheckBox;
    WICheckBox32: TWICheckBox;
    WICheckBox33: TWICheckBox;
    WICheckBox34: TWICheckBox;
    Wlevels4: TWIGroupBox;
    Label286: TLabel;
    WIPlsw4: TWIPanel;
    Label287: TLabel;
    Label288: TLabel;
    W5009SpinEdit106: TW5009SpinEdit;
    W5009SpinEdit107: TW5009SpinEdit;
    WICheckBox35: TWICheckBox;
    WICheckBox36: TWICheckBox;
    WICheckBox37: TWICheckBox;
    WICheckBox38: TWICheckBox;
    WICheckBox39: TWICheckBox;
    EndofAo: TWIPanel;
    WIact1readout: TWIGroupBox;
    Label308: TLabel;
    WReadout5Option: TWIEnumComboBox;
    PActuatorReadout1Values: TWIPanel;
    Label310: TLabel;
    Label311: TLabel;
    W5009SpinEdit109: TW5009SpinEdit;
    W5009SpinEdit110: TW5009SpinEdit;
    WIact2readout: TWIGroupBox;
    Label312: TLabel;
    WReadout6Option: TWIEnumComboBox;
    PActuatorReadout2Values: TWIPanel;
    Label313: TLabel;
    Label314: TLabel;
    W5009SpinEdit111: TW5009SpinEdit;
    W5009SpinEdit112: TW5009SpinEdit;
    WIItemSpyact1: TWIItemSpy;
    WIItemSpyact2: TWIItemSpy;
    WInormalsd: TWIGroupBox;
    WICheckBox40: TWICheckBox;
    WICheckBox41: TWICheckBox;
    WICheckBox42: TWICheckBox;
    WIhpcpcas: TWICheckBox;
    WICheckBox49: TWICheckBox;
    WICheckBox50: TWICheckBox;
    WICheckBox51: TWICheckBox;
    Wpilot1: TWIGroupBox;
    Label169: TLabel;
    WIEnumComboBox7: TWIEnumComboBox;
    Wpilot2: TWIGroupBox;
    Label170: TLabel;
    usepilot1: TWICheckBox;
    usepilot2: TWICheckBox;
    WIEnumComboBox8: TWIEnumComboBox;
    WIEnumComboBox9: TWIEnumComboBox;
    Label171: TLabel;
    WIEnumComboBox18: TWIEnumComboBox;
    Label176: TLabel;
    WICheckBox45: TWICheckBox;
    WICheckBox46: TWICheckBox;
    WICheckBox47: TWICheckBox;
    WICheckBox48: TWICheckBox;
    W5009SpinEdit3: TW5009SpinEdit;
    Label177: TLabel;
    W5009SpinEdit113: TW5009SpinEdit;
    Label178: TLabel;
    WExtrCntrlMinLPValveLift: TW5009SpinEdit;
    LExtrCntrlMinLPValveLiftUnits: TLabel;
    LExtrCntrlMinLPValveLift: TLabel;
    Wextrsetting: TWIGroupBox;
    Label237: TLabel;
    Label255: TLabel;
    Label256: TLabel;
    Label315: TLabel;
    WIEnumComboBox19: TWIEnumComboBox;
    W5009SpinEdit114: TW5009SpinEdit;
    W5009SpinEdit115: TW5009SpinEdit;
    Wremextr: TWIPanel;
    LExtrCntrlRmtSetptMaxRate: TLabel;
    WExtrCntrlRmtSetptMaxRate: TW5009SpinEdit;
    W5009SpinEdit117: TW5009SpinEdit;
    W5009SpinEdit118: TW5009SpinEdit;
    Label238: TLabel;
    Label316: TLabel;
    Label317: TLabel;
    W5009SpinEdit116: TW5009SpinEdit;
    Label318: TLabel;
    Label319: TLabel;
    WICheckBox43: TWICheckBox;
    W5009SpinEdit119: TW5009SpinEdit;
    Label320: TLabel;
    Label321: TLabel;
    Label9: TLabel;
    Label322: TLabel;
    Label323: TLabel;
    Label324: TLabel;
    WIEnumComboBox41: TWIEnumComboBox;
    Label325: TLabel;
    W5009SpinEdit120: TW5009SpinEdit;
    Label326: TLabel;
    Label327: TLabel;
    WExtrCntrlUseAutomaticEnable: TWICheckBox;
    W5009SpinEdit124: TW5009SpinEdit;
    W5009SpinEdit125: TW5009SpinEdit;
    Label333: TLabel;
    Label334: TLabel;
    Label335: TLabel;
    Label336: TLabel;
    W5009SpinEdit126: TW5009SpinEdit;
    W5009SpinEdit127: TW5009SpinEdit;
    WIGroupBox2: TWIGroupBox;
    Label342: TLabel;
    Label343: TLabel;
    Label344: TLabel;
    Label345: TLabel;
    WIEnumComboBox2: TWIEnumComboBox;
    W5009SpinEdit130: TW5009SpinEdit;
    W5009SpinEdit131: TW5009SpinEdit;
    WIEnumComboBox42: TWIEnumComboBox;
    LAdmissionUnits: TLabel;
    WIGroupBox5: TWIGroupBox;
    Label6: TLabel;
    Label10: TLabel;
    Label328: TLabel;
    Label329: TLabel;
    Label330: TLabel;
    Label331: TLabel;
    Label332: TLabel;
    Label337: TLabel;
    Label338: TLabel;
    Label339: TLabel;
    W5009SpinEdit121: TW5009SpinEdit;
    W5009SpinEdit122: TW5009SpinEdit;
    W5009SpinEdit123: TW5009SpinEdit;
    W5009SpinEdit128: TW5009SpinEdit;
    W5009SpinEdit129: TW5009SpinEdit;
    WICheckBox44: TWICheckBox;
    WIGroupBox6: TWIGroupBox;
    Label340: TLabel;
    Label341: TLabel;
    Label346: TLabel;
    Label347: TLabel;
    Label348: TLabel;
    Label349: TLabel;
    Label350: TLabel;
    Label351: TLabel;
    W5009SpinEdit132: TW5009SpinEdit;
    W5009SpinEdit133: TW5009SpinEdit;
    W5009SpinEdit134: TW5009SpinEdit;
    W5009SpinEdit135: TW5009SpinEdit;
    Wremadmsel: TWICheckBox;
    WICheckBox53: TWICheckBox;
    Wremadm: TWIPanel;
    Label352: TLabel;
    Label353: TLabel;
    Label354: TLabel;
    Label355: TLabel;
    W5009SpinEdit136: TW5009SpinEdit;
    W5009SpinEdit137: TW5009SpinEdit;
    W5009SpinEdit138: TW5009SpinEdit;
    W5009SpinEdit139: TW5009SpinEdit;
    Label356: TLabel;
    W5009SpinEdit140: TW5009SpinEdit;
    Label357: TLabel;
    Label358: TLabel;
    Label359: TLabel;
    WIGroupBox8: TWIGroupBox;
    Label360: TLabel;
    Label361: TLabel;
    Label362: TLabel;
    Label363: TLabel;
    Label364: TLabel;
    WIEnumComboBox43: TWIEnumComboBox;
    W5009SpinEdit141: TW5009SpinEdit;
    W5009SpinEdit142: TW5009SpinEdit;
    WIEnumComboBox44: TWIEnumComboBox;
    WIGroupBox9: TWIGroupBox;
    Label365: TLabel;
    Label366: TLabel;
    Label367: TLabel;
    Label368: TLabel;
    Label369: TLabel;
    Label370: TLabel;
    Label371: TLabel;
    Label372: TLabel;
    Label373: TLabel;
    Label374: TLabel;
    W5009SpinEdit143: TW5009SpinEdit;
    W5009SpinEdit144: TW5009SpinEdit;
    W5009SpinEdit145: TW5009SpinEdit;
    W5009SpinEdit146: TW5009SpinEdit;
    W5009SpinEdit147: TW5009SpinEdit;
    WICheckBox52: TWICheckBox;
    WIGroupBox10: TWIGroupBox;
    Label375: TLabel;
    Label376: TLabel;
    Label377: TLabel;
    Label378: TLabel;
    Label379: TLabel;
    Label380: TLabel;
    Label381: TLabel;
    Label382: TLabel;
    W5009SpinEdit148: TW5009SpinEdit;
    W5009SpinEdit149: TW5009SpinEdit;
    W5009SpinEdit150: TW5009SpinEdit;
    W5009SpinEdit151: TW5009SpinEdit;
    useestradm: TWICheckBox;
    WICheckBox55: TWICheckBox;
    WExtrAdmUseRemoteSetpoint: TWIPanel;
    Label383: TLabel;
    Label384: TLabel;
    Label385: TLabel;
    Label386: TLabel;
    W5009SpinEdit152: TW5009SpinEdit;
    W5009SpinEdit153: TW5009SpinEdit;
    W5009SpinEdit154: TW5009SpinEdit;
    Label387: TLabel;
    W5009SpinEdit155: TW5009SpinEdit;
    Label388: TLabel;
    W5009SpinEdit156: TW5009SpinEdit;
    Label389: TLabel;
    Label390: TLabel;
    WIScrollredudnat: TWIScrollBox;
    EndOfRedundancy: TWIPanel;
    WIPanel2: TWIPanel;
    Wselred2: TWICheckBox;
    Wred1: TWIGroupBox;
    WIEnumComboBox45: TWIEnumComboBox;
    Label391: TLabel;
    Wautotest1: TWICheckBox;
    Wred1autotest: TWIPanel;
    Wred1period: TW5009SpinEdit;
    Label392: TLabel;
    Label393: TLabel;
    W5009SpinEdit157: TW5009SpinEdit;
    Label394: TLabel;
    Label395: TLabel;
    Wred1fdbkerr: TWICheckBox;
    Werrordly: TWIPanel;
    W5009SpinEdit158: TW5009SpinEdit;
    Label396: TLabel;
    Label397: TLabel;
    WICheckBox54: TWICheckBox;
    WICheckBox57: TWICheckBox;
    red1useaia: TWICheckBox;
    Waired1a: TWIPanel;
    Label398: TLabel;
    Label399: TLabel;
    W5009SpinEdit159: TW5009SpinEdit;
    Label400: TLabel;
    Label401: TLabel;
    W5009SpinEdit160: TW5009SpinEdit;
    red1useaib: TWICheckBox;
    Waired1b: TWIPanel;
    Label402: TLabel;
    Label403: TLabel;
    Label404: TLabel;
    Label405: TLabel;
    W5009SpinEdit161: TW5009SpinEdit;
    W5009SpinEdit162: TW5009SpinEdit;
    Wred2: TWIGroupBox;
    Label406: TLabel;
    WIEnumComboBox46: TWIEnumComboBox;
    Wautotest2: TWICheckBox;
    Wred2autotest: TWIPanel;
    Label407: TLabel;
    Label408: TLabel;
    Label409: TLabel;
    Label410: TLabel;
    W5009SpinEdit163: TW5009SpinEdit;
    W5009SpinEdit164: TW5009SpinEdit;
    Wred2fdbkerr: TWICheckBox;
    Werrordly2: TWIPanel;
    Label411: TLabel;
    Label412: TLabel;
    W5009SpinEdit165: TW5009SpinEdit;
    WICheckBox62: TWICheckBox;
    WICheckBox63: TWICheckBox;
    red2useaia: TWICheckBox;
    Waired2a: TWIPanel;
    Label413: TLabel;
    Label414: TLabel;
    Label415: TLabel;
    Label416: TLabel;
    W5009SpinEdit166: TW5009SpinEdit;
    W5009SpinEdit167: TW5009SpinEdit;
    red2useaib: TWICheckBox;
    Waired2b: TWIPanel;
    Label417: TLabel;
    Label418: TLabel;
    Label419: TLabel;
    Label420: TLabel;
    W5009SpinEdit168: TW5009SpinEdit;
    W5009SpinEdit169: TW5009SpinEdit;
    W5009SpinEdit170: TW5009SpinEdit;
    W5009SpinEdit171: TW5009SpinEdit;
    Label421: TLabel;
    Label422: TLabel;
    Label423: TLabel;
    Label424: TLabel;
    W5009SpinEdit172: TW5009SpinEdit;
    W5009SpinEdit173: TW5009SpinEdit;
    Label425: TLabel;
    Label426: TLabel;
    Label427: TLabel;
    W5009SpinEdit174: TW5009SpinEdit;
    W5009SpinEdit175: TW5009SpinEdit;
    Label428: TLabel;
    Label429: TLabel;
    Label430: TLabel;
    W5009SpinEdit176: TW5009SpinEdit;
    W5009SpinEdit177: TW5009SpinEdit;
    Label431: TLabel;
    Label432: TLabel;
    WDCPLcontrol: TWIPanel;
    WIPanel6: TWIPanel;
    WIGroupBox12: TWIGroupBox;
    Label443: TLabel;
    Label444: TLabel;
    Label445: TLabel;
    Label446: TLabel;
    Label447: TLabel;
    Label448: TLabel;
    Label449: TLabel;
    Label450: TLabel;
    W5009SpinEdit183: TW5009SpinEdit;
    W5009SpinEdit184: TW5009SpinEdit;
    W5009SpinEdit185: TW5009SpinEdit;
    W5009SpinEdit186: TW5009SpinEdit;
    WIremdcpl: TWICheckBox;
    WICheckBox59: TWICheckBox;
    Wremdcpl: TWIPanel;
    Label451: TLabel;
    Label452: TLabel;
    Label453: TLabel;
    Label454: TLabel;
    W5009SpinEdit187: TW5009SpinEdit;
    W5009SpinEdit188: TW5009SpinEdit;
    W5009SpinEdit189: TW5009SpinEdit;
    WIGroupBox13: TWIGroupBox;
    Label455: TLabel;
    Label456: TLabel;
    Label457: TLabel;
    Label458: TLabel;
    Label459: TLabel;
    Label460: TLabel;
    Label461: TLabel;
    Label462: TLabel;
    Label463: TLabel;
    Label464: TLabel;
    W5009SpinEdit190: TW5009SpinEdit;
    W5009SpinEdit191: TW5009SpinEdit;
    W5009SpinEdit192: TW5009SpinEdit;
    W5009SpinEdit193: TW5009SpinEdit;
    WICheckBox60: TWICheckBox;
    W5009SpinEdit194: TW5009SpinEdit;
    WIGroupBox14: TWIGroupBox;
    Label465: TLabel;
    Label466: TLabel;
    Label467: TLabel;
    Label468: TLabel;
    WIEnumComboBox47: TWIEnumComboBox;
    W5009SpinEdit195: TW5009SpinEdit;
    W5009SpinEdit196: TW5009SpinEdit;
    Label433: TLabel;
    Pfeedforward: TWITabSheet;
    WIScrollfeedforward: TWIScrollBox;
    Wfwsensor: TWIGroupBox;
    Label436: TLabel;
    Label437: TLabel;
    W5009SpinEdit178: TW5009SpinEdit;
    W5009SpinEdit179: TW5009SpinEdit;
    Wnormalfeedforward: TWIGroupBox;
    wfeedcasc: TWICheckBox;
    Wusedirect: TWICheckBox;
    wcontrolfw: TWIGroupBox;
    wuseemrgency: TWICheckBox;
    W5009SpinEdit180: TW5009SpinEdit;
    Label434: TLabel;
    Label435: TLabel;
    W5009SpinEdit181: TW5009SpinEdit;
    Label438: TLabel;
    Label439: TLabel;
    W5009SpinEdit182: TW5009SpinEdit;
    Label440: TLabel;
    Label441: TLabel;
    W5009SpinEdit197: TW5009SpinEdit;
    Label442: TLabel;
    Label469: TLabel;
    W5009SpinEdit199: TW5009SpinEdit;
    Label472: TLabel;
    Label473: TLabel;
    Wemergency: TWIGroupBox;
    Label474: TLabel;
    Label475: TLabel;
    Label476: TLabel;
    Label477: TLabel;
    Label478: TLabel;
    Label479: TLabel;
    Label482: TLabel;
    Label483: TLabel;
    Label484: TLabel;
    Label485: TLabel;
    W5009SpinEdit200: TW5009SpinEdit;
    W5009SpinEdit201: TW5009SpinEdit;
    W5009SpinEdit202: TW5009SpinEdit;
    W5009SpinEdit204: TW5009SpinEdit;
    W5009SpinEdit205: TW5009SpinEdit;
    W5009SpinEdit203: TW5009SpinEdit;
    Label480: TLabel;
    Label481: TLabel;
    Label470: TLabel;
    W5009SpinEdit198: TW5009SpinEdit;
    Label471: TLabel;
    WIGroupBox11: TWIGroupBox;
    Label486: TLabel;
    Label487: TLabel;
    Label488: TLabel;
    Label489: TLabel;
    Label490: TLabel;
    Label491: TLabel;
    Label492: TLabel;
    Label493: TLabel;
    Label494: TLabel;
    Label495: TLabel;
    W5009SpinEdit206: TW5009SpinEdit;
    W5009SpinEdit207: TW5009SpinEdit;
    W5009SpinEdit208: TW5009SpinEdit;
    W5009SpinEdit209: TW5009SpinEdit;
    WICheckBox56: TWICheckBox;
    WICheckBox58: TWICheckBox;
    W5009SpinEdit210: TW5009SpinEdit;
    WICheckBox61: TWICheckBox;
    WIGroupBox15: TWIGroupBox;
    Label496: TLabel;
    Label497: TLabel;
    Label498: TLabel;
    Label499: TLabel;
    Label500: TLabel;
    Label501: TLabel;
    Label502: TLabel;
    Label503: TLabel;
    Label504: TLabel;
    Label505: TLabel;
    W5009SpinEdit211: TW5009SpinEdit;
    W5009SpinEdit212: TW5009SpinEdit;
    W5009SpinEdit213: TW5009SpinEdit;
    W5009SpinEdit214: TW5009SpinEdit;
    WICheckBox64: TWICheckBox;
    WICheckBox65: TWICheckBox;
    W5009SpinEdit215: TW5009SpinEdit;
    WICheckBox66: TWICheckBox;
    WICheckBox67: TWICheckBox;
    WICheckBox68: TWICheckBox;
    WICheckBox69: TWICheckBox;
    WICheckBox70: TWICheckBox;
    WICheckBox71: TWICheckBox;
    W5009SpinEdit216: TW5009SpinEdit;
    W5009SpinEdit217: TW5009SpinEdit;
    Label506: TLabel;
    Label507: TLabel;
    Label508: TLabel;
    Label509: TLabel;
    W5009SpinEdit218: TW5009SpinEdit;
    W5009SpinEdit219: TW5009SpinEdit;
    Label510: TLabel;
    Label511: TLabel;
    Label512: TLabel;
    Label513: TLabel;
    Label514: TLabel;
    W5009SpinEdit220: TW5009SpinEdit;
    W5009SpinEdit221: TW5009SpinEdit;
    Label515: TLabel;
    W5009SpinEdit449: TW5009SpinEdit;
    W5009SpinEdit448: TW5009SpinEdit;
    Label1040: TLabel;
    Label1041: TLabel;
    Label1038: TLabel;
    Label1039: TLabel;
    W5009SpinEdit446: TW5009SpinEdit;
    W5009SpinEdit447: TW5009SpinEdit;
    W5009SpinEdit456: TW5009SpinEdit;
    Label1050: TLabel;
    W5009SpinEdit457: TW5009SpinEdit;
    Label1051: TLabel;
    WICheckBox72: TWICheckBox;
    WICheckBox73: TWICheckBox;
    WICheckBox74: TWICheckBox;
    WICheckBox75: TWICheckBox;
    WICheckBox76: TWICheckBox;
    WICheckBox77: TWICheckBox;
    WICheckBox78: TWICheckBox;
    WICheckBox79: TWICheckBox;
    WICheckBox80: TWICheckBox;
    WICheckBox81: TWICheckBox;
    WICheckBox82: TWICheckBox;
    WICheckBox83: TWICheckBox;
    WICheckBox84: TWICheckBox;
    Wlswen2: TWIEnumComboBox;
    Wlswen3: TWIEnumComboBox;
    Wlswen4: TWIEnumComboBox;
    W5009SpinEdit222: TW5009SpinEdit;
    W5009SpinEdit223: TW5009SpinEdit;
    W5009SpinEdit224: TW5009SpinEdit;
    W5009SpinEdit225: TW5009SpinEdit;
    Label516: TLabel;
    Label517: TLabel;
    Label518: TLabel;
    Label519: TLabel;
    function GetMinMaxHints(SpinEdit: TW5009SpinEdit): boolean;
    procedure UpdateFormCaption;
    procedure HandleTurbineType(Sender: TObject);
    procedure WPApplicationEnter(Sender: TObject);
    procedure WPApplicationExit(Sender: TObject);
    procedure WTurbineTypeValueChange(Sender: TObject);
    procedure WPStartSettingsEnter(Sender: TObject);
    procedure WPStartSettingsExit(Sender: TObject);
    procedure WUseCriticalSpeedAvoidanceValueChange(Sender: TObject);
    procedure WUseCriticalSpeedAvoidanceBand2ValueChange(Sender: TObject);
    procedure WPSpeedControlEnter(Sender: TObject);
    procedure WSpdCntrlUseRemoteSpeedSetpointValueChange(Sender: TObject);
    procedure WPExtractionControlEnter(Sender: TObject);
    procedure WExtrCntrlUseRemoteSetpointValueChange(Sender: TObject);
    procedure PageControl1Enter(Sender: TObject);
    procedure PageControl1Exit(Sender: TObject);
    procedure WAnalogInput1OptionValueChange(Sender: TObject);
    procedure WPAdmissionControlEnter(Sender: TObject);
    procedure WPDriverConfigEnter(Sender: TObject);
    procedure WPDriverConfigExit(Sender: TObject);
    procedure WPExtrAdmControlEnter(Sender: TObject);
    procedure WPAnalogInputsEnter(Sender: TObject);
    procedure WPAnalogInputsExit(Sender: TObject);
    procedure WAnalogInput2OptionValueChange(Sender: TObject);
    procedure WAnalogInput3OptionValueChange(Sender: TObject);
    procedure WAnalogInput4OptionValueChange(Sender: TObject);
    procedure WAnalogInput5OptionValueChange(Sender: TObject);
    procedure WAnalogInput6OptionValueChange(Sender: TObject);
    procedure WAnalogInput7OptionValueChange(Sender: TObject);
    procedure WAnalogInput8OptionValueChange(Sender: TObject);
    procedure WPContactInputsEnter(Sender: TObject);
    procedure WPContactInputsExit(Sender: TObject);
    procedure WPDCPLControlEnter(Sender: TObject);
    procedure WPCascadeControlEnter(Sender: TObject);
    procedure WUseRemoteCascadeSetpointValueChange(Sender: TObject);
    procedure WPReadoutsEnter(Sender: TObject);
    procedure WPReadoutsExit(Sender: TObject);
    procedure WReadout1OptionValueChange(Sender: TObject);
    procedure WReadout2OptionValueChange(Sender: TObject);
    procedure WReadout3OptionValueChange(Sender: TObject);
    procedure WReadout4OptionValueChange(Sender: TObject);
    procedure WPRelaysEnter(Sender: TObject);
    procedure WPRelaysExit(Sender: TObject);
    procedure WPCommunicationsEnter(Sender: TObject);
    procedure WPCommunicationsExit(Sender: TObject);
    procedure WComPort1TypeValueChange(Sender: TObject);
    procedure WComPort2TypeValueChange(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormActivate(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure RelaysFunction(FunctionBox: TWIEnumComboBox; PFBox,
              PIndication,PLevelSW,PConfig: TWIPanel; GSettings: TWIGroupBox);
    procedure WRelay4FunctionValueChange(Sender: TObject);
    procedure WRelay5FunctionValueChange(Sender: TObject);
    procedure WRelay6FunctionValueChange(Sender: TObject);
    procedure WRelay7FunctionValueChange(Sender: TObject);
    procedure WRelay8FunctionValueChange(Sender: TObject);
    procedure WRelay9FunctionValueChange(Sender: TObject);
    procedure WRelay10FunctionValueChange(Sender: TObject);
    procedure WRelay11FunctionValueChange(Sender: TObject);
    procedure WRelay12FunctionValueChange(Sender: TObject);
    procedure WHotStartLimitChange(Sender: TObject);
    procedure WLowIdleDelayTimeHotLimitChange(Sender: TObject);
    procedure WHighIdleSetpointLimitChange(Sender: TObject);
    procedure WHighIdleDelayTimeHotLimitChange(Sender: TObject);
    procedure WHighIdleToRatedRateHotLimitChange(Sender: TObject);
    procedure WCriticalRateLimitChange(Sender: TObject);
    procedure WBand1MinimumLimitChange(Sender: TObject);
    procedure WBand1MaximumLimitChange(Sender: TObject);
    procedure WBand2MinimumLimitChange(Sender: TObject);
    procedure WBand2MaximumLimitChange(Sender: TObject);
    procedure WUseCascadePIDValueChange(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure WOverspeedTripLevelLimitChange(Sender: TObject);
    procedure WMaxControlSetptLimitChange(Sender: TObject);
    procedure WMinControlSetptLimitChange(Sender: TObject);
    procedure OpenPageOf(parent: TControl);
    function GetSTuneMinMaxHints(SpinTune: TW5009SpinTune): boolean;
    procedure UpdateMonStatus( bMonitorMode: Boolean );
    function  GetAssociatedErrorObject( Code: Integer;
                                        iPass: Integer;
                                        var bMore: boolean;
                                        var sAppend: string) : TControl;
    procedure PrintInfo( Printer1: TPrinter );
    procedure PrintChildInfo( Printer1: TPrinter;
                              Parent: TWinControl;
                              var y: integer;
                              LineInc, Margin: integer );
    function GetNameAndValue(Obj: TObject; var sName, sVal: string): boolean;
    procedure PrintWndo( Printer1: TPrinter );
    procedure PrintChildWndo( Printer1: TPrinter;
                              Parent: TWinControl;
                              var y: integer;
                              LineInc, Margin: integer );
    procedure ExitProgramModeButtonClick(Sender: TObject);
    procedure LoadButtonClick(Sender: TObject);
    procedure SaveButtonClick(Sender: TObject);
    procedure SwapOnOffLine(OffLine: boolean);
    function UpdateChildrensHints( Parent: TWinControl ): boolean;
    procedure ResetSheetMonStatus;
    procedure WPAdmissionSteamMapEnter(Sender: TObject);
    procedure WPAdmissionSteamMapExit(Sender: TObject);
    procedure WPExtractionSteamMapEnter(Sender: TObject);
    procedure WPExtractionSteamMapExit(Sender: TObject);
    procedure WPExtrAdmSteamMapEnter(Sender: TObject);
    procedure WPExtrAdmSteamMapExit(Sender: TObject);
    procedure WISpySIOBservValueChange(Sender: TObject);
    procedure WISIOB4disaValueChange(Sender: TObject);
    procedure WISpySIOAservValueChange(Sender: TObject);
    procedure WSIOAPort4TypeChange(Sender: TObject);
    procedure WSIObPort4TypeChange(Sender: TObject);
    procedure WItypeValueChange(Sender: TObject);
    procedure WRatioLimiterModeValueChange(Sender: TObject);
    procedure WStartRoutineValueChange(Sender: TObject);
    procedure WIfixerate1ValueChange(Sender: TObject);
    procedure WIfixerate2ValueChange(Sender: TObject);
    procedure WuseremhotcoldValueChange(Sender: TObject);
    procedure WusehidleValueChange(Sender: TObject);
    procedure WusehhidleValueChange(Sender: TObject);
    procedure WusedeadbandValueChange(Sender: TObject);
    procedure WdcplValueChange(Sender: TObject);
    procedure WSpeedInput4ValueChange(Sender: TObject);
    procedure WuseundertripValueChange(Sender: TObject);
    procedure WIuseunderspeedValueChange(Sender: TObject);
    procedure WnofwValueChange(Sender: TObject);
    procedure WIHP1rangeValueChange(Sender: TObject);
    procedure WIHP2rangeValueChange(Sender: TObject);
    procedure WhhdfbktypeValueChange(Sender: TObject);
    procedure WItwohpValueChange(Sender: TObject);
    procedure Whhdfbktypehp2ValueChange(Sender: TObject);
    procedure WIspyact1ValueChange(Sender: TObject);
    procedure wspyact2ValueChange(Sender: TObject);
    procedure Wspyact1fbValueChange(Sender: TObject);
    procedure Wspyact2fbValueChange(Sender: TObject);
    procedure WIspylp2ValueChange(Sender: TObject);
    procedure Whp2selValueChange(Sender: TObject);
    procedure WlpselValueChange(Sender: TObject);
    procedure Wlp2selValueChange(Sender: TObject);
    procedure WIselhpvalveValueChange(Sender: TObject);
    procedure WhpcompValueChange(Sender: TObject);
    procedure WlpcompValueChange(Sender: TObject);
    procedure Wspymon1ValueChange(Sender: TObject);
    procedure Wspymon2ValueChange(Sender: TObject);
    procedure Wspymon3ValueChange(Sender: TObject);
    procedure Wspymon4ValueChange(Sender: TObject);
    procedure Wlswen1ValueChange(Sender: TObject);
    procedure Wlswen2ValueChange(Sender: TObject);
    procedure Wlswen3ValueChange(Sender: TObject);
    procedure Wlswen4ValueChange(Sender: TObject);
    procedure WIusered1ValueChange(Sender: TObject);
    procedure WReadout5OptionValueChange(Sender: TObject);
    procedure WReadout6OptionValueChange(Sender: TObject);
    procedure WIItemSpyact1ValueChange(Sender: TObject);
    procedure WIItemSpyact2ValueChange(Sender: TObject);
    procedure usepilot1ValueChange(Sender: TObject);
    procedure usepilot2ValueChange(Sender: TObject);
    procedure WremadmselValueChange(Sender: TObject);
    procedure useestradmValueChange(Sender: TObject);
    procedure Wred1fdbkerrValueChange(Sender: TObject);
    procedure Wred2fdbkerrValueChange(Sender: TObject);
    procedure red1useaiaValueChange(Sender: TObject);
    procedure red1useaibValueChange(Sender: TObject);
    procedure red2useaiaValueChange(Sender: TObject);
    procedure red2useaibValueChange(Sender: TObject);
    procedure Wautotest1ValueChange(Sender: TObject);
    procedure Wautotest2ValueChange(Sender: TObject);
    procedure Wselred2ValueChange(Sender: TObject);
    procedure WIremdcplValueChange(Sender: TObject);
    procedure WusefeedforwardValueChange(Sender: TObject);
    procedure wuseemrgencyValueChange(Sender: TObject);
    procedure WusedirectValueChange(Sender: TObject);






  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FProgramMode: TFProgramMode = nil;
  ChangeProgramMode: integer = 0;
  PModeWasMaximized: Boolean = False;
  UserResized: Boolean = False;
  PModeOldWidth,PModeOldHeight,PModeDefaultWidth,PModeDefaultHeight: integer;
  bMonitorOnly: Boolean;

const
  NotUsed = 99;
  AuxLimiterStr = 'Aux Limiter';
  AuxControlStr = 'Aux Control';
  Act1SettingStr = 'Act #1 Settings';
  Act2SettingStr = 'Act #2 Settings';
  Act1HPSettingStr = 'Act #1 (HP) Settings';
  Act2LPSettingStr = 'Act #2 (LP) Settings';
  ProgramMode = 'Program Mode - ';
  ViewOnly = '      -      View Only';
  GBoxOverhead = 20;
  PanelOverhead = 2;
  SHEET_NOT_UPDATED = 0;
  SHEET_UPDATED = 123;
  IP_HINTED = $0000001D;

implementation

uses Pci_main;

{$R *.DFM}

procedure TfProgramMode.OpenPageOf(parent: TControl);
begin
  while ((not(parent is TWITabSheet)) and (parent is TWinControl)) do begin
    parent := parent.Parent;
  end;
  if (parent is TWITabSheet) then begin
    if (PageControl1.ActivePage <> TWITabSheet(parent)) then
      PageControl1.ActivePage := TWITabSheet(parent);
  end;
end;


Function TFProgramMode.GetMinMaxHints(SpinEdit: TW5009SpinEdit): boolean;
var
  VarMin, VarMax : real;
begin
  if SpinEdit.IsInitialized then begin
    VarMin := SpinEdit.MinValue;
    VarMax := SpinEdit.MaxValue;
    SpinEdit.Hint := 'Range: ' + (FloatToStrF(VarMin,ffGeneral, 5, 0))
                      + ' to ' + (FloatToStrF(VarMax, ffGeneral, 5, 0));
    GetMinMaxHints := TRUE;
  end
  else
    GetMinMaxHints := FALSE;
end;

function TFProgramMode.GetSTuneMinMaxHints(SpinTune: TW5009SpinTune): boolean;
var
  VarMin, VarMax : real;
  //sEE : string;
begin
  if SpinTune.IsInitialized then begin
    VarMin := SpinTune.MinValue;
    VarMax := SpinTune.MaxValue;
{
    if (SpinTune.GetEnableEnter) then
      sEE := '(No incremental checking)'
    else
      sEE := '(Only incremental changes allowed)';
}
    SpinTune.Hint := 'Range: ' + (FloatToStrF(VarMin, ffGeneral, 5, 0))
                      + ' to ' + (FloatToStrF(VarMax, ffGeneral, 5, 0))
;//                      + sEE;
    GetSTuneMinMaxHints := TRUE;
  end
  else
    GetSTuneMinMaxHints := FALSE;
end;

procedure TFProgramMode.FormCreate(Sender: TObject);
begin
  //WindowState := wsMaximized;
  PageControl1.ActivePage := WPApplication;
  WPExtractionControl.TabVisible := False;
  WPExtractionSteamMap.TabVisible := False;
  WPAdmissionControl.TabVisible := False;
  WPAdmissionSteamMap.TabVisible := False;
  WPExtrAdmControl.TabVisible := False;
  WPExtrAdmSteamMap.TabVisible := False;
  WPDCPLControl.TabVisible := False;
  WPCascadeControl.TabVisible := False;
  WPEnd.TabVisible := False;
  ExitProgramModeButton.Enabled := TRUE;
end;

procedure TFProgramMode.FormClose(Sender: TObject; var Action: TCloseAction);
var
  iResponse: integer;
begin
  if ((fMain.ProgramEdit.Checked) and fMain.bInConfMode) then
    iResponse := MessageDlg('Reset control before exiting program mode?',mtConfirmation,mbYesNoCancel,0)
  else
    iResponse := mrNo;

  case iResponse of
    mrYes:
      begin
        Action := caNone;
        ExitProgramModeButtonClick(Sender);
      end;
    mrCancel:
      Action := caNone; //don't do anything
    mrNo:
      begin
        PageControl1.ActivePage := WPEnd;
        Action := caNone; //allow fMain to close it
        fMain.Enabled := False;
        fMain.ShowStatus('Closing Program Mode');
        ChangeProgramMode := CLOSE_MODE;
        FMain.tMain.Interval := 100;
        FMain.tMain.Enabled := True;
      end;
  end; //case
end;

procedure TFProgramMode.FormActivate(Sender: TObject);
begin
 FMain.Program1.Checked := True;
end;

procedure TFProgramMode.UpdateFormCaption;
begin
  If (FMain.ProgramEdit.Checked = True) then
    Caption := ProgramMode + PageControl1.ActivePage.Caption
  Else
    Caption := ProgramMode + PageControl1.ActivePage.Caption +
                            ViewOnly;
end;

procedure TFProgramMode.FormResize(Sender: TObject);
begin
  if (WindowState = wsNormal) then
    begin
      if (not UserResized) then
        begin
          PModeOldWidth := Width;
          PModeOldHeight := Height;
        end
      else if PModeWasMaximized then
        begin
          PModeWasMaximized := False; {do not move this line of code}
          Width := PModeDefaultWidth;
          Height := PModeDefaultHeight;
          PageControl1.Align := alClient;
          PageControl1.Align := alNone;
          Width := PModeOldWidth;
          Height := PModeOldHeight;
          UserResized := False; {do not move this line of code}
        end;
    end
  else if (WindowState = wsMaximized) then
    begin
      PModeWasMaximized := True;
      UserResized := True;
      PageControl1.Align := alClient;
    end
  else
    PModeWasMaximized := False;

  fMain.tMain.Enabled := False;
  fMain.tMain.Enabled := True; //Tell main form to redraw itself appropriately
end;

procedure TFProgramMode.PageControl1Enter(Sender: TObject);
begin
  UpdateFormCaption;
end;

procedure TFProgramMode.PageControl1Exit(Sender: TObject);
begin
  //777
end;

procedure TFProgramMode.HandleTurbineType(Sender: TObject);
begin
  if WTurbineType.IsInitialized and (WTurbineType.EnumValue > 1) then
    PRatioLimiterMode.Visible := True
  else
    PRatioLimiterMode.Visible := False;
end;


procedure TFProgramMode.RelaysFunction(FunctionBox: TWIEnumComboBox; PFBox,
          PIndication,PLevelSW,PConfig: TWIPanel; GSettings: TWIGroupBox);
var
  GBoxHeight: integer;
begin
  if not FunctionBox.IsInitialized then exit;
  GBoxHeight := GSettings.Height;
  case FunctionBox.EnumValue of
    0,1: begin
           PIndication.Visible := False;
           PLevelSW.Visible := False;
           PConfig.Visible := False;
           GSettings.Height := GBoxOverhead + PFBox.Height;
        end;
      2: begin
           PLevelSW.Visible := True;
           GSettings.Height := (GBoxOverhead + PFBox.Height + PConfig.Height +
                                PLevelSW.Height);
           PIndication.Visible := False;
           PConfig.Visible := True;
         end;
      3: begin
           PIndication.Visible := True;
           GSettings.Height := (GBoxOverhead + PFBox.Height + PConfig.Height +
                                PIndication.Height);
           PLevelSW.Visible := False;
           PConfig.Visible := True;
        end;
  end;
  GBoxHeight := GBoxHeight - GSettings.Height;
  EndOfRelay.Top := EndOfRelay.Top - GBoxHeight;
end;

procedure TFProgramMode.WPApplicationEnter(Sender: TObject);
begin
  UpdateFormCaption;
  HandleTurbineType(Sender);
  if (WPApplication.Tag <> SHEET_UPDATED) then begin
    fMain.UpdateChildrensMonStatus(WPApplication, fMain.ProgramViewOnly.Checked);
    WPApplication.Tag := SHEET_UPDATED;
  end;
end;

procedure TFProgramMode.WUseCascadePIDValueChange(Sender: TObject);
begin
  If (WUseCascadePID.EnumValue = 1) then
     WPCascadeControl.TabVisible := True
     else
     WPCascadeControl.TabVisible := False;



end;

procedure TFProgramMode.WPApplicationExit(Sender: TObject);
begin
  //777
end;


procedure TFProgramMode.WTurbineTypeValueChange(Sender: TObject);
begin
  case WTurbineType.EnumValue of
    0,1: begin
             WPExtractionControl.TabVisible := False;
             WPExtractionSteamMap.TabVisible := False;
             WPAdmissionControl.TabVisible := False;
             WPAdmissionSteamMap.TabVisible := False;
             WPExtrAdmControl.TabVisible := False;
             WPExtrAdmSteamMap.TabVisible := False;

           end;
        2: begin
             WPExtractionControl.TabVisible := True;
             WPExtractionSteamMap.TabVisible := True;
             WPAdmissionControl.TabVisible := False;
             WPAdmissionSteamMap.TabVisible := False;
             WPExtrAdmControl.TabVisible := False;
             WPExtrAdmSteamMap.TabVisible := False;

           end;
        3,4: begin
             WPExtractionControl.TabVisible := False;
             WPExtractionSteamMap.TabVisible := False;
             WPAdmissionControl.TabVisible := True;
             WPAdmissionSteamMap.TabVisible := True;
             WPExtrAdmControl.TabVisible := False;
             WPExtrAdmSteamMap.TabVisible := False;
           end;
        5,6: begin
             WPExtractionControl.TabVisible := False;
             WPExtractionSteamMap.TabVisible := False;
             WPAdmissionControl.TabVisible := False;
             WPAdmissionSteamMap.TabVisible := False;
             WPExtrAdmControl.TabVisible := True;
             WPExtrAdmSteamMap.TabVisible := True;
           end;
  end;
  HandleTurbineType(Sender);
end;


procedure TFProgramMode.WPStartSettingsEnter(Sender: TObject);
begin
  //WHPValveLimiterRate.Hint := 'HP Valve Limiter Rate (.01, 25.0)'; //777
  UpdateFormCaption;
  if (WPStartSettings.Tag <> SHEET_UPDATED) then begin
    fMain.UpdateChildrensMonStatus(WPStartSettings, fMain.ProgramViewOnly.Checked);
    WPStartSettings.Tag := SHEET_UPDATED;
  end;
end;

procedure TFProgramMode.WCriticalRateLimitChange(Sender: TObject);
begin
  if (not WCriticalRate.IsInitialized) then exit;
  WCriticalRate.Hint :=
  'Range: Setpoint Slow Rate (' +
  FloatToStrF(WCriticalRate.MinValue,ffGeneral, 5, 0) + ')'+
//  ' To 500 rpm';
  ' To ' + FloatToStrF(WCriticalRate.MaxValue,ffGeneral, 5, 0);
end;

procedure TFProgramMode.WBand1MinimumLimitChange(Sender: TObject);
begin
  if (not WBand1Minimum.IsInitialized) then exit;
  WBand1Minimum.Hint :=
  'Range: Idle (' +
  FloatToStrF(WBand1Minimum.MinValue,ffGeneral, 5, 0) + ')'+
  ' To Min Gov (' + FloatToStrF(WBand1Minimum.MaxValue,ffGeneral, 5, 0) +
  ')';
end;

procedure TFProgramMode.WBand1MaximumLimitChange(Sender: TObject);
begin
  if (not WBand1Maximum.IsInitialized) then exit;
  WBand1Maximum.Hint :=
  'Range: Band1 Min (' +
  FloatToStrF(WBand1Maximum.MinValue,ffGeneral, 5, 0) + ')'+
  ' To Min Gov (' + FloatToStrF(WBand1Maximum.MaxValue,ffGeneral, 5, 0) +
  ')';
end;

procedure TFProgramMode.WBand2MinimumLimitChange(Sender: TObject);
begin
  if (not WBand2Minimum.IsInitialized) then exit;
  WBand2Minimum.Hint :=
  'Range: Band1 Max (' +
  FloatToStrF(WBand2Minimum.MinValue,ffGeneral, 5, 0) + ')'+
  ' To Min Gov (' + FloatToStrF(WBand2Minimum.MaxValue,ffGeneral, 5, 0) +
  ')';
end;

procedure TFProgramMode.WBand2MaximumLimitChange(Sender: TObject);
begin
  if (not WBand2Maximum.IsInitialized) then exit;
  WBand2Maximum.Hint :=
  'Range: Band2 Min (' +
  FloatToStrF(WBand2Maximum.MinValue,ffGeneral, 5, 0) + ')'+
  ' To Min Gov (' + FloatToStrF(WBand2Maximum.MaxValue,ffGeneral, 5, 0) +
  ')';
end;



procedure TFProgramMode.WHotStartLimitChange(Sender: TObject);
begin
  if (not WHotStart.IsInitialized) then exit;
  WHotStart.Hint :=
  'Range: ' + FloatToStrF(WHotStart.MinValue,ffGeneral, 5, 0) +
  ' To Cold Time (' + FloatToStrF(WHotStart.MaxValue,ffGeneral, 5, 0) + ')';
end;

procedure TFProgramMode.WLowIdleDelayTimeHotLimitChange(Sender: TObject);
begin
  if (not WLowIdleDelayTimeHot.IsInitialized) then exit;
  WLowIdleDelayTimeHot.Hint :=
  'Range: ' + FloatToStrF(WLowIdleDelayTimeHot.MinValue,ffGeneral, 5, 0) +
  ' To Cold Time (' +
  FloatToStrF(WLowIdleDelayTimeHot.MaxValue,ffGeneral, 5, 0) + ')';
end;


procedure TFProgramMode.WHighIdleSetpointLimitChange(Sender: TObject);
begin
  if (not WHighIdleSetpoint.IsInitialized) then exit;
  WHighIdleSetpoint.Hint :=
  'Range: Low Idle (' +
  FloatToStrF(WHighIdleSetpoint.MinValue,ffGeneral, 5, 0) + ')'+
  ' To Min Gov (' + FloatToStrF(WHighIdleSetpoint.MaxValue,ffGeneral, 5, 0) +
  ')';
end;

procedure TFProgramMode.WHighIdleDelayTimeHotLimitChange(Sender: TObject);
begin
  if (not WHighIdleDelayTimeHot.IsInitialized) then exit;
  WHighIdleDelayTimeHot.Hint :=
  'Range: ' + FloatToStrF(WHighIdleDelayTimeHot.MinValue,ffGeneral, 5, 0) +
  ' To Cold Delay (' +
  FloatToStrF(WHighIdleDelayTimeHot.MaxValue,ffGeneral, 5, 0) + ')';
end;

procedure TFProgramMode.WHighIdleToRatedRateHotLimitChange(
  Sender: TObject);
begin
  if (not WHighIdleToRatedRateHot.IsInitialized) then exit;
  WHighIdleToRatedRateHot.Hint :=
  'Range: Cold Rate (' +
  FloatToStrF(WHighIdleToRatedRateHot.MinValue,ffGeneral, 5, 0) + ')'+
  ' To ' + FloatToStrF(WHighIdleToRatedRateHot.MaxValue,ffGeneral, 5, 0);
end;



procedure TFProgramMode.WPStartSettingsExit(Sender: TObject);
begin
  //777
end;

procedure TFProgramMode.WUseCriticalSpeedAvoidanceValueChange(
  Sender: TObject);
begin
  if WUseCriticalSpeedAvoidance.Value then
    begin
    WUseCriticalSpeedAvoidanceBand2.Visible := True;
     PCriticalSpeedAvoidance.Visible := True;
     PCriticalSpeed.Height := PanelOverhead + PCriticalSpeedAvoidance.Height +
                                 PUseCriticalSpeedAvoidance.Height;
     GCriticalSpeedAvoidanceBand1.Visible := True;
      if WUseCriticalSpeedAvoidanceBand2.Value
        then begin
             GCriticalSpeedAvoidanceBand2.Visible := True;
              WIminhighcritical.Visible := True;
              Wstuck.Visible := True;
        end
        Else begin
        GCriticalSpeedAvoidanceBand2.Visible := False;
        WIminhighcritical.Visible := True;
        Wstuck.Visible := True;

     end
     end
  else
    begin
      WUseCriticalSpeedAvoidanceBand2.Visible := False;
      PCriticalSpeedAvoidance.Visible := False;
      PCriticalSpeed.Height := PanelOverhead + PUseCriticalSpeedAvoidance.Height;
      WIminhighcritical.Visible := False;
      Wstuck.Visible := False;
    end
end;

procedure TFProgramMode.WUseCriticalSpeedAvoidanceBand2ValueChange(
  Sender: TObject);
begin
  if WUseCriticalSpeedAvoidanceBand2.Value then
    GCriticalSpeedAvoidanceBand2.Visible := True
  else
    GCriticalSpeedAvoidanceBand2.Visible := False;
end;

procedure TFProgramMode.WPSpeedControlEnter(Sender: TObject);
begin
  UpdateFormCaption;
  if (WPSpeedControl.Tag <> SHEET_UPDATED) then begin
    fMain.UpdateChildrensMonStatus(WPSpeedControl, fMain.ProgramViewOnly.Checked);
    WPSpeedControl.Tag := SHEET_UPDATED;
  end;
end;


procedure TFProgramMode.WSpdCntrlUseRemoteSpeedSetpointValueChange(
  Sender: TObject);
begin
  remotespeed.Visible := WSpdCntrlUseRemoteSpeedSetpoint.Value;

end;


procedure TFProgramMode.WPExtractionControlEnter(Sender: TObject);
begin
  UpdateFormCaption;
  if (WPExtractionControl.Tag <> SHEET_UPDATED) then begin
    fMain.UpdateChildrensMonStatus(WPExtractionControl, fMain.ProgramViewOnly.Checked);
    WPExtractionControl.Tag := SHEET_UPDATED;
  end;
end;



procedure TFProgramMode.WExtrCntrlUseRemoteSetpointValueChange(
  Sender: TObject);
begin
  if WExtrCntrlUseRemoteSetpoint.Value then
   Wremextr.Visible := true
  else
  Wremextr.Visible := false;

end;

procedure TFProgramMode.WPAdmissionControlEnter(Sender: TObject);
begin
  UpdateFormCaption;
  if (WPAdmissionControl.Tag <> SHEET_UPDATED) then begin
    fMain.UpdateChildrensMonStatus(WPAdmissionControl, fMain.ProgramViewOnly.Checked);
    WPAdmissionControl.Tag := SHEET_UPDATED;
  end;
end;




procedure TFProgramMode.WPExtrAdmControlEnter(Sender: TObject);
begin
  UpdateFormCaption;
  if (WPExtrAdmControl.Tag <> SHEET_UPDATED) then begin
    fMain.UpdateChildrensMonStatus(WPExtrAdmControl, fMain.ProgramViewOnly.Checked);
    WPExtrAdmControl.Tag := SHEET_UPDATED;
  end;
end;


procedure TFProgramMode.WPDriverConfigEnter(Sender: TObject);
begin
  UpdateFormCaption;
  WSDriverConfigLinkToTurbineType.LockOnAdvise := True;
  if (WPDriverConfig.Tag <> SHEET_UPDATED) then begin
    fMain.UpdateChildrensMonStatus(WPDriverConfig, fMain.ProgramViewOnly.Checked);
    WPDriverConfig.Tag := SHEET_UPDATED;
  end;
end;

procedure TFProgramMode.WPDriverConfigExit(Sender: TObject);
begin
  WSDriverConfigLinkToTurbineType.LockOnAdvise := False
end;



procedure TFProgramMode.WPAnalogInputsEnter(Sender: TObject);
begin
  UpdateFormCaption;
  if (WPAnalogInputs.Tag <> SHEET_UPDATED) then begin
    fMain.UpdateChildrensMonStatus(WPAnalogInputs, fMain.ProgramViewOnly.Checked);
    WPAnalogInputs.Tag := SHEET_UPDATED;
  end;
end;

procedure TFProgramMode.WPAnalogInputsExit(Sender: TObject);
begin
  //777
end;

procedure TFProgramMode.WAnalogInput1OptionValueChange(Sender: TObject);
begin
  if (WAnalogInput1Option.Value = 1) then
    PAnalogInput1Values.Visible := False
  else
    PAnalogInput1Values.Visible := True;
end;

procedure TFProgramMode.WAnalogInput2OptionValueChange(Sender: TObject);
begin
  if (WAnalogInput2Option.Value = 1) then
    PAnalogInput2Values.Visible := False
  else
    PAnalogInput2Values.Visible := True;
end;

procedure TFProgramMode.WAnalogInput3OptionValueChange(Sender: TObject);
begin
  if (WAnalogInput3Option.Value = 1) then
    PAnalogInput3Values.Visible := False
  else
    PAnalogInput3Values.Visible := True;
end;

procedure TFProgramMode.WAnalogInput4OptionValueChange(Sender: TObject);
begin
  if (WAnalogInput4Option.Value = 1) then
    PAnalogInput4Values.Visible := False
  else
    PAnalogInput4Values.Visible := True;
end;

procedure TFProgramMode.WAnalogInput5OptionValueChange(Sender: TObject);
begin
  if (WAnalogInput5Option.Value = 1) then
    PAnalogInput5Values.Visible := False
  else
    PAnalogInput5Values.Visible := True;
end;

procedure TFProgramMode.WAnalogInput6OptionValueChange(Sender: TObject);
begin
  if (WAnalogInput6Option.Value = 1) then
    PAnalogInput6Values.Visible := False
  else
    PAnalogInput6Values.Visible := True;
end;

procedure TFProgramMode.WAnalogInput7OptionValueChange(Sender: TObject);
begin
  if (WAnalogInput7Option.Value = 1) then
    PAnalogInput7Values.Visible := False
  else
    PAnalogInput7Values.Visible := True;
end;

procedure TFProgramMode.WAnalogInput8OptionValueChange(Sender: TObject);
begin
  if (WAnalogInput8Option.Value = 1) then
    PAnalogInput8Values.Visible := False
  else
    PAnalogInput8Values.Visible := True;
end;

procedure TFProgramMode.WPContactInputsEnter(Sender: TObject);
begin
  UpdateFormCaption;
  if (WPContactInputs.Tag <> SHEET_UPDATED) then begin
    fMain.UpdateChildrensMonStatus(WPContactInputs, fMain.ProgramViewOnly.Checked);
    WPContactInputs.Tag := SHEET_UPDATED;
  end;
end;

procedure TFProgramMode.WPContactInputsExit(Sender: TObject);
begin
  //777
end;

procedure TFProgramMode.WPDCPLControlEnter(Sender: TObject);
begin
  UpdateFormCaption;
  if (WPDCPLControl.Tag <> SHEET_UPDATED) then begin
    fMain.UpdateChildrensMonStatus(WPDCPLControl, fMain.ProgramViewOnly.Checked);
    WPDCPLControl.Tag := SHEET_UPDATED;
  end;
end;


procedure TFProgramMode.WPCascadeControlEnter(Sender: TObject);
begin
  UpdateFormCaption;
  if (WPCascadeControl.Tag <> SHEET_UPDATED) then begin
    fMain.UpdateChildrensMonStatus(WPCascadeControl, fMain.ProgramViewOnly.Checked);
    WPCascadeControl.Tag := SHEET_UPDATED;
  end;
end;




procedure TFProgramMode.WUseRemoteCascadeSetpointValueChange(
  Sender: TObject);
begin
  if WUseRemoteCascadeSetpoint.Value then
    PCasCntrlRmtSetptMaxRate.Visible := True
  else
    PCasCntrlRmtSetptMaxRate.Visible := False;
end;

procedure TFProgramMode.WPReadoutsEnter(Sender: TObject);
begin
  UpdateFormCaption;
  if (WPReadouts.Tag <> SHEET_UPDATED) then begin
    fMain.UpdateChildrensMonStatus(WPReadouts, fMain.ProgramViewOnly.Checked);
    WPReadouts.Tag := SHEET_UPDATED;
  end;
end;

procedure TFProgramMode.WPReadoutsExit(Sender: TObject);
begin
  //777
end;

procedure TFProgramMode.WReadout1OptionValueChange(Sender: TObject);
begin
  if (WReadout1Option.Value = 1) then
    PAnalogReadout1Values.Visible := False
  else
    PAnalogReadout1Values.Visible := True;
end;

procedure TFProgramMode.WReadout2OptionValueChange(Sender: TObject);
begin
  if (WReadout2Option.Value = 1) then
    PAnalogReadout2Values.Visible := False
  else
    PAnalogReadout2Values.Visible := True;
end;

procedure TFProgramMode.WReadout3OptionValueChange(Sender: TObject);
begin
  if (WReadout3Option.Value = 1) then
    PAnalogReadout3Values.Visible := False
  else
    PAnalogReadout3Values.Visible := True;
end;

procedure TFProgramMode.WReadout4OptionValueChange(Sender: TObject);
begin
  if (WReadout4Option.Value = 1) then
    PAnalogReadout4Values.Visible := False
  else
    PAnalogReadout4Values.Visible := True;
end;

procedure TFProgramMode.WPRelaysEnter(Sender: TObject);
begin
  UpdateFormCaption;
  if (WPRelays.Tag <> SHEET_UPDATED) then begin
    fMain.UpdateChildrensMonStatus(WPRelays, fMain.ProgramViewOnly.Checked);
    WPRelays.Tag := SHEET_UPDATED;
  end;
end;

procedure TFProgramMode.WRelay4FunctionValueChange(Sender: TObject);
begin
  RelaysFunction(WRelay4Function,PRelay4Function,PRelay4Indication,
                 PRelay4LevelSW,PRelay4Config,GRelay4Settings);
end;

procedure TFProgramMode.WRelay5FunctionValueChange(Sender: TObject);
begin
  RelaysFunction(WRelay5Function,PRelay5Function,PRelay5Indication,
                 PRelay5LevelSW,PRelay5Config,GRelay5Settings);
end;

procedure TFProgramMode.WRelay6FunctionValueChange(Sender: TObject);
begin
  RelaysFunction(WRelay6Function,PRelay6Function,PRelay6Indication,
                 PRelay6LevelSW,PRelay6Config,GRelay6Settings);
end;

procedure TFProgramMode.WRelay7FunctionValueChange(Sender: TObject);
begin
  RelaysFunction(WRelay7Function,PRelay7Function,PRelay7Indication,
                 PRelay7LevelSW,PRelay7Config,GRelay7Settings);
end;

procedure TFProgramMode.WRelay8FunctionValueChange(Sender: TObject);
begin
  RelaysFunction(WRelay8Function,PRelay8Function,PRelay8Indication,
                 PRelay8LevelSW,PRelay8Config,GRelay8Settings);
end;

procedure TFProgramMode.WRelay9FunctionValueChange(Sender: TObject);
begin
  RelaysFunction(WRelay9Function,PRelay9Function,PRelay9Indication,
                 PRelay9LevelSW,PRelay9Config,GRelay9Settings);
end;

procedure TFProgramMode.WRelay10FunctionValueChange(Sender: TObject);
begin
  RelaysFunction(WRelay10Function,PRelay10Function,PRelay10Indication,
                 PRelay10LevelSW,PRelay10Config,GRelay10Settings);
end;

procedure TFProgramMode.WRelay11FunctionValueChange(Sender: TObject);
begin
  RelaysFunction(WRelay11Function,PRelay11Function,PRelay11Indication,
                 PRelay11LevelSW,PRelay11Config,GRelay11Settings);
end;

procedure TFProgramMode.WRelay12FunctionValueChange(Sender: TObject);
begin
  RelaysFunction(WRelay12Function,PRelay12Function,PRelay12Indication,
                 PRelay12LevelSW,PRelay12Config,GRelay12Settings);
end;

procedure TFProgramMode.WPRelaysExit(Sender: TObject);
begin
  //777
end;

procedure TFProgramMode.WPCommunicationsEnter(Sender: TObject);
begin
  UpdateFormCaption;
  if (WPCommunications.Tag <> SHEET_UPDATED) then begin
    fMain.UpdateChildrensMonStatus(WPCommunications, fMain.ProgramViewOnly.Checked);
    WPCommunications.Tag := SHEET_UPDATED;
  end;
end;

procedure TFProgramMode.WComPort1TypeValueChange(Sender: TObject);
begin
  case WComPort1Type.EnumValue of
    0,1: begin
           PComPort1ModbusSettings.Visible := False;
           M1GEN.Visible := False;
           GComPort1Settings.Height := 70;
         end;
      2: begin
           PComPort1ModbusSettings.Visible := True;
           M1GEN.Visible := True;
           M1SET_R.visible:= False;
           GComPort1Settings.Height := 152;
         end;
  end;
end;

procedure TFProgramMode.WComPort2TypeValueChange(Sender: TObject);
begin
      PComPort2PrinterSettings.Visible := False;
      printer.Visible := False;

  case WComPort2Type.EnumValue of

       0,1: begin
          if   WISIOB4disa.Value = True then begin
          PComPrt2printer.visible:=false;
          M2GEN.visible := False;
          GComPort2Settings.Height := 70;
          end;

          if   WISpySIOBserv.Value = true then
           WISIOB4disa.Visible := True;

          if   WISpySIOBserv.Value = False then begin
               GComPort2Settings.Height := 70;
               PComPrt2printer.visible:=false;
               M2GEN.visible := False;
               end;
          End;

       2: begin
          WISIOB4disa.Visible := false;
          PComPrt2printer.visible:=True;
          M2GEN.visible := True;
          M2SET_R.visible := False;
            GComPort2Settings.Height := 190;
          end;
      3:  begin
           PComPort2PrinterSettings.Visible := True;
           printer.Visible := True;
           if   WISIOB4disa.Value = True then begin
                PComPrt2printer.visible:=false;
                M2GEN.visible := False;
                GComPort2Settings.Height := 70;
                end;

          if   WISpySIOBserv.Value = true then
               WISIOB4disa.Visible := True;

            if   WISpySIOBserv.Value = False then begin
                PComPrt2printer.visible:=false;
                GComPort2Settings.Height := 70;
                M2GEN.visible := False;
                end;
end;
end;
end;

procedure TFProgramMode.WPCommunicationsExit(Sender: TObject);
begin
  //777
end;

procedure TFProgramMode.WOverspeedTripLevelLimitChange(Sender: TObject);
begin
  if (not WOverspeedTripLevel.IsInitialized) then exit;
  WOverspeedTripLevel.Hint :=
  'Range: ' + FloatToStrF(WOverspeedTripLevel.MinValue,ffGeneral, 5, 0) +
  ' To Overspeed Test Limit (' +
  FloatToStrF(WOverspeedTripLevel.MaxValue,ffGeneral, 5, 0) + ')';
end;

procedure TFProgramMode.WMaxControlSetptLimitChange(Sender: TObject);
begin
  if (not WMaxControlSetpt.IsInitialized) then exit;
  WMaxControlSetpt.Hint :=
  'Range: ' + FloatToStrF(WMaxControlSetpt.MinValue,ffGeneral, 5, 0) +
  ' To Overspeed Trip Level (' +
  FloatToStrF(WMaxControlSetpt.MaxValue,ffGeneral, 5, 0) + ')';
end;


procedure TFProgramMode.WMinControlSetptLimitChange(Sender: TObject);
begin
  if (not WMinControlSetpt.IsInitialized) then exit;
  WMinControlSetpt.Hint :=
  'Range: ' + FloatToStrF(WMinControlSetpt.MinValue,ffGeneral, 5, 0) +
  ' To Rated, if Genset, or Max Gov (' +
  FloatToStrF(WMinControlSetpt.MaxValue,ffGeneral, 5, 0) + ')';
end;

procedure TFProgramMode.UpdateMonStatus( bMonitorMode: Boolean );
begin
  fMain.UpdateChildrensMonStatus(TWinControl(PageControl1.ActivePage), bMonitorMode);
end;

function TFProgramMode.UpdateChildrensHints( Parent: TWinControl ): boolean;
var
  i: integer;
  Obj: TObject;
  bFailed: boolean;
begin
  bFailed := FALSE;
  for i := 0 to (Parent.ControlCount-1) do
  begin
    Obj := Parent.Controls[i];
    if (Obj is TWinControl) then begin
      if Obj is TW5009SpinEdit then begin
        if not GetMinMaxHints(TW5009SpinEdit(Obj)) then
          bFailed := TRUE;
      end
      else if Obj is TW5009SpinTune then begin
        if not GetSTuneMinMaxHints(TW5009SpinTune(Obj)) then
          bFailed := TRUE;
      end
      else if (TWinControl(Obj).ControlCount > 0) then
        if not UpdateChildrensHints(TWinControl(Obj)) then
          bFailed := TRUE;
    end;
  end;
  UpdateChildrensHints := bFailed;
end;


{
function TFProgramMode.GetAssociatedErrorObject: TControl
Params--
  Code: Integer; //Integer representation from GAP of error condition to report.
                 //This is the basis for the LARGE switch statement that defines
                 //this function.
  iPass: Integer; //Some error codes cause this function to be called more than
                  //once.  This parameter indicates if this is call #1 or #2
  var bMore: boolean; //Returns to parent if there are more passes required.
  var sAppend: string; //A suffix string may be appended to the control's errmsg.
Returns--
  The interponent variable to branch to when this error is selected.
}
function TFProgramMode.GetAssociatedErrorObject( Code: Integer;
                                                 iPass: Integer;
                                                 var bMore: boolean;
                                                 var sAppend: string
                                                ) : TControl;
begin
  sAppend := '';
  bMore := FALSE;
  case code of
    1  :  GetAssociatedErrorObject := GSpdCntrlSpeedSensorSettings;
    2  :  GetAssociatedErrorObject := GContactInputs;
    3  :  GetAssociatedErrorObject := WContactInput8;
    4  :  GetAssociatedErrorObject := WContactInput9;
    5  :  GetAssociatedErrorObject := WContactInput10;
    6  :  GetAssociatedErrorObject := WContactInput11;
    7  :  GetAssociatedErrorObject := WContactInput12;
    8  :  GetAssociatedErrorObject := WContactInput13;
    9 :  GetAssociatedErrorObject := WContactInput14;
    10 :  GetAssociatedErrorObject := WContactInput15;
    11 :  GetAssociatedErrorObject := WContactInput16;
    12 :  GetAssociatedErrorObject := WContactInput17;
    13 :  GetAssociatedErrorObject := WContactInput18;
    14 :  GetAssociatedErrorObject := WContactInput19;
    15 :  GetAssociatedErrorObject := WContactInput20;
    16 :  GetAssociatedErrorObject := WContactInput21;
    17 :  GetAssociatedErrorObject := WContactInput22;
    18 :  GetAssociatedErrorObject := WContactInput23;
    19 :  GetAssociatedErrorObject := WContactInput24;
    20 :  GetAssociatedErrorObject := WPAnalogInputs;
    21 :  GetAssociatedErrorObject := WAnalogInput1Option;
    22 :  GetAssociatedErrorObject := WAnalogInput2Option;
    23 :  GetAssociatedErrorObject := WAnalogInput3Option;
    24 :  GetAssociatedErrorObject := WAnalogInput4Option;
    25 :  GetAssociatedErrorObject := WAnalogInput5Option;
    26 :  GetAssociatedErrorObject := WAnalogInput6Option;
    27 :  GetAssociatedErrorObject := WAnalogInput7Option;
    28 :  GetAssociatedErrorObject := WAnalogInput8Option;
    29 :  GetAssociatedErrorObject := WRelay4Function;
    30 :  GetAssociatedErrorObject := WRelay5Function;
    31 :  GetAssociatedErrorObject := WRelay6Function;
    32 :  GetAssociatedErrorObject := WRelay7Function;
    33 :  GetAssociatedErrorObject := WRelay8Function;
    34 :  GetAssociatedErrorObject := WRelay9Function;
    35 :  GetAssociatedErrorObject := WRelay10Function;
    36 :  GetAssociatedErrorObject := WRelay11Function;
    37 :  GetAssociatedErrorObject := WRelay12Function;
    38 :  GetAssociatedErrorObject := WReadout1Option;
    39 :  GetAssociatedErrorObject := WReadout2Option;
    40 :  GetAssociatedErrorObject := WReadout3Option;
    41 :  GetAssociatedErrorObject := WReadout4Option;
    42 :  GetAssociatedErrorObject := WIact1readout;
    43 :  GetAssociatedErrorObject := WIact2readout;
    44 :  GetAssociatedErrorObject := WOverspeedTestLimit;
    46 :  GetAssociatedErrorObject := WLowIdleSetpoint;
    47 :  GetAssociatedErrorObject := WLowIdleSetpoint;
    48 :  GetAssociatedErrorObject := WhighIdleSetpoint;
    49 :  GetAssociatedErrorObject := WhhighIdleSetpoint;
    50 :  GetAssociatedErrorObject := WMinControlSetpt;
    51 :  GetAssociatedErrorObject := Wrated;
    52 :  GetAssociatedErrorObject := WMaxControlSetpt;
    53 :  GetAssociatedErrorObject := WOverspeedTripLevel;
    54,59 :

      begin
        if iPass = 1 then begin
          GetAssociatedErrorObject := WBand1Minimum;
          sAppend := ' (Check critical band 1 minimum)';
          bMore := TRUE;
        end
        else begin
          GetAssociatedErrorObject := WBand1Maximum;
          sAppend := ' (Check critical band 1 maximum)';
          bMore := FALSE;
        end;
      end;
    60,65 :
      begin
        if iPass = 1 then begin
          GetAssociatedErrorObject := WBand2Minimum;
          sAppend := ' (Check critical band 2 minimum)';
          bMore := TRUE;
        end
        else begin
          GetAssociatedErrorObject := WBand2Maximum;
          sAppend := ' (Check critical band 2 maximum)';
          bMore := FALSE;
        end;
     end;



    66 :
      if      (WPAdmissionSteamMap.TabVisible) then
        GetAssociatedErrorObject := WPAdmissionSteamMap
      else if (WPExtrAdmSteamMap.TabVisible) then
        GetAssociatedErrorObject := WPExtrAdmSteamMap
      else if (WPExtractionSteamMap.TabVisible) then
        GetAssociatedErrorObject := WPExtractionSteamMap
      else begin
        GetAssociatedErrorObject := WPApplication;
        sAppend := ' (Cannot open Steam Map Page!)';
      end;
    67 :  GetAssociatedErrorObject := WPAnalogInputs;
    68 :
      begin
        if iPass = 1 then begin
          GetAssociatedErrorObject := WPAnalogInputs;
          sAppend := ' (Check analog inputs)';
          bMore := TRUE;
        end
        else begin
          GetAssociatedErrorObject := WExtrAdmUseRemoteSetpoint;
          sAppend := ' (Using extraction remote setpoint?)';
          bMore := FALSE;
        end;
      end;
    69 :  GetAssociatedErrorObject := WPAnalogInputs;
    70 :
      begin
        if iPass = 1 then begin
          GetAssociatedErrorObject := WPAnalogInputs;
          sAppend := ' (Check analog inputs)';
          bMore := TRUE;
        end
        else begin
          GetAssociatedErrorObject := WUseRemoteCascadeSetpoint;
          sAppend := ' (Using remote cascade setpoint?)';
          bMore := FALSE;
        end;
      end;
    71 :  GetAssociatedErrorObject := WPAnalogInputs;
    72 :
      begin
        if iPass = 1 then begin
          GetAssociatedErrorObject := WPAnalogInputs;
          sAppend := ' (Check analog inputs)';
          bMore := TRUE;
        end
        else begin
          GetAssociatedErrorObject := WIremdcpl;
          sAppend := ' (Using remote auxiliary setpoint?)';
          bMore := FALSE;
        end;
      end;
    73 :
      begin
        if iPass = 1 then begin
          GetAssociatedErrorObject := WPAnalogInputs;
          sAppend := ' (Check analog inputs)';
          bMore := TRUE;
        end
        else begin
          GetAssociatedErrorObject := WSpdCntrlUseRemoteSpeedSetpoint;
          sAppend := ' (Using remote speed setpoint?)';
          bMore := FALSE;
        end;
      end;
    74 :  GetAssociatedErrorObject := WPExtrAdmControl;
    75 :  GetAssociatedErrorObject := WPCascadeControl;
    76 :  GetAssociatedErrorObject := WDCPLcontrol; //Aux Limiter Page?
    77 :  GetAssociatedErrorObject := WPAnalogInputs;
    78 :  GetAssociatedErrorObject := WPAnalogInputs;
  end; //case
end;





procedure TFProgramMode.PrintInfo(Printer1: TPrinter);
{$IFDEF PrintFunctionsWork}
var
  Obj: TObject;
  y: integer;
  LineInc: integer;
  Margin: integer;
  i: integer;
{$ENDIF}
begin
{$IFDEF PrintFunctionsWork}
  Margin := 200;
  LineInc := Abs(Printer1.Canvas.Font.Height * 15) div 10;

  y := Margin;
  for i := 0 to (ComponentCount-1) do
  begin
    Obj := Components[i];
    if (Obj is TWITabSheet) then begin
      if (y + Margin > Printer1.PageHeight) then begin
        Printer1.NewPage;
        y := Margin;
      end;
      Printer1.Canvas.TextOut(Margin, y, TWITabSheet(Obj).Caption + ' :');
      y := y + LineInc;
      PrintChildInfo( Printer1, TWITabSheet(Obj), y, LineInc, Margin);
      y := y + LineInc;
    end;
  end;
{$ENDIF}
end; //procedure

function GetMatchingEnumCBString(EnumVal: integer; EnumComboBox: TWIEnumComboBox) : string;
var
  EObj: TWEnumObject;
  i: integer;
  bFound: BOOLEAN;
begin
  bFound := FALSE;
  i := 0;
  while ((i < EnumComboBox.EnumList.Size) and not bFound) do begin
    EObj := EnumComboBox.EnumList[i];
    if (EObj.Value = EnumVal) then begin
      bFound := TRUE;
      Result := EObj.Description;
    end
    else
      i := i+1;
  end;
  if (not bFound) then
    Result := 'Invalid enumerated value';
end;

function TFProgramMode.GetNameAndValue( Obj: TObject;
                                        var sName, sVal: string): boolean;
var
  CurItem : TWIServlinkItem;
  i: integer;
  bFound: boolean;
begin
  bFound := TRUE;

  if      Obj is TW5009SpinEdit then       sName := TW5009SpinEdit(Obj).ItemName
  else if Obj is TW5009SpinTune then       sName := TW5009SpinTune(Obj).ItemName
  else if Obj is TWIEnumComboBox then      sName := TWIEnumComboBox(Obj).ItemName
  else if Obj is TWIBoxLabel then          sName := TWIBoxLabel(Obj).ItemName
  else if Obj is TWIStringEdit then        sName := TWIStringEdit(Obj).ItemName
  else if Obj is TWICheckBox then          sName := TWICheckBox(Obj).ItemName
  else if Obj is TWILabel then             sName := TWILabel(Obj).ItemName

  else
    bFound := FALSE;

  if (bFound and (sName <> '')) then begin
    try
      CurItem := fMain.WIServlinkControl1.GetServlinkItemObject(sName);
      if Obj is TWIEnumComboBox then begin
        i := CurItem.Value;
        sVal := GetMatchingEnumCBString(i, TWIEnumComboBox(Obj));
      end
      else
        sVal := CurItem.Value;
      fMain.WIServlinkControl1.ReleaseItemObject(sName);
    except
      sVal := 'Error retrieving value';
    end;
    GetNameAndValue := TRUE;
  end
  else
    GetNameAndValue := FALSE;
end; //procedure
//////////////////////////////
procedure TFProgramMode.PrintChildInfo( Printer1: TPrinter;
                                        Parent: TWinControl;
                                        var y: integer;
                                        LineInc, Margin: integer );
{$IFDEF PrintFunctionsWork}
var
  Obj: TObject;
  sName, sVal: string;
  i: integer;
{$ENDIF}
begin
{$IFDEF PrintFunctionsWork}
  for i := 0 to Parent.ControlCount-1 do
  begin
    if (y + Margin > Printer1.PageHeight) then begin
      Printer1.NewPage;
      y := Margin;
    end;
    Obj := Parent.Controls[i];
    if (GetNameAndValue(Obj, sName, sVal)) then begin
      Printer1.Canvas.TextOut(Margin + 200, y, sName + ' = ' + sVal);
      y := y + LineInc;
    end
    else if (Obj is TWinControl) then begin
      if (TWinControl(Obj).ControlCount > 0) then
        PrintChildInfo( Printer1, TWinControl(Obj), y, LineInc, Margin );
    end;
  end; //for...
{$ENDIF}
end; //procedure

procedure TFProgramMode.PrintChildWndo( Printer1: TPrinter;
                                        Parent: TWinControl;
                                        var y: integer;
                                        LineInc, Margin: integer );
{$IFDEF PrintFunctionsWork}
var
  Obj: TObject;
  i: integer;
  Source: tRect;
  Dest: tRect;
  TempCanvas: tCanvas;
{$ENDIF}
begin
{$IFDEF PrintFunctionsWork}
  for i := 0 to Parent.ControlCount-1 do
  begin
    if (y + Margin > Printer1.PageHeight) then begin
      Printer1.NewPage;
      y := Margin;
    end;
    Obj := Parent.Controls[i];
    if (Obj is TWIScrollBox) then begin
      if (TWinControl(Obj).ControlCount > 0) then
        PrintChildWndo( Printer1, TWinControl(Obj), y, LineInc, Margin );
    end
    else if (Obj is TCustomControl) then begin
      if (TWinControl(Obj).Visible) then begin
        Dest.Left := Margin;
        Dest.Top := y;
        Dest.Right := Dest.Left + TCustomControl(Obj).Width;
        Dest.Bottom := Dest.Top + TCustomControl(Obj).Height;
        Source.Left := TCustomControl(Obj).Left;
        Source.Top := TCustomControl(Obj).Top;
        Source.Right := Source.Left + TCustomControl(Obj).Width;
        Source.Bottom := Source.Top + TCustomControl(Obj).Height;
        TWinControl(Obj).PaintTo(TempCanvas.Handle, Dest.Left, Dest.Top);
        y := y + TCustomControl(Obj).Height;
      end;
    end;
  end; //for...
{$ENDIF}
end; //procedure

procedure TFProgramMode.PrintWndo(Printer1: TPrinter);
{$IFDEF PrintFunctionsWork}
var
  Obj: TObject;
  y: integer;
  LineInc: integer;
  Margin: integer;
  i: integer;
{$ENDIF}
begin
{$IFDEF PrintFunctionsWork}
  Margin := 200;
  LineInc := Abs(Printer1.Canvas.Font.Height * 15) div 10;

  y := Margin;
  for i := 0 to (ComponentCount-1) do
  begin
    Obj := Components[i];
    if ((Obj is TWITabSheet) and (TWITabSheet(Obj) = PageControl1.ActivePage)) then begin
      if (y + Margin > Printer1.PageHeight) then begin
        Printer1.NewPage;
        y := Margin;
      end;
      Printer1.Canvas.TextOut(Margin, y, TWITabSheet(Obj).Caption + ' :');
      y := y + LineInc;
      PrintChildWndo( Printer1, TWITabSheet(Obj), y, LineInc, Margin);
      y := y + LineInc;
    end;
  end;

{$ENDIF}
end; //procedure

procedure TFProgramMode.ExitProgramModeButtonClick(Sender: TObject);
var
  CurItem : TWIServlinkItem;
begin
  if fMain.ControlInLoadFromFileState then begin
    MessageDlg('Configuration error:  The control is only partially configured.  You must either reset the entire control or successfully download a configuration file to the control.', mtWarning,[mbOK], 0);
    exit;
  end;
  fMain.SuspendOtherAdvises;

  try
    CurItem := fMain.WIServLinkControl1.GetServlinkItemObject(sGAPStartConfig);
    CurItem.Value := TRUE;
    fMain.WIServlinkControl1.ReleaseItemObject(sGAPStartConfig);
    fMain.StatusBar1.Panels[ControlStatusPanel].Text := 'Control is checking for configuration errors...';
    fMain.CCheckTimer.Interval := 4500; //Wait 2.5 seconds before checking return values
    CCheckTime := 0;
    fMain.CCheckTimer.Enabled := TRUE;
  except
    MessageDlg('Unable to access the following GAP value:  ' + sGAPStartConfig + '.  ...Aborting', mtWarning,[mbOK], 0);
  end;

end;

procedure TFProgramMode.LoadButtonClick(Sender: TObject);
begin
  fMain.Loadfromfile1Click(Sender);
end;

procedure TFProgramMode.SaveButtonClick(Sender: TObject);
begin
  fMain.Save1Click(Sender);
end;

procedure TFProgramMode.SwapOnOffLine(OffLine: boolean);
begin
  ExitProgramModeButton.Visible := not OffLine;
  fMain.SendValuesToControl.Enabled := OffLine;
  if OffLine then begin
  end
  else begin
    fMain.ProgramEdit.Checked := TRUE;
  end;
end;

procedure TFProgramMode.ResetSheetMonStatus;
var
  i: integer;
  Obj: tComponent;
begin
  for i := 0 to (ComponentCount-1) do
  begin
    Obj := Components[i];
    if (Obj is TWITabSheet) then begin
      TWITabSheet(Obj).Tag := SHEET_NOT_UPDATED;
    end;
  end;
end;

procedure TFProgramMode.WPAdmissionSteamMapEnter(Sender: TObject);
begin
  if (WPAdmissionSteamMap.Tag <> SHEET_UPDATED) then begin
    fMain.UpdateChildrensMonStatus(WPAdmissionSteamMap, fMain.ProgramViewOnly.Checked);
    WPAdmissionSteamMap.Tag := SHEET_UPDATED;
  end;
end;

procedure TFProgramMode.WPAdmissionSteamMapExit(Sender: TObject);
begin
//777
end;

procedure TFProgramMode.WPExtractionSteamMapEnter(Sender: TObject);
begin
  if (WPExtractionSteamMap.Tag <> SHEET_UPDATED) then begin
    fMain.UpdateChildrensMonStatus(WPExtractionSteamMap, fMain.ProgramViewOnly.Checked);
    WPExtractionSteamMap.Tag := SHEET_UPDATED;
  end;
end;

procedure TFProgramMode.WPExtractionSteamMapExit(Sender: TObject);
begin
//777
end;

procedure TFProgramMode.WPExtrAdmSteamMapEnter(Sender: TObject);
begin
  if (WPExtrAdmSteamMap.Tag <> SHEET_UPDATED) then begin
    fMain.UpdateChildrensMonStatus(WPExtrAdmSteamMap, fMain.ProgramViewOnly.Checked);
    WPExtrAdmSteamMap.Tag := SHEET_UPDATED;
  end;
end;

procedure TFProgramMode.WPExtrAdmSteamMapExit(Sender: TObject);
begin
//777
end;


procedure TFProgramMode.WISpySIOBservValueChange(Sender: TObject);
begin

if  (WISpySIOBserv.value = false)then begin
      RSSIO4B.visible := False;
      commsiobname.visible:=False;
      CPUBbypass.visible:= False;
     WISIOB4disa.Visible := false;
     WISIOBCH4.Visible := False;
     if  (WISpySIOAserv.value = false)then
     WPSIOCOM.TabVisible:=False;
     if (WComPort2Type.Value<> 2) then  begin
      GComPort2Settings.Height := 70;
     PComPrt2printer.visible := false;
     M2GEN.visible := False;
     end;

     end;
if  (WISpySIOBserv.value = True)then begin
      RSSIO4B.visible := True;
     WISIOB4disa.Visible := true;
     if      (WComPort2Type.Value = 2) then
              GComPort2Settings.Height := 190;
     if      ( WISIOB4disa.Value = true) then
              GComPort2Settings.Height := 190;

     commsiobname.visible:=True;
     CPUBbypass.visible:= True;
      WPSIOCOM.TabVisible:=True;
      WISIOBCH4.Visible := True;
     end;

end;


procedure TFProgramMode.WISIOB4disaValueChange(Sender: TObject);
begin
     if        WISIOB4disa.Value = True then begin
               PComPrt2printer.visible:= False;
               M2GEN.visible := False;
               GComPort2Settings.Height := 70;
     end;

     if        WISIOB4disa.Value = False then begin
               PComPrt2printer.visible:= True;
               M2GEN.visible := True;
               M2SET_R.visible:=False;
               GComPort2Settings.Height := 190;
     end;

end;

procedure TFProgramMode.WISpySIOAservValueChange(Sender: TObject);
begin
     if  (WISpySIOAserv.value = false)then begin
      RSSIO3A.visible := False;
      commsioaname.visible:=False;
      CPUAbypass.visible:=False;
       WISIOACH4.Visible := False;
       if  (WISpySIOBserv.value = false)then
     WPSIOCOM.TabVisible:=False;
      end;
      if  (WISpySIOAserv.value = True)then begin
      RSSIO3A.visible := True;
      commsioaname.visible:= True;
       CPUAbypass.visible:=True;
       WPSIOCOM.TabVisible:=True;
        WISIOACH4.Visible := True;
      end;


end;

procedure TFProgramMode.WSIOAPort4TypeChange(Sender: TObject);
begin
case WSIOAPort4Type.EnumValue of
    0,1: begin
            WISIOAP4.Visible := False;
             RSSIO4A.visible := False;
             M2SET_R.Visible:= False;
         end;
      2: begin
          WISIOAP4.Visible := True;
          RSSIO4A.visible := True;
          if PComPrt2printer.visible= False   then
          M2SET_R.Visible:= True;

         end;
      3: begin
          WISIOAP4.Visible := False;
          RSSIO4A.visible := True;
          M2SET_R.Visible:= False;
          end;

 end;
end;

procedure TFProgramMode.WSIObPort4TypeChange(Sender: TObject);
begin
 case WSIOBPort4Type.EnumValue of
    0,1: begin
            WISIOBP4.Visible := False;
            RSSIO3B.Visible:=False;
            M1SET_R.Visible:= False;

         end;
      2: begin
          WISIOBP4.Visible := True;
          RSSIO3B.Visible:= True;
          if WComPort1Type.Value = 1 then
          M1SET_R.Visible:= True;


         end;
      3: begin
          WISIOBP4.Visible := False;
          RSSIO3B.Visible:= True;
          M1SET_R.Visible:= False;
          end;
end;


end;



procedure TFProgramMode.WItypeValueChange(Sender: TObject);
begin
 case WItype.Value of
    0,1: begin
             WPExtractionControl.TabVisible := False;
             WPExtractionSteamMap.TabVisible := False;
             WPAdmissionControl.TabVisible := False;
             WPAdmissionSteamMap.TabVisible := False;
             WPExtrAdmControl.TabVisible := False;
             WPExtrAdmSteamMap.TabVisible := False;
             WILPselection.Visible :=False;

           end;
        2: begin
             WPExtractionControl.TabVisible := True;
             WPAdmissionControl.TabVisible := False;
             WPAdmissionSteamMap.TabVisible := False;
             WPExtrAdmControl.TabVisible := False;
             WPExtrAdmSteamMap.TabVisible := False;
             WILPselection.Visible :=True;
           end;
        3,4: begin
             WPExtractionControl.TabVisible := False;
             WPExtractionSteamMap.TabVisible := False;
             WPAdmissionControl.TabVisible := True;
             WPExtrAdmControl.TabVisible := False;
             WPExtrAdmSteamMap.TabVisible := False;
             WILPselection.Visible :=True;
           end;
        5,6: begin
             WPExtractionControl.TabVisible := False;
             WPExtractionSteamMap.TabVisible := False;
             WPAdmissionControl.TabVisible := False;
             WPAdmissionSteamMap.TabVisible := False;
             WPExtrAdmControl.TabVisible := True;
             WILPselection.Visible :=True;
           end;
  end;
  HandleTurbineType(Sender);

end;

procedure TFProgramMode.WRatioLimiterModeValueChange(Sender: TObject);
begin
case WRatioLimiterMode.Value of
 0,1: begin
           WPDCPLControl.TabVisible := False;
         end;
      2,3: begin
           //WPDCPLControl.Caption := AuxControlStr;
           WPDCPLControl.TabVisible := True;
         end;
      4: begin
           WPDCPLControl.TabVisible := False;
         end;
      end;
end;

procedure TFProgramMode.WStartRoutineValueChange(Sender: TObject);
begin
   case WStartRoutine.Value of
 0,1,2: begin
           WIstickyrotor.Visible := True;
         end;
      3: begin
           WIstickyrotor.Visible := False;
         end;
      end;
end;

procedure TFProgramMode.WIfixerate1ValueChange(Sender: TObject);
begin
  if WIfixerate1.Value then begin

        WCriticalRate.Visible := True;
        LCriticalRate.Visible := True;
        LCriticalRateUnits.Visible := True;
        
  end
  Else begin
        LCriticalRate.Visible := False;
        LCriticalRateUnits.Visible := False;
        WCriticalRate.Visible := False
  end

end;

procedure TFProgramMode.WIfixerate2ValueChange(Sender: TObject);
begin
   if WIfixerate2.Value then begin

        WCriticalRate2.Visible := True;
         LCriticalRate2.Visible := True;
        LCriticalRateUnits2.Visible := True;
  end
  Else begin
        LCriticalRate2.Visible := False;
        LCriticalRateUnits2.Visible := False;
        WCriticalRate2.Visible := False
  end

end;



procedure TFProgramMode.WuseremhotcoldValueChange(Sender: TObject);
begin
      if  Wuseremhotcold.Value then
      WIremtimer.Visible := True
      else
       WIremtimer.Visible := False;
end;

procedure TFProgramMode.WusehidleValueChange(Sender: TObject);
begin
 if Wusehidle.Value then begin
    GAutoSequencegotohilde.Visible := True;
    if  GAutoSequencegotohilde.Visible then
    WIGAutoSequenceathilde.Visible := True;
    
    end
    else begin
    GAutoSequenceathhidle.Visible :=False;
    GAutoSequencegotohhidle.Visible := False;
    WIGAutoSequenceathilde.Visible := False;
    GAutoSequencegotohilde.Visible := False;



    end
end;

procedure TFProgramMode.WusehhidleValueChange(Sender: TObject);
begin
if Wusehhidle.Value and WIGAutoSequenceathilde.Visible then begin
   GAutoSequencegotohhidle.Visible := True;
   if  GAutoSequencegotohhidle.Visible then
   GAutoSequenceathhidle.Visible:= True;

   end
   else begin
   GAutoSequenceathhidle.Visible := False;
   GAutoSequencegotohhidle.Visible := False;

   end
end;

procedure TFProgramMode.WusedeadbandValueChange(Sender: TObject);
begin
   if Wusedeadband.Value then begin
      Wspeeddb.Visible := True;
      Lspeeddb.Visible := True;
      Lunitdb.Visible := True;
      Wdbdcpl.Visible := True;
      end
      else begin
      Wspeeddb.Visible := False;
      Lspeeddb.Visible := False;
      Lunitdb.Visible := False;
      Wdbdcpl.Visible := False;
      end


end;

procedure TFProgramMode.WdcplValueChange(Sender: TObject);
begin
if  (Wdcpl.Value > 1) and (WItype.Value > 1)and Wusedeadband.Value then  begin
 Wdbdcpl.Visible := True;
 end
end;



procedure TFProgramMode.WSpeedInput4ValueChange(Sender: TObject);
begin
if  WSpeedInput4.value = 1  then begin
    Wmaxnullspeed.Visible := True;
    Lmaxnull.Visible := True;
    Lwarningnullspeed.Visible := True;
    Wdlyon.Visible := True;
    Wnullofflevel.Visible := True;
    Ldlyzero.Visible := True;
    Lnullof.Visible :=True;
    Lseconds4.Visible :=True;
    Lrpm5.Visible :=True;
    end
    else begin
    Wmaxnullspeed.Visible := False;
    Lmaxnull.Visible := False;
    Lwarningnullspeed.Visible := False;
    Wdlyon.Visible := False;
    Wnullofflevel.Visible := False;
    Ldlyzero.Visible := False;
    Lnullof.Visible := False;
    Lseconds4.Visible :=False;
    Lrpm5.Visible :=False;
    end

end;


procedure TFProgramMode.WuseundertripValueChange(Sender: TObject);
begin
    if  Wuseundertrip.Value then  begin
    Ltripunder.Visible := True;
    W5undertrip.Visible := True;
    end
    else begin
    Ltripunder.Visible := False;
    W5undertrip.Visible := False;
    end
end;

procedure TFProgramMode.WIuseunderspeedValueChange(Sender: TObject);
begin
     if WIuseunderspeed.Value then begin
       WIunderspeed.Height := 102;
     end
     else begin WIunderspeed.Height := 38;
     end
end;



procedure TFProgramMode.WnofwValueChange(Sender: TObject);
begin
if   Wnofw.Value then begin
     Wcasfwdroop.Visible:= False;
     Lrancasfwdb.Visible := False;
     Lcadbfw.visible := False;
     end
     else begin
     Wcasfwdroop.Visible:= True;
     Lrancasfwdb.Visible := True;
     Lcadbfw.visible := True;
     end

end;

procedure TFProgramMode.WIHP1rangeValueChange(Sender: TObject);
begin
     if   WIHP1range.Value = 0 then begin
     Whp20160.Visible :=False;
     Whp420.Visible := True;
     end
     else begin
     Whp20160.Visible :=True;
     Whp420.Visible := True;
     end

end;


procedure TFProgramMode.WIHP2rangeValueChange(Sender: TObject);
begin
  if   WIHP1range.Value = 0 then begin
     Whp201602.Visible :=False;
     Whp4202.Visible := True;
     end
     else begin
     Whp201602.Visible :=True;
     Whp4202.Visible := True;
     end

end;

procedure TFProgramMode.WhhdfbktypeValueChange(Sender: TObject);
begin
    case Whhdfbktype.EnumValue of

      1: begin
         WIprop.Visible := True;
         WIPI.Visible := False;
         WIP.Visible := False;
         WPILAG.Visible := False;
         WPILEADLAG.Visible := False;
         end;
      2: begin
         WIprop.Visible := False;
         WIPI.Visible := True;
         WIP.Visible := False;
         WPILAG.Visible := False;
         WPILEADLAG.Visible := False;
         end;
      3: begin
         WIprop.Visible := False;
         WIPI.Visible := False;
         WIP.Visible := True;
         WPILAG.Visible := False;
         WPILEADLAG.Visible := False;
         end;
      4: begin
         WIprop.Visible := False;
         WIPI.Visible := False;
         WIP.Visible := False;
         WPILAG.Visible := True;
         WPILEADLAG.Visible := False;
         end;
      5: begin
         WIprop.Visible := False;
         WIPI.Visible := False;
         WIP.Visible := False;
         WPILAG.Visible := False;
         WPILEADLAG.Visible := True;
         end;


    end;



end;






procedure TFProgramMode.WItwohpValueChange(Sender: TObject);
begin
     if  WItwohp.Value then begin
         WIHP2selection.Visible := True;
     end
     else begin
     WIHP2selection.Visible := False;
     end
     
end;

procedure TFProgramMode.Whhdfbktypehp2ValueChange(Sender: TObject);
begin
  case Whhdfbktypehp2.EnumValue of

      1: begin
         WProphp2.Visible := True;
         WPIhp2.Visible := False;
         wphp2.Visible := False;
         WPILLAGhp2.Visible := False;
         WPILEADhp2LAG.Visible := False;
         end;
      2: begin
          WProphp2.Visible := False;
         WPIhp2.Visible := True;
         wphp2.Visible := False;
         WPILLAGhp2.Visible := False;
         WPILEADhp2LAG.Visible := False;
         end;
      3: begin
         WProphp2.Visible := False;
         WPIhp2.Visible := False;
         wphp2.Visible := True;
         WPILLAGhp2.Visible := False;
         WPILEADhp2LAG.Visible := False;
         end;
      4: begin
         WProphp2.Visible := False;
         WPIhp2.Visible := False;
         wphp2.Visible := False;
         WPILLAGhp2.Visible := True;
         WPILEADhp2LAG.Visible := False;
         end;
      5: begin
         WProphp2.Visible := False;
         WPIhp2.Visible := False;
         wphp2.Visible := False;
         WPILLAGhp2.Visible := False;
         WPILEADhp2LAG.Visible := True;
         end;

      end;
end;



procedure TFProgramMode.WIspyact1ValueChange(Sender: TObject);
begin
   if   WIspyact1.Value and WIHPselection.Visible then begin
        if WIselhpvalve.Value = 2 then
        WHPact1.Visible := True;
        if WIHP2selection.visible and  (Whp2sel.Value = 2) then
        WHPact1.Visible := True;
        if WILPselection.visible and  (Wlpsel.Value = 2) then
        WHPact1.Visible := True;
        if WILP2selection.visible and  (Wlp2sel.Value = 2) then
        WHPact1.Visible := True;
   end
   else begin
   WHPact1.Visible := False;
   end
   
end;

procedure TFProgramMode.wspyact2ValueChange(Sender: TObject);
begin
     if   wspyact2.Value then begin
       if WIselhpvalve.Value = 3 then
        WHPact2.Visible := True;
        if WIHP2selection.visible and  (Whp2sel.Value = 3) then
        WHPact2.Visible := True;
        if WILPselection.visible and  (Wlpsel.Value = 3) then
        WHPact2.Visible := True;
        if WILP2selection.visible and  (Wlp2sel.Value = 3) then
        WHPact2.Visible := True;
        end
     else begin
     WHPact2.Visible := False;
     end

     
end;

procedure TFProgramMode.Wspyact1fbValueChange(Sender: TObject);
begin
    if   Wspyact1fb.Value then
         WHPact1fdbk.Visible := True
         else
         WHPact1fdbk.Visible := False;
end;

procedure TFProgramMode.Wspyact2fbValueChange(Sender: TObject);
begin
      if  Wspyact2fb.Value then
      WHPact2fdbk.Visible := True
      else
      WHPact2fdbk.Visible := False;
      
end;


procedure TFProgramMode.WIspylp2ValueChange(Sender: TObject);
begin
 if   WIspylp2.Value = True then  WILP2selection.Visible := True
 else  WILP2selection.Visible := False;
end;



procedure TFProgramMode.Whp2selValueChange(Sender: TObject);
begin
sleep(160);
    if  (Whp2sel.Value = WIselhpvalve.Value) then
        Whp2sel.Value := 1;
     if  (Whp2sel.Value = Wlpsel.Value) and  (WItype.Value > 1)  then
          Whp2sel.Value := 1;
end;

procedure TFProgramMode.WlpselValueChange(Sender: TObject);
begin
    if  (Wlpsel.Value = WIselhpvalve.Value) then
        Wlpsel.Value := 1;
    if  (Whp2sel.Value = Wlpsel.Value)and (WItype.Value > 1)  then
        Whp2sel.Value := 1;
    if (Wlp2sel.Value = Wlpsel.Value)and  (Wlpsel.Value >1) then
        Wlp2sel.Value := 1;


end;

procedure TFProgramMode.Wlp2selValueChange(Sender: TObject);
begin
      sleep(160);
      if (Wlp2sel.Value = WIselhpvalve.Value)
     then
       Wlp2sel.Value := 1;
       if (Wlp2sel.Value = Wlpsel.Value) and   (Wlpsel.Value >1)
     then
       Wlp2sel.Value := 1;

     if  (Wlp2sel.Value = Whp2sel.Value) and WItwohp.Value
     then
     Wlp2sel.Value := 1;

end;

procedure TFProgramMode.WIselhpvalveValueChange(Sender: TObject);
begin
sleep(160);
      if  (Wlpsel.Value = WIselhpvalve.Value) then
        Wlpsel.Value := 1;
      if  (Whp2sel.Value = WIselhpvalve.Value) then
        Whp2sel.Value := 1;
      if  (Wlp2sel.Value = WIselhpvalve.Value) then
        Wlp2sel.Value := 1;

end;

procedure TFProgramMode.WhpcompValueChange(Sender: TObject);
begin
 if    Whpcomp.Value
       then
       Whpcompensated.Visible := True
       else
       Whpcompensated.Visible := False;
end;

procedure TFProgramMode.WlpcompValueChange(Sender: TObject);
begin
 if     Wlpcomp.Value and  (WItype.Value > 1)
       then
       Wlpcompensated.Visible := True
       else
       Wlpcompensated.Visible := False;
end;

procedure TFProgramMode.Wspymon1ValueChange(Sender: TObject);
begin
   if Wspymon1.Value
   then   Wmonitor1.Visible := False
   else
   Wmonitor1.Visible := True;

end;

procedure TFProgramMode.Wspymon2ValueChange(Sender: TObject);
begin
   if Wspymon2.Value
   then   Wmonitor2.Visible := False
   else
   Wmonitor2.Visible := True;

end;

procedure TFProgramMode.Wspymon3ValueChange(Sender: TObject);
begin
   if Wspymon3.Value
   then   Wmonitor3.Visible := False
   else
   Wmonitor3.Visible := True;
end;

procedure TFProgramMode.Wspymon4ValueChange(Sender: TObject);
begin
   if Wspymon4.Value
   then   Wmonitor4.Visible := False
   else
   Wmonitor4.Visible := True;
end;


procedure TFProgramMode.Wlswen1ValueChange(Sender: TObject);
begin
   if  (Wlswen1.Value = 1)  then begin
   WIPlsw1.Visible := False;
   Wlevels1.Height := 40;
   end
   else begin
   Wlevels1.Height := 85;
   WIPlsw1.Visible := True;
   end

end;

procedure TFProgramMode.Wlswen2ValueChange(Sender: TObject);
begin
 if  (Wlswen2.Value = 1)  then  begin
   WIPlsw2.Visible := False;
   Wlevels2.Height := 40;
   end
   else begin
   Wlevels2.Height := 85;
   WIPlsw2.Visible := True;
   end

end;

procedure TFProgramMode.Wlswen3ValueChange(Sender: TObject);
begin
 if  (Wlswen3.Value = 1)  then  begin
   WIPlsw3.Visible := False;
    Wlevels3.Height := 40;
    end
   else begin
   Wlevels3.Height := 85;
   WIPlsw3.Visible := True;
   end

end;

procedure TFProgramMode.Wlswen4ValueChange(Sender: TObject);
begin
 if  (Wlswen4.Value = 1)  then begin
   WIPlsw4.Visible := False;
    Wlevels4.Height := 40;
   end
   else begin
   Wlevels4.Height := 85;
   WIPlsw4.Visible := True;
   end
end;


 procedure TFProgramMode.WReadout5OptionValueChange(Sender: TObject);
begin
  if (WReadout5Option.Value = 1) then
    PActuatorReadout1Values.Visible := False
  else
    PActuatorReadout1Values.Visible := True;
end;

procedure TFProgramMode.WReadout6OptionValueChange(Sender: TObject);
begin
  if (WReadout6Option.Value = 1) then
    PActuatorReadout2Values.Visible := False
  else
    PActuatorReadout2Values.Visible := True;
end;


procedure TFProgramMode.WIusered1ValueChange(Sender: TObject);
begin
if (WIusered1.Value = 1) then  begin
WPdualredund.Visible :=  True;
WPdualredund.TabVisible := true
end
else begin
WPdualredund.Visible :=  False;
WPdualredund.TabVisible := False
end
end;


procedure TFProgramMode.WIItemSpyact1ValueChange(Sender: TObject);
begin
if  WIItemSpyact1.value then
WIact1readout.Visible := True
else
WIact1readout.Visible := False;

end;

procedure TFProgramMode.WIItemSpyact2ValueChange(Sender: TObject);
begin
if  WIItemSpyact2.value then
WIact2readout.Visible := True
else
WIact2readout.Visible := False;

end;

procedure TFProgramMode.usepilot1ValueChange(Sender: TObject);
begin
if usepilot1.Value then   Wpilot1.Visible := true
else
Wpilot1.Visible := false;
end;

procedure TFProgramMode.usepilot2ValueChange(Sender: TObject);
begin
if usepilot2.Value then   Wpilot2.Visible := true
else
Wpilot2.Visible := false;
end;

procedure TFProgramMode.WremadmselValueChange(Sender: TObject);
begin
if Wremadmsel.Value then
Wremadm.Visible := True
else
Wremadm.Visible := False;

end;

procedure TFProgramMode.useestradmValueChange(Sender: TObject);
begin
if useestradm.Value then
WExtrAdmUseRemoteSetpoint.Visible := True
else
WExtrAdmUseRemoteSetpoint.Visible := False;
end;

procedure TFProgramMode.Wred1fdbkerrValueChange(Sender: TObject);
begin
if Wred1fdbkerr.Value then
Werrordly.Visible := true
else
Werrordly.Visible := false;
end;

procedure TFProgramMode.Wred2fdbkerrValueChange(Sender: TObject);
begin
if Wred2fdbkerr.Value then
Werrordly2.Visible := true
else
Werrordly2.Visible := false;
end;

procedure TFProgramMode.red1useaiaValueChange(Sender: TObject);
begin
if  red1useaia.Value then
    Waired1a.Visible := true
    else
    Waired1a.Visible := false;
end;

procedure TFProgramMode.red1useaibValueChange(Sender: TObject);
begin
if  red1useaib.Value then
    Waired1b.Visible := true
    else
    Waired1b.Visible := false;
end;

procedure TFProgramMode.red2useaiaValueChange(Sender: TObject);
begin
if  red2useaia.Value then
    Waired2a.Visible := true
    else
    Waired2a.Visible := false;
end;

procedure TFProgramMode.red2useaibValueChange(Sender: TObject);
begin
 if  red2useaib.Value then
    Waired2b.Visible := true
    else
    Waired2b.Visible := false;
end;

procedure TFProgramMode.Wautotest1ValueChange(Sender: TObject);
begin
if Wautotest1.Value then
Wred1autotest.Visible := True
else
Wred1autotest.Visible := false;
end;

procedure TFProgramMode.Wautotest2ValueChange(Sender: TObject);
begin
if Wautotest2.Value then
Wred2autotest.Visible := True
else
Wred2autotest.Visible := false;
end;

procedure TFProgramMode.Wselred2ValueChange(Sender: TObject);
begin
if Wselred2.Value then
Wred2.Visible := true
else
Wred2.Visible := false;

end;

procedure TFProgramMode.WIremdcplValueChange(Sender: TObject);
begin
if WIremdcpl.Value then
Wremdcpl.Visible := true
else
Wremdcpl.Visible := false;
end;

procedure TFProgramMode.WusefeedforwardValueChange(Sender: TObject);
begin
if  Wusefeedforward.EnumValue = 1 then
Pfeedforward.TabVisible := true
else
Pfeedforward.TabVisible := false;

end;

procedure TFProgramMode.wuseemrgencyValueChange(Sender: TObject);
begin
if wuseemrgency.Value and not Wusedirect.Value then
Wemergency.Visible := true
else
Wemergency.Visible := false;

end;

procedure TFProgramMode.WusedirectValueChange(Sender: TObject);
begin
if Wusedirect.Value then begin
wcontrolfw.Visible := false;
Wemergency.Visible := false
end
else begin
wcontrolfw.Visible := true;
if wuseemrgency.Value then  Wemergency.Visible := true
end;

end;


end.
