unit Pci_run;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  WIForms, ComCtrls, StdCtrls, Grids, ExtCtrls, Buttons, WIAlarmViewer,
  WIEventViewer, WLabel, WILabel, WSpinEdit, WISpinEdit, WIStringEdit,
  WIItemSpy, WIToggleButton, Spin, WMomentaryButton, WIServlinkItem,
  WIMomentaryButton, WIBoxLabel, WLinearGauge, WLinearNeedleGauge,
  WILinearNeedleGauge, WIDAMomentaryButton, WToggleButton, PCI_TimeDate,
  PCI_Speed, PCI_ExtAdm, PCI_Cascade, PCI_Auxiliary, PCI_OverspeedTest,
  WOneShotButton, WIOneShotButton, WIDAOneShotButton, W5009SpinEdit,
  WINumberEdit, W5009SpinTune, WStatusText, WIStatusText, WEnumComboBox,
  WIEnumComboBox;

type
  TFRunMode = class(TWIForm)
    WSpyAuxiliaryType: TWIItemSpy;
    WSpyRemoteSpeed: TWIItemSpy;
    WSpyRemoteExtAdm: TWIItemSpy;
    WSpyRemoteCascade: TWIItemSpy;
    WSpyRemoteAuxiliary: TWIItemSpy;
    WSpyCascadeType: TWIItemSpy;
    WSpyControlledShutdown: TWIItemSpy;
    WSpyHaltVisible: TWIItemSpy;
    WSpytRunning: TWIItemSpy;
    WPRunButtons: TWIPanel;
    PResetAlarmsButton: TWIPanel;
    POverspeedTestButton: TWIPanel;
    BOverspeedTest: TBitBtn;
    PSetTimeDateButton: TWIPanel;
    BSetTimeDate: TBitBtn;
    BResetAlarms: TWIOneShotButton;
    tRunTimer: TTimer;
    PShutdownButton: TWIPanel;
    WIDAOneShotButton1: TWIDAOneShotButton;
    PSecurityButton: TWIPanel;
    BSecurityUnlock: TBitBtn;
    BSecurityLock: TBitBtn;
    WSpyUseShutdown: TWIItemSpy;
    PageControl1: TWIPageControl;
    WPStartTurbine: TWITabSheet;
    WPStartSeqPanel: TWIPanel;
    WHaltButton: TWIMomentaryButton;
    WPShutdown: TWIPanel;
    WAbortButton: TWIMomentaryButton;
    WControlledShutdownButton: TWIDAOneShotButton;
    WPSpeedControl: TWITabSheet;
    WPRemoteSpeedSetpoint: TWIPanel;
    LSpeedRemoteSetpoint: TLabel;
    LSpeedRemoteSetpointUnits: TLabel;
    WSpeedRemoteSetpoint: TWIBoxLabel;
    WSpeedRemoteSetpointEnable: TWIMomentaryButton;
    WSpeedRemoteSetpointDisable: TWIMomentaryButton;
    WPSpeed: TWIPanel;
    LSpeedInput: TLabel;
    LSpeedInputUnits: TLabel;
    LSpeedSetpoint: TLabel;
    LSpeedPID: TLabel;
    LSpeedPIDUnits: TLabel;
    DCPL2: TLabel;
    WSpeedInput: TWIBoxLabel;
    WSpeedSetpoint: TWIBoxLabel;
    WSpeedSetpointRaise: TWIMomentaryButton;
    WSpeedSetpointLower: TWIMomentaryButton;
    WSpeedPID: TWIBoxLabel;
    BSpeedDynamics: TButton;
    WPExtrAdmCntrl: TWITabSheet;
    WPRemoteExtAdmSetpoint: TWIPanel;
    LExtAdmRemoteSetpoint: TLabel;
    WExtAdmRemoteSetpoint: TWIBoxLabel;
    WExtAdmRemoteSetpointEnable: TWIMomentaryButton;
    WExtAdmRemoteSetpointDisable: TWIMomentaryButton;
    WPExtAdm: TWIPanel;
    LExtAdmInput: TLabel;
    LExtAdmSetpoint: TLabel;
    LExtAdmPID: TLabel;
    LExtAdmPIDUnits: TLabel;
    WExtAdmInput: TWIBoxLabel;
    WExtAdmSetpoint: TWIBoxLabel;
    WExtAdmSetpointRaise: TWIMomentaryButton;
    WExtAdmSetpointLower: TWIMomentaryButton;
    WExtAdmPID: TWIBoxLabel;
    BExtAdmDynamics: TButton;
    WPExtAdmStatus: TWIPanel;
    LExtAdmStatus: TLabel;
    WExtAdmStatus: TWIBoxLabel;
    WExtAdmEnable: TWIMomentaryButton;
    WExtAdmDisable: TWIMomentaryButton;
    WPLPValveLimiter: TWIPanel;
    LLPValveLimiter: TLabel;
    LLPValveLimiterUnits: TLabel;
    WLPValveLimiter: TWIBoxLabel;
    WLPValveLimiterRaise: TWIMomentaryButton;
    WLPValveLimiterLower: TWIMomentaryButton;
    WPCascadeControl: TWITabSheet;
    WPRemoteCascadeSetpoint: TWIPanel;
    LCascadeRemoteSetpoint: TLabel;
    WCascadeRemoteSetpoint: TWIBoxLabel;
    WCascadeRemoteSetpointEnable: TWIMomentaryButton;
    WCascadeRemoteSetpointDisable: TWIMomentaryButton;
    WPCascade: TWIPanel;
    LCascadeInput: TLabel;
    LCascadeSetpoint: TLabel;
    LCascadePID: TLabel;
    LCascadePIDUnits: TLabel;
    WCascadeInput: TWIBoxLabel;
    WCascadeSetpoint: TWIBoxLabel;
    WCascadeSetpointRaise: TWIMomentaryButton;
    WCascadeSetpointLower: TWIMomentaryButton;
    WCascadePID: TWIBoxLabel;
    BCascadeDynamics: TButton;
    WPCascadeStatus: TWIPanel;
    LCascadeStatus: TLabel;
    WCascadeEnable: TWIMomentaryButton;
    WCascadeDisable: TWIMomentaryButton;
    WPdecouplingControl: TWITabSheet;
    WPRemoteAuxiliarySetpoint: TWIPanel;
    LAuxiliaryRemoteSetpoint: TLabel;
    WAuxiliaryRemoteSetpoint: TWIBoxLabel;
    WAuxiliaryRemoteSetpointEnable: TWIMomentaryButton;
    WAuxiliaryRemoteSetpointDisable: TWIMomentaryButton;
    WPdecoupling: TWIPanel;
    LAuxiliaryInput: TLabel;
    LAuxiliarySetpoint: TLabel;
    LAuxiliaryPID: TLabel;
    LAuxiliaryPIDUnits: TLabel;
    WAuxiliaryInput: TWIBoxLabel;
    WAuxiliarySetpoint: TWIBoxLabel;
    WAuxiliarySetpointRaise: TWIMomentaryButton;
    WAuxiliarySetpointLower: TWIMomentaryButton;
    WAuxiliaryPID: TWIBoxLabel;
    BAuxiliaryDynamics: TButton;
    Wrauxdm: TWIMomentaryButton;
    Wlauxdm: TWIMomentaryButton;
    WPAuxiliaryStatus: TWIPanel;
    LAuxiliaryStatus: TLabel;
    WAuxiliaryStatus: TWIBoxLabel;
    WAuxiliaryEnable: TWIMomentaryButton;
    WAuxiliaryDisable: TWIMomentaryButton;
    WPValves: TWITabSheet;
    WPStart: TWIPanel;
    LSpeed: TLabel;
    LSpeedUnits: TLabel;
    LSetpoint: TLabel;
    LHPValveLimiter: TLabel;
    LHPValveLimiterUnits: TLabel;
    WResetButton: TWIMomentaryButton;
    WSpeed: TWIBoxLabel;
    WSetpoint: TWIBoxLabel;
    WSetpointRaise: TWIMomentaryButton;
    WSetpointLower: TWIMomentaryButton;
    WHPValveLimiter: TWIBoxLabel;
    WHPValveLimiterRaise: TWIMomentaryButton;
    WHPValveLimiterLower: TWIMomentaryButton;
    WRunButton: TWIMomentaryButton;
    WStartSequenceStatus: TWIBoxLabel;
    LStartSequenceStatus: TLabel;
    Watidle: TWIPanel;
    WIBoxLabel1: TWIBoxLabel;
    Label1: TLabel;
    Label2: TLabel;
    WIBoxLabel2: TWIBoxLabel;
    Watmedium: TWIPanel;
    Label3: TLabel;
    Label4: TLabel;
    WIBoxLabel3: TWIBoxLabel;
    WIBoxLabel4: TWIBoxLabel;
    Wathigh: TWIPanel;
    Label5: TLabel;
    Label6: TLabel;
    WIBoxLabel5: TWIBoxLabel;
    WIBoxLabel6: TWIBoxLabel;
    WIatlowstep: TWIItemSpy;
    WIatlmediumstep: TWIItemSpy;
    WIatlhighstep: TWIItemSpy;
    WIStatusText16: TWIStatusText;
    Label7: TLabel;
    Label8: TLabel;
    WIStatusText1: TWIStatusText;
    WIStatusText2: TWIStatusText;
    Label9: TLabel;
    WIBoxLabel7: TWIBoxLabel;
    WIcomplete: TWIItemSpy;
    WContinueButton: TWIMomentaryButton;
    WIScrollvlv: TWIScrollBox;
    WIPanel1: TWIPanel;
    WIvalvetestsel: TWIEnumComboBox;
    WIstartvlvtest: TWIMomentaryButton;
    WIquitcal: TWIMomentaryButton;
    Wtestseq: TWIPanel;
    Wvlvtomin: TWIPanel;
    WIgotomin: TWIMomentaryButton;
    WIvlvtomax: TWIPanel;
    WIgotomax: TWIMomentaryButton;
    WIvlvtoman: TWIPanel;
    WIgotoman: TWIMomentaryButton;
    WIvlvcplted: TWIPanel;
    WIcompleted: TWIMomentaryButton;
    Endofvalv: TWIPanel;
    Wactuatorselected: TWIPanel;
    Wact1combo: TWIPanel;
    WMinControlSetpt: TW5009SpinEdit;
    Label10: TLabel;
    Wact1min4: TW5009SpinEdit;
    Wact1max20: TW5009SpinEdit;
    W5009SpinEdit3: TW5009SpinEdit;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    WIBoxLabel8: TWIBoxLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    Wact1min20: TW5009SpinEdit;
    Wact1max160: TW5009SpinEdit;
    WIspycurract1: TWIItemSpy;
    Wact2combo: TWIPanel;
    Label20: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    Label24: TLabel;
    Label25: TLabel;
    Label26: TLabel;
    Label27: TLabel;
    Label28: TLabel;
    Label29: TLabel;
    W5009SpinEdit1: TW5009SpinEdit;
    Wact2min4: TW5009SpinEdit;
    Wact2max20: TW5009SpinEdit;
    W5009SpinEdit5: TW5009SpinEdit;
    WIBoxLabel9: TWIBoxLabel;
    Wact2min20: TW5009SpinEdit;
    Wact2max160: TW5009SpinEdit;
    WIspycurract2: TWIItemSpy;
    Wa106_1: TWIPanel;
    Label40: TLabel;
    Label41: TLabel;
    WIPanel3: TWIPanel;
    WIa106_ch1man: TWIPanel;
    Label42: TLabel;
    Label43: TLabel;
    W5009SpinEdit8: TW5009SpinEdit;
    Label34: TLabel;
    Label35: TLabel;
    WIpropAch1: TWIPanel;
    W5009SpinEdit7: TW5009SpinEdit;
    Label36: TLabel;
    Label33: TLabel;
    Label32: TLabel;
    W5009SpinEdit6: TW5009SpinEdit;
    Label37: TLabel;
    Label31: TLabel;
    W5009SpinEdit4: TW5009SpinEdit;
    Label38: TLabel;
    Label30: TLabel;
    WIintAch1: TWIPanel;
    Label39: TLabel;
    Label44: TLabel;
    Label45: TLabel;
    Label46: TLabel;
    Label47: TLabel;
    Label48: TLabel;
    W5009SpinEdit2: TW5009SpinEdit;
    W5009SpinEdit9: TW5009SpinEdit;
    W5009SpinEdit10: TW5009SpinEdit;
    Label49: TLabel;
    Label50: TLabel;
    WIMomentaryButton6: TWIMomentaryButton;
    WIMomentaryButton7: TWIMomentaryButton;
    WIBoxLabel13: TWIBoxLabel;
    Label53: TLabel;
    Label54: TLabel;
    WIBoxLabel15: TWIBoxLabel;
    Label57: TLabel;
    Label58: TLabel;
    WIBoxLabel16: TWIBoxLabel;
    Label59: TLabel;
    Label61: TLabel;
    WIalvdt2: TWIPanel;
    Label55: TLabel;
    WIBoxLabel14: TWIBoxLabel;
    Label56: TLabel;
    Label60: TLabel;
    WIBoxLabel17: TWIBoxLabel;
    Label62: TLabel;
    Wc106_1: TWIPanel;
    WIPanel6: TWIPanel;
    Label63: TLabel;
    Label64: TLabel;
    Label65: TLabel;
    Label68: TLabel;
    Label69: TLabel;
    WIc106_ch1man: TWIPanel;
    Label70: TLabel;
    Label71: TLabel;
    W5009SpinEdit11: TW5009SpinEdit;
    WIpropCch1: TWIPanel;
    Label72: TLabel;
    Label73: TLabel;
    Label74: TLabel;
    Label75: TLabel;
    Label76: TLabel;
    Label77: TLabel;
    W5009SpinEdit12: TW5009SpinEdit;
    W5009SpinEdit13: TW5009SpinEdit;
    W5009SpinEdit14: TW5009SpinEdit;
    WIintCch1: TWIPanel;
    Label78: TLabel;
    Label79: TLabel;
    Label80: TLabel;
    Label81: TLabel;
    Label82: TLabel;
    Label83: TLabel;
    Label84: TLabel;
    Label85: TLabel;
    Label86: TLabel;
    Label87: TLabel;
    Label88: TLabel;
    Label89: TLabel;
    W5009SpinEdit15: TW5009SpinEdit;
    W5009SpinEdit16: TW5009SpinEdit;
    W5009SpinEdit17: TW5009SpinEdit;
    WIMomentaryButton8: TWIMomentaryButton;
    WIMomentaryButton9: TWIMomentaryButton;
    WIBoxLabel22: TWIBoxLabel;
    WIBoxLabel23: TWIBoxLabel;
    WIclvdt2: TWIPanel;
    Label90: TLabel;
    Label91: TLabel;
    Label92: TLabel;
    Label93: TLabel;
    W5009SpinEdit19: TW5009SpinEdit;
    Label96: TLabel;
    Label97: TLabel;
    WIBoxLabel19: TWIBoxLabel;
    Label66: TLabel;
    Label67: TLabel;
    WIBoxLabel12: TWIBoxLabel;
    Label51: TLabel;
    Label52: TLabel;
    Wa106_2: TWIPanel;
    WIPanel5: TWIPanel;
    Label98: TLabel;
    Label99: TLabel;
    Label100: TLabel;
    Label101: TLabel;
    Label102: TLabel;
    WIBoxLabel24: TWIBoxLabel;
    WIBoxLabel25: TWIBoxLabel;
    WIa106_ch2man: TWIPanel;
    Label103: TLabel;
    Label104: TLabel;
    Label105: TLabel;
    Label106: TLabel;
    W5009SpinEdit20: TW5009SpinEdit;
    WIBoxLabel26: TWIBoxLabel;
    WIpropAch2: TWIPanel;
    Label107: TLabel;
    Label108: TLabel;
    Label109: TLabel;
    Label110: TLabel;
    Label111: TLabel;
    Label112: TLabel;
    W5009SpinEdit21: TW5009SpinEdit;
    W5009SpinEdit22: TW5009SpinEdit;
    W5009SpinEdit23: TW5009SpinEdit;
    WIintAch2: TWIPanel;
    Label113: TLabel;
    Label114: TLabel;
    Label115: TLabel;
    Label116: TLabel;
    Label117: TLabel;
    Label118: TLabel;
    Label119: TLabel;
    Label120: TLabel;
    Label121: TLabel;
    Label122: TLabel;
    Label123: TLabel;
    Label124: TLabel;
    Label125: TLabel;
    Label126: TLabel;
    W5009SpinEdit24: TW5009SpinEdit;
    W5009SpinEdit25: TW5009SpinEdit;
    W5009SpinEdit26: TW5009SpinEdit;
    WIBoxLabel27: TWIBoxLabel;
    WIMomentaryButton10: TWIMomentaryButton;
    WIMomentaryButton11: TWIMomentaryButton;
    WIBoxLabel28: TWIBoxLabel;
    WIBoxLabel29: TWIBoxLabel;
    WIa2lvdt2: TWIPanel;
    Label127: TLabel;
    Label128: TLabel;
    Label129: TLabel;
    Label130: TLabel;
    W5009SpinEdit27: TW5009SpinEdit;
    Wc106_2: TWIPanel;
    WIPanel7: TWIPanel;
    Label131: TLabel;
    Label132: TLabel;
    Label133: TLabel;
    Label134: TLabel;
    Label135: TLabel;
    WIBoxLabel30: TWIBoxLabel;
    WIBoxLabel31: TWIBoxLabel;
    WIc106_ch2man: TWIPanel;
    Label136: TLabel;
    Label137: TLabel;
    Label138: TLabel;
    Label139: TLabel;
    W5009SpinEdit28: TW5009SpinEdit;
    WIBoxLabel32: TWIBoxLabel;
    WIpropCch2: TWIPanel;
    Label140: TLabel;
    Label141: TLabel;
    Label142: TLabel;
    Label143: TLabel;
    Label144: TLabel;
    Label145: TLabel;
    W5009SpinEdit29: TW5009SpinEdit;
    W5009SpinEdit30: TW5009SpinEdit;
    W5009SpinEdit31: TW5009SpinEdit;
    WIintCch2: TWIPanel;
    Label146: TLabel;
    Label147: TLabel;
    Label148: TLabel;
    Label149: TLabel;
    Label150: TLabel;
    Label151: TLabel;
    Label152: TLabel;
    Label153: TLabel;
    Label154: TLabel;
    Label155: TLabel;
    Label156: TLabel;
    Label157: TLabel;
    W5009SpinEdit32: TW5009SpinEdit;
    W5009SpinEdit33: TW5009SpinEdit;
    W5009SpinEdit34: TW5009SpinEdit;
    WIBoxLabel33: TWIBoxLabel;
    WIMomentaryButton12: TWIMomentaryButton;
    WIMomentaryButton13: TWIMomentaryButton;
    WIBoxLabel34: TWIBoxLabel;
    WIBoxLabel35: TWIBoxLabel;
    WIc2lvdt2: TWIPanel;
    Label160: TLabel;
    Label161: TLabel;
    Label162: TLabel;
    Label163: TLabel;
    Wspyvalvetested: TWIItemSpy;
    Wspyteststepnumber: TWIItemSpy;
    Wspyact1prop: TWIItemSpy;
    Wspyact2prop: TWIItemSpy;
    WIact1used: TWIItemSpy;
    WIact2used: TWIItemSpy;
    WIactfb1used: TWIItemSpy;
    WIactfb2used: TWIItemSpy;
    WIPanel2: TWIPanel;
    WIBoxLabel36: TWIBoxLabel;
    Label164: TLabel;
    Label165: TLabel;
    usehp2: TWIPanel;
    Label166: TLabel;
    Label167: TLabel;
    WIBoxLabel37: TWIBoxLabel;
    Wuselp: TWIPanel;
    Label168: TLabel;
    Label169: TLabel;
    WIBoxLabel38: TWIBoxLabel;
    uselp2: TWIPanel;
    Label170: TLabel;
    Label171: TLabel;
    WIBoxLabel39: TWIBoxLabel;
    WIextrturb: TWIItemSpy;
    WIspyusehp2: TWIItemSpy;
    WIspylp2: TWIItemSpy;
    WIspya106lvdt2: TWIItemSpy;
    WIspyc106lvdt2: TWIItemSpy;
    WIspy2a106lvdt2: TWIItemSpy;
    WIspy2c106lvdt2: TWIItemSpy;
    WIBoxLabel40: TWIBoxLabel;
    WIBoxLabel11: TWIBoxLabel;
    WIBoxLabel10: TWIBoxLabel;
    WIBoxLabel21: TWIBoxLabel;
    WIBoxLabel18: TWIBoxLabel;
    WhpPIlot: TWIPanel;
    Label172: TLabel;
    WIBoxLabel20: TWIBoxLabel;
    Lhpdegrated: TLabel;
    WIhpliot: TWIItemSpy;
    WIhpdeg: TWIItemSpy;
    WlpPIlot: TWIPanel;
    Label174: TLabel;
    Llpdegrated: TLabel;
    WIBoxLabel41: TWIBoxLabel;
    WIlpliot: TWIItemSpy;
    WIlpdeg: TWIItemSpy;
    Whpfdbk: TWIPanel;
    Label176: TLabel;
    Label177: TLabel;
    WIBoxLabel42: TWIBoxLabel;
    Wlpfdbk: TWIPanel;
    Label178: TLabel;
    Label179: TLabel;
    WIBoxLabel43: TWIBoxLabel;
    WIusedfdbk: TWIItemSpy;
    WHPchk: TWIItemSpy;
    WLPchk: TWIItemSpy;
    Label180: TLabel;
    WIBoxLabel44: TWIBoxLabel;
    WIMomentaryButton1: TWIMomentaryButton;
    WIMomentaryButton2: TWIMomentaryButton;
    WIBoxLabel45: TWIBoxLabel;
    WIBoxLabel46: TWIBoxLabel;
    WIMomentaryButton3: TWIMomentaryButton;
    WIMomentaryButton4: TWIMomentaryButton;
    Label181: TLabel;
    Label182: TLabel;
    WIMomentaryButton5: TWIMomentaryButton;
    WIMomentaryButton14: TWIMomentaryButton;
    WIBoxLabel47: TWIBoxLabel;
    Label183: TLabel;
    WIMomentaryButton15: TWIMomentaryButton;
    WIMomentaryButton16: TWIMomentaryButton;
    WIBoxLabel48: TWIBoxLabel;
    Label184: TLabel;
    WIMomentaryButton17: TWIMomentaryButton;
    WIMomentaryButton18: TWIMomentaryButton;
    Label185: TLabel;
    WIBoxLabel49: TWIBoxLabel;
    WIMomentaryButton19: TWIMomentaryButton;
    WIMomentaryButton20: TWIMomentaryButton;
    WIBoxLabel50: TWIBoxLabel;
    Label186: TLabel;
    WIMomentaryButton21: TWIMomentaryButton;
    WIMomentaryButton22: TWIMomentaryButton;
    Label187: TLabel;
    WIBoxLabel51: TWIBoxLabel;
    WIMomentaryButton23: TWIMomentaryButton;
    WIMomentaryButton24: TWIMomentaryButton;
    WIBoxLabel52: TWIBoxLabel;
    Label188: TLabel;
    WIMomentaryButton25: TWIMomentaryButton;
    WIMomentaryButton26: TWIMomentaryButton;
    Label189: TLabel;
    WIBoxLabel53: TWIBoxLabel;
    WIMomentaryButton27: TWIMomentaryButton;
    WIMomentaryButton28: TWIMomentaryButton;
    WIBoxLabel54: TWIBoxLabel;
    Label190: TLabel;
    WIMomentaryButton29: TWIMomentaryButton;
    WIMomentaryButton30: TWIMomentaryButton;
    Label191: TLabel;
    WIBoxLabel55: TWIBoxLabel;
    WIMomentaryButton31: TWIMomentaryButton;
    WIMomentaryButton32: TWIMomentaryButton;
    sample: TWIMomentaryButton;
    W5009SpinEdit36: TW5009SpinEdit;
    W5009SpinEdit37: TW5009SpinEdit;
    Label173: TLabel;
    Label175: TLabel;
    Wextrman: TWIMomentaryButton;
    Wextrauto: TWIMomentaryButton;
    WIMomentaryButton35: TWIMomentaryButton;
    WIMomentaryButton36: TWIMomentaryButton;
    Wetrack: TWIMomentaryButton;
    Wenottrack: TWIMomentaryButton;
    WIspytrackextr: TWIItemSpy;
    Label192: TLabel;
    WIauxman: TWIMomentaryButton;
    WIauxauto: TWIMomentaryButton;
    Label193: TLabel;
    dcpltrack: TWIMomentaryButton;
    dcplnottrack: TWIMomentaryButton;
    WIspydcpltrack: TWIItemSpy;
    WForward: TWIPanel;
    Label194: TLabel;
    Label195: TLabel;
    WIStatusText3: TWIStatusText;
    WIBoxLabel56: TWIBoxLabel;
    WIMomentaryButton37: TWIMomentaryButton;
    WIMomentaryButton38: TWIMomentaryButton;
    WIspyfw: TWIItemSpy;
    Wred1: TWIPanel;
    Label196: TLabel;
    WIStatusred1: TWIStatusText;
    red1selB: TWIMomentaryButton;
    red1selA: TWIMomentaryButton;
    WIStatusText4: TWIStatusText;
    WIStatusText5: TWIStatusText;
    Wred2: TWIPanel;
    Label197: TLabel;
    WIStatusText6: TWIStatusText;
    WIStatusText7: TWIStatusText;
    WIStatusText8: TWIStatusText;
    WIMomentaryButton39: TWIMomentaryButton;
    WIMomentaryButton40: TWIMomentaryButton;
    WIStatusText9: TWIStatusText;
    WIStatusText10: TWIStatusText;
    WIStatusText11: TWIStatusText;
    WIStatusText12: TWIStatusText;
    WIStatusText13: TWIStatusText;
    WIStatusText14: TWIStatusText;
    Wspyred1: TWIItemSpy;
    Wspyred2: TWIItemSpy;
    Wcastrack: TWIMomentaryButton;
    Wcasnotrack: TWIMomentaryButton;
    WIcascadetrack: TWIItemSpy;
    WIspyextman: TWIItemSpy;
    Wspydcplauto: TWIItemSpy;
    WlagdegHP: TW5009SpinEdit;
    LlagHPdeg: TLabel;
    WleaddegHP: TW5009SpinEdit;
    LleadHPdeg: TLabel;
    WlagdegLP: TW5009SpinEdit;
    WleaddegLP: TW5009SpinEdit;
    LlagLPdeg: TLabel;
    LleadLPdeg: TLabel;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormActivate(Sender: TObject);
    procedure PageControl1Enter(Sender: TObject);
    procedure PageControl1Exit(Sender: TObject);
    procedure UpdateFormCaption;
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure BSpeedDynamicsClick(Sender: TObject);
    procedure BExtAdmDynamicsClick(Sender: TObject);
    procedure BCascadeDynamicsClick(Sender: TObject);
    procedure BAuxiliaryDynamicsClick(Sender: TObject);
    procedure WSpyAuxiliaryTypeValueChange(Sender: TObject);
    procedure WSpyCascadeTypeValueChange(Sender: TObject);
    procedure WSpyRemoteSpeedValueChange(Sender: TObject);
    procedure WSpyRemoteExtAdmValueChange(Sender: TObject);
    procedure WSpyRemoteCascadeValueChange(Sender: TObject);
    procedure WSpyRemoteAuxiliaryValueChange(Sender: TObject);
    procedure WSpyControlledShutdownValueChange(Sender: TObject);
    procedure WSpyHaltVisibleValueChange(Sender: TObject);
    procedure WSpyIdleToRatedStateValueChange(Sender: TObject);
    procedure WSpytRunningValueChange(Sender: TObject);
    procedure BOverspeedTestClick(Sender: TObject);
    procedure WSpyAlarmTripClearValueChange(Sender: TObject);
    procedure BSetTimeDateClick(Sender: TObject);
    procedure BSecurityUnlockClick(Sender: TObject);
    procedure BSecurityLockClick(Sender: TObject);
    procedure Security(Secure: Boolean);
    procedure WSpyUseShutdownValueChange(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
    procedure PageControl1Change(Sender: TObject);
    procedure PageControl1Changing(Sender: TObject;
      var AllowChange: Boolean);
    procedure BRemoteMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure BLocalMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure WIatlowstepValueChange(Sender: TObject);
    procedure WIatlmediumstepValueChange(Sender: TObject);
    procedure WIatlhighstepValueChange(Sender: TObject);
    procedure WIcompleteValueChange(Sender: TObject);
    procedure WIspycurract1ValueChange(Sender: TObject);
    procedure WIspycurract2ValueChange(Sender: TObject);
    procedure WspyvalvetestedValueChange(Sender: TObject);
    procedure WspyteststepnumberValueChange(Sender: TObject);
    procedure Wspyact1propValueChange(Sender: TObject);
    procedure Wspyact2propValueChange(Sender: TObject);
    procedure WIvalvetestselChange(Sender: TObject);
    procedure WIextrturbValueChange(Sender: TObject);
    procedure e(Sender: TObject);
    procedure WIspylp2ValueChange(Sender: TObject);
    procedure WIspya106lvdt2ValueChange(Sender: TObject);
    procedure WIspyc106lvdt2ValueChange(Sender: TObject);
    procedure WIspy2a106lvdt2ValueChange(Sender: TObject);
    procedure WIspy2c106lvdt2ValueChange(Sender: TObject);
    procedure WIhpdegValueChange(Sender: TObject);
    procedure WIlpdegValueChange(Sender: TObject);
    procedure WIusedfdbkValueChange(Sender: TObject);
    procedure WHPchkValueChange(Sender: TObject);
    procedure WLPchkValueChange(Sender: TObject);
    procedure WIspytrackextrValueChange(Sender: TObject);
    procedure WIspydcpltrackValueChange(Sender: TObject);
    procedure WIspyfwValueChange(Sender: TObject);
    procedure Wspyred1ValueChange(Sender: TObject);
    procedure Wspyred2ValueChange(Sender: TObject);
    procedure WIcascadetrackValueChange(Sender: TObject);
    procedure WIspyextmanValueChange(Sender: TObject);
    procedure WspydcplautoValueChange(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FRunMode: TFRunMode = nil;
  ChangeRunMode: integer = 0;
  RModeWasMaximized: Boolean = False;
  UserResized: Boolean = False;
  RModeOldWidth,RModeOldHeight,RModeDefaultWidth,RModeDefaultHeight: integer;
  ResetCurrentAlarms: boolean = True;
  ResetAlarmHistory: boolean = True;
  ResetTripHistory: boolean = True;
  CurrentAlarmsCount: integer = 0;
  AlarmHistoryCount: integer = 0;
  TripHistoryCount: integer = 0;
  FSpeedDynamics: TFSpeedDynamics = nil;
  FExtAdmDynamics: TFExtAdmDynamics = nil;
  FCascadeDynamics: TFCascadeDynamics = nil;
  FAuxiliaryDynamics: TFAuxiliaryDynamics = nil;
  bGlobalSecure: boolean = TRUE;

const
  NotUsed = 99;
  sRunMode = 'Run Mode - ';
  sAuxControl = 'Auxiliary Control';
  sAuxLimiter = 'Auxiliary Limiter';
  sGAPCurrentAlarmMsgRoot = 'Y_ALARMS.ALARMS.MSG_O_';
  sGAPCurrentAlarmTimeRoot = 'Y_ALARMS.ALARMS.EV_TM_';
  sGAPNumCurrentAlarms = 'Y_ALARMS.ALARMS.NUM_EVENTS';
  sGAPAlarmHistoryMsgRoot = 'X_EVENTLOG.A.MESG_O_';
  sGAPAlarmHistoryTimeRoot = 'X_EVENTLOG.A.EV_TM_';
  sGAPTripHistoryMsgRoot = 'X_ELOG.T.MESG_O_';
  sGAPTripHistoryTimeRoot = 'X_ELOG.T.EV_TM_';
  sSync = 'Sync';
  sLoadshare = 'Loadshare';
  RunModePassword = '1111';

implementation

uses Pci_main;

{$R *.DFM}


procedure TFRunMode.UpdateFormCaption;
begin
  FRunMode.Caption := sRunMode + PageControl1.ActivePage.Caption;
end;


procedure TFRunMode.FormCreate(Sender: TObject);
begin
  PageControl1.ActivePage := WPStartTurbine;
//  WSpyTurbineType.LockOnAdvise := True;
//  WSpyIdleToRatedRoutine.LockOnAdvise := True;
//  WSpyNonExtractionStr.LockOnAdvise := True;
//  WSpyExtractionStr1.LockOnAdvise := True;
//  WSpyExtractionStr2.LockOnAdvise := True;
//  WSpyApplicationType.LockOnAdvise := True;
//  WSpyAuxiliaryType.LockOnAdvise := True;
//  WSpyRemoteSpeed.LockOnAdvise := True;
//  WSpyRemoteExtAdm.LockOnAdvise := True;
//  WSpyRemoteCascade.LockOnAdvise := True;
//  WSpyRemoteAuxiliary.LockOnAdvise := True;
//  WSpyCascadeType.LockOnAdvise := True;
//  WSpyUseFSP.LockOnAdvise := True;
//  WSpyControlledShutdown.LockOnAdvise := True;
//  WSpyHaltVisible.LockOnAdvise := True;
//  WSpyIdleToRatedState.LockOnAdvise := True;
//  WSpyNotRunning.LockOnAdvise := True;
//  WSpyHPLimiter.LockOnAdvise := True;
//  WSpyHPRampLimit.LockOnAdvise := True;
//  WSpyAlarmNum.LockOnAdvise := True;
//  WSpyAlarmTripClear.LockOnAdvise := True;
//  WSpyStartHold.LockOnAdvise := True;
//  WSpySync.LockOnAdvise := True;
//  WSpyLoadshare.LockOnAdvise := True;
//  WSpyFreqControl.LockOnAdvise := True;
  FSpeedDynamics := TFSpeedDynamics.Create(FRunMode);
  FExtAdmDynamics := TFExtAdmDynamics.Create(FRunMode);
  FCascadeDynamics := TFCascadeDynamics.Create(FRunMode);
  FAuxiliaryDynamics := TFAuxiliaryDynamics.Create(FRunMode);
  BSecurityLock.Visible := False;
  BSecurityUnlock.Visible := True;
  Security(True);
end;

procedure TFRunMode.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  //Action := caFree;
  Action := caNone; //allow fMain to close it
  fMain.Enabled := False;
  fMain.ShowStatus('Closing Run Mode');
  ChangeRunMode := CLOSE_MODE;
  fMain.tMain.Interval := 100;
  FMain.tMain.Enabled := True;
end;

procedure TFRunMode.FormActivate(Sender: TObject);
begin
  FMain.Run1.Checked := True;

  tRunTimer.Enabled := True;
end;

procedure TFRunMode.FormDeactivate(Sender: TObject);
begin
  tRunTimer.Enabled := False;
end;

procedure TFRunMode.PageControl1Enter(Sender: TObject);
begin
//
end;

procedure TFRunMode.PageControl1Exit(Sender: TObject);
begin
//  WValve1GoToMax.Visible := True;
//  WValve1GoToMin.Visible := True;
//  WValve1GoToManual.Visible := True;
//  WValve2GoToMax.Visible := True;
//  WValve2GoToMin.Visible := True;
//  WValve2GoToManual.Visible := True;
end;

procedure TFRunMode.FormResize(Sender: TObject);
begin
  if (FRunMode = nil)  then exit;
  if (FRunMode.WindowState = wsNormal) then
    begin
      if (not UserResized) then
        begin
          RModeOldWidth := FRunMode.Width;
          RModeOldHeight := FRunMode.Height;
        end
      else if RModeWasMaximized then
        begin
          RModeWasMaximized := False; {do not move this line of code}
          FRunMode.Width := RModeDefaultWidth;
          FRunMode.Height := RModeDefaultHeight;
          FRunMode.PageControl1.Align := alClient;
          FRunMode.PageControl1.Align := alNone;
          FRunMode.Width := RModeOldWidth;
          FRunMode.Height := RModeOldHeight;
          UserResized := False; {do not move this line of code}
        end;
    end
  else if (FRunMode.WindowState = wsMaximized) then
    begin
      RModeWasMaximized := True;
      UserResized := True;
      FRunMode.PageControl1.Align := alClient;
    end
  else
    RModeWasMaximized := False;

  fMain.tMain.Enabled := False;
  fMain.tMain.Enabled := True; //Tell main form to redraw itself appropriately
end;


procedure TFRunMode.BSpeedDynamicsClick(Sender: TObject);
begin
  FSpeedDynamics.Show;
  Security(BSecurityUnlock.Visible);
end;

procedure TFRunMode.BExtAdmDynamicsClick(Sender: TObject);
begin
  FExtAdmDynamics.Show;
  Security(BSecurityUnlock.Visible);
end;

procedure TFRunMode.BCascadeDynamicsClick(Sender: TObject);
begin
  FCascadeDynamics.Show;
  Security(BSecurityUnlock.Visible);
end;

procedure TFRunMode.BAuxiliaryDynamicsClick(Sender: TObject);
begin
  FAuxiliaryDynamics.Show;
  Security(BSecurityUnlock.Visible);
end;


procedure TFRunMode.WSpyAuxiliaryTypeValueChange(Sender: TObject);

begin
 WPdecouplingControl.TabVisible := WSpyAuxiliaryType.Value;

end;

procedure TFRunMode.WSpyCascadeTypeValueChange(Sender: TObject);
  var itype: Integer;
begin
  itype := StrToIntDef(WSpyCascadeType.Value, NotUsed);
  case itype of
      0: begin
           WPCascadeControl.TabVisible := False;
         end;
      1: begin
           WPCascadeControl.TabVisible := True;
         end;
  end;
end;

procedure TFRunMode.WSpyRemoteSpeedValueChange(Sender: TObject);
begin
  WPRemoteSpeedSetpoint.Visible := WSpyRemoteSpeed.Value;
end;

procedure TFRunMode.WSpyRemoteExtAdmValueChange(Sender: TObject);
begin
  WPRemoteExtAdmSetpoint.Visible := WSpyRemoteExtAdm.Value;
end;

procedure TFRunMode.WSpyRemoteCascadeValueChange(Sender: TObject);
begin
  WPRemoteCascadeSetpoint.Visible := WSpyRemoteCascade.Value;
end;

procedure TFRunMode.WSpyRemoteAuxiliaryValueChange(Sender: TObject);
begin
  WPRemoteAuxiliarySetpoint.Visible := WSpyRemoteAuxiliary.Value;
end;



procedure TFRunMode.WSpyControlledShutdownValueChange(Sender: TObject);
begin
  if (WSpyControlledShutdown.Value) then begin
      WControlledShutdownButton.Visible := False;
      WAbortButton.Visible := True;
      end
  else begin
       WControlledShutdownButton.Visible := True;
      WAbortButton.Visible := False;

    end;
end;

procedure TFRunMode.WSpyHaltVisibleValueChange(Sender: TObject);
begin
  if (WSpyHaltVisible.Value) then
    begin
      WHaltButton.Visible := True;
      WContinueButton.Visible := False;
    end
  else
    begin
      WHaltButton.Visible := False;
      WContinueButton.Visible := True;
    end;
end;

procedure TFRunMode.WSpyIdleToRatedStateValueChange(Sender: TObject);
//  var itype: Integer;
begin
//  itype := StrToIntDef(WSpyIdleToRatedState.Value, NotUsed);
//  if ((itype = 5) or (itype = 7)) then
//    WRatedButton.Visible := False
//  else
//    WRatedButton.Visible := True;
//  if ((itype = 3) or (itype = 6)) then
//    WIdleButton.Visible := False
//  else
//    WIdleButton.Visible := True;
end;

procedure TFRunMode.WSpytRunningValueChange(Sender: TObject);
begin
  WRunButton.Visible := not WSpytRunning.Value;
end;




procedure TFRunMode.BOverspeedTestClick(Sender: TObject);
var
  FOverspeedTest: TFOverspeedTest;
begin
  FOverspeedTest := TFOverspeedTest.Create(FRunMode);
  FOverspeedTest.Show;
end;


procedure TFRunMode.WSpyAlarmTripClearValueChange(Sender: TObject);
begin
  ResetCurrentAlarms := True;
  ResetAlarmHistory := True;
  ResetTripHistory := True;
//  tRunTimer.Enabled := True;
end;


procedure TFRunMode.BSetTimeDateClick(Sender: TObject);
var
  FTimeDate: TFTimeDate;
begin
  FTimeDate := TFTimeDate.Create(FRunMode);
  FTimeDate.Show;
end;


procedure TFRunMode.WSpyUseShutdownValueChange(Sender: TObject);
begin
  PShutdownButton.Visible := WSpyUseShutdown.Value;
end;

procedure TFRunMode.BSecurityUnlockClick(Sender: TObject);
begin
  if (FMain.CheckPassword(RunModePassword, 'Run')) then begin
    BSecurityUnlock.Visible := False;
    BSecurityLock.Visible := True;
    Security(False);
  end;
end;

procedure TFRunMode.BSecurityLockClick(Sender: TObject);
begin
  if (MessageDlg('Lock Security?', mtConfirmation, mbOkCancel, 0) = mrOK) then begin
    BSecurityLock.Visible := False;
    BSecurityUnlock.Visible := True;
    Security(True);
  end;
end;

procedure TFRunMode.Security(Secure: Boolean);
//var
//  CommMode: TWCommunicationMode;
begin
  bGlobalSecure := Secure;
  if (FSpeedDynamics <> nil) then begin
    FSpeedDynamics.WSpeedOffPRaise.IsMonitorOnly := Secure;
    FSpeedDynamics.WIffRp1.IsMonitorOnly := Secure;
    FSpeedDynamics.WIffLp1.IsMonitorOnly := Secure;
    FSpeedDynamics.WIffRI1.IsMonitorOnly := Secure;
    FSpeedDynamics.WIffLI1.IsMonitorOnly := Secure;
    FSpeedDynamics.WIffRd1.IsMonitorOnly := Secure;
    FSpeedDynamics.WIffLD1.IsMonitorOnly := Secure;
    FSpeedDynamics.WIffRp.IsMonitorOnly := Secure;
    FSpeedDynamics.WIffLp2.IsMonitorOnly := Secure;
    FSpeedDynamics.WIffRI2.IsMonitorOnly := Secure;
    FSpeedDynamics.WIffLI2.IsMonitorOnly := Secure;
    FSpeedDynamics.WIffRD2.IsMonitorOnly := Secure;
    FSpeedDynamics.WIffLd2.IsMonitorOnly := Secure;

    FSpeedDynamics.WSpeedOffPLower.IsMonitorOnly := Secure;
    FSpeedDynamics.WSpeedOffIRaise.IsMonitorOnly := Secure;
    FSpeedDynamics.WSpeedOffILower.IsMonitorOnly := Secure;
    FSpeedDynamics.WSpeedOffDRaise.IsMonitorOnly := Secure;
    FSpeedDynamics.WSpeedOffDLower.IsMonitorOnly := Secure;
    FSpeedDynamics.WSpeedOnPRaise.IsMonitorOnly := Secure;
    FSpeedDynamics.WSpeedOnPLower.IsMonitorOnly := Secure;
    FSpeedDynamics.WSpeedOnIRaise.IsMonitorOnly := Secure;
    FSpeedDynamics.WSpeedOnILower.IsMonitorOnly := Secure;
    FSpeedDynamics.WSpeedOnDRaise.IsMonitorOnly := Secure;
    FSpeedDynamics.WSpeedOnDLower.IsMonitorOnly := Secure;
  end;
  if (FExtAdmDynamics <> nil) then begin
    FExtAdmDynamics.WExtAdmPRaise.IsMonitorOnly := Secure;
    FExtAdmDynamics.WExtAdmPFastRaise.IsMonitorOnly := Secure;
    FExtAdmDynamics.WExtAdmPLower.IsMonitorOnly := Secure;
    FExtAdmDynamics.WExtAdmPFastLower.IsMonitorOnly := Secure;
    FExtAdmDynamics.WExtAdmIRaise.IsMonitorOnly := Secure;
    FExtAdmDynamics.WExtAdmIFastRaise.IsMonitorOnly := Secure;
    FExtAdmDynamics.WExtAdmILower.IsMonitorOnly := Secure;
    FExtAdmDynamics.WExtAdmIFastLower.IsMonitorOnly := Secure;
    FExtAdmDynamics.WExtAdmDRaise.IsMonitorOnly := Secure;
    FExtAdmDynamics.WExtAdmDFastRaise.IsMonitorOnly := Secure;
    FExtAdmDynamics.WExtAdmDLower.IsMonitorOnly := Secure;
    FExtAdmDynamics.WExtAdmDFastLower.IsMonitorOnly := Secure;
  end;
  if (FCascadeDynamics <> nil) then begin
    FCascadeDynamics.WCascadePRaise.IsMonitorOnly := Secure;
    FCascadeDynamics.WCascadePFastRaise.IsMonitorOnly := Secure;
    FCascadeDynamics.WCascadePLower.IsMonitorOnly := Secure;
    FCascadeDynamics.WCascadePFastLower.IsMonitorOnly := Secure;
    FCascadeDynamics.WCascadeIRaise.IsMonitorOnly := Secure;
    FCascadeDynamics.WCascadeIFastRaise.IsMonitorOnly := Secure;
    FCascadeDynamics.WCascadeILower.IsMonitorOnly := Secure;
    FCascadeDynamics.WCascadeIFastLower.IsMonitorOnly := Secure;
    FCascadeDynamics.WCascadeDRaise.IsMonitorOnly := Secure;
    FCascadeDynamics.WCascadeDFastRaise.IsMonitorOnly := Secure;
    FCascadeDynamics.WCascadeDLower.IsMonitorOnly := Secure;
    FCascadeDynamics.WCascadeDFastLower.IsMonitorOnly := Secure;
  end;
  if (FAuxiliaryDynamics <> nil) then begin
    FAuxiliaryDynamics.WAuxiliaryPRaise.IsMonitorOnly := Secure;
    FAuxiliaryDynamics.WAuxiliaryPFastRaise.IsMonitorOnly := Secure;
    FAuxiliaryDynamics.WAuxiliaryPLower.IsMonitorOnly := Secure;
    FAuxiliaryDynamics.WAuxiliaryPFastLower.IsMonitorOnly := Secure;
    FAuxiliaryDynamics.WAuxiliaryIRaise.IsMonitorOnly := Secure;
    FAuxiliaryDynamics.WAuxiliaryIFastRaise.IsMonitorOnly := Secure;
    FAuxiliaryDynamics.WAuxiliaryILower.IsMonitorOnly := Secure;
    FAuxiliaryDynamics.WAuxiliaryIFastLower.IsMonitorOnly := Secure;
    FAuxiliaryDynamics.WAuxiliaryDRaise.IsMonitorOnly := Secure;
    FAuxiliaryDynamics.WAuxiliaryDFastRaise.IsMonitorOnly := Secure;
    FAuxiliaryDynamics.WAuxiliaryDLower.IsMonitorOnly := Secure;
    FAuxiliaryDynamics.WAuxiliaryDFastLower.IsMonitorOnly := Secure;
  end;
  // Valve Calibration

 // WValve1Dither.IsMonitorOnly := Secure;
 // WValve1Manual.IsMonitorOnly := Secure;
 // WValve1Max.Enabled := not Secure;
 // WValve1Min.Enabled := not Secure;
 // WUpperMaxRaise.IsMonitorOnly := Secure;
 // WUpperMaxLower.IsMonitorOnly := Secure;
 // WUpperMinRaise.IsMonitorOnly := Secure;
 // WUpperMinLower.IsMonitorOnly := Secure;
{
  WValve1GoToManual.IsMonitorOnly := Secure;
  WValve1GoToMax.IsMonitorOnly := Secure;
  WValve1GoToMin.IsMonitorOnly := Secure;
}

 // WValve1Enable.IsMonitorOnly := Secure;
 // WValve1Disable.IsMonitorOnly := Secure;
{
  WValve2GoToManual.IsMonitorOnly := Secure;
  WValve2GoToMax.IsMonitorOnly := Secure;
  WValve2GoToMin.IsMonitorOnly := Secure;
}


 // WSaveSettingsButton.IsMonitorOnly := Secure;
  //Misc
  BSetTimeDate.Enabled := not Secure;
  BOverspeedTest.Enabled := not secure;
  WIstartvlvtest.Enabled := not Secure;
  if (Secure = True) then 
  WIvalvetestsel.Value := 0;
  WIvalvetestsel.IsMonitorOnly := secure;


end;

procedure TFRunMode.PageControl1Changing(Sender: TObject;
  var AllowChange: Boolean);
begin
  //PResetAlarmsButton.Visible := False;
  POverspeedTestButton.Visible := False;
 // PSetTimeDateButton.Visible := False;
  PSecurityButton.Visible := False;


end;

procedure TFRunMode.PageControl1Change(Sender: TObject);
begin
  UpdateFormCaption;
  if (PageControl1.ActivePage = WPStartTurbine) then begin
  end else if (PageControl1.ActivePage = WPSpeedControl) then begin
    POverspeedTestButton.Visible := True;
    PSecurityButton.Visible := True;
  end else if (PageControl1.ActivePage = WPExtrAdmCntrl) then begin
    PSecurityButton.Visible := True;
  end else if (PageControl1.ActivePage = WPCascadeControl) then begin
    PSecurityButton.Visible := True;
  end else if (PageControl1.ActivePage = WPdecouplingControl) then begin
    PSecurityButton.Visible := True;
  end else if (PageControl1.ActivePage = WPValves) then begin
    PSecurityButton.Visible := True;

  end;
end;


procedure TFRunMode.BRemoteMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  //BRemote.Enabled := False;
end;

procedure TFRunMode.BLocalMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  //BLocal.Enabled := False;
end;




procedure TFRunMode.WIatlowstepValueChange(Sender: TObject);
begin
Watidle.Visible := WIatlowstep.Value;
end;

procedure TFRunMode.WIatlmediumstepValueChange(Sender: TObject);
begin
Watmedium.Visible :=  WIatlmediumstep.Value;
end;

procedure TFRunMode.WIatlhighstepValueChange(Sender: TObject);
begin
Wathigh.Visible :=  WIatlhighstep.Value;
end;

procedure TFRunMode.WIcompleteValueChange(Sender: TObject);
begin
if WIcomplete.Value then
WPStartSeqPanel.visible := False
else
WPStartSeqPanel.visible := True;
end;

procedure TFRunMode.WIspycurract1ValueChange(Sender: TObject);
begin
if  WIspycurract1.Value then begin
Wact1min4.Visible := True;
Wact1max20.Visible := True;
Wact1min20.Visible := False;
Wact1max160.Visible := False;
end
else begin
Wact1min4.Visible := False;
Wact1max20.Visible := False;
Wact1min20.Visible := True;
Wact1max160.Visible := True;
end

end;

procedure TFRunMode.WIspycurract2ValueChange(Sender: TObject);
begin
if  WIspycurract2.Value then begin
Wact2min4.Visible := True;
Wact2max20.Visible := True;
Wact2min20.Visible := False;
Wact2max160.Visible := False;
end
else begin
Wact2min4.Visible := False;
Wact2max20.Visible := False;
Wact2min20.Visible := True;
Wact2max160.Visible := True;
end
end;




procedure TFRunMode.WspyvalvetestedValueChange(Sender: TObject);
begin
case Wspyvalvetested.Value of
    0: begin
         Wact1combo.visible := False;
         Wact2combo.visible := False;
         Wa106_1.Visible := False;
         Wc106_1.Visible := False;
         Wa106_2.Visible := False;
         Wc106_2.Visible := False;
         WhpPIlot.Visible := False;
         WlpPIlot.Visible := False;
         end;
     1: begin
         Wact1combo.visible := True;
         Wact2combo.visible := False;
         Wa106_1.Visible := False;
         Wc106_1.Visible := False;
         Wa106_2.Visible := False;
         Wc106_2.Visible := False;
         WhpPIlot.Visible := False;
         WlpPIlot.Visible := False;
         end;

       2: begin
         Wact1combo.visible := False;
         Wact2combo.visible := True;
         Wa106_1.Visible := False;
         Wc106_1.Visible := False;
         Wa106_2.Visible := False;
         Wc106_2.Visible := False;
         WhpPIlot.Visible := False;
         WlpPIlot.Visible := False;
         end;
       3: begin
         Wact1combo.visible := False;
         Wact2combo.visible := False;
         Wa106_1.Visible := True;
         Wc106_1.Visible := False;
         Wa106_2.Visible := False;
         Wc106_2.Visible := False;
         WhpPIlot.Visible := WIhpliot.value;
         WlpPIlot.Visible := WIlpliot.value;
         end;
       4: begin
         Wact1combo.visible := False;
         Wact2combo.visible := False;
         Wa106_1.Visible := False;
         Wc106_1.Visible := True;
         Wa106_2.Visible := False;
         Wc106_2.Visible := False;
         WhpPIlot.Visible := WIhpliot.value;
         WlpPIlot.Visible := WIlpliot.value;
         end;
       5: begin
         Wact1combo.visible := False;
         Wact2combo.visible := False;
         Wa106_1.Visible := False;
         Wc106_1.Visible := False;
         Wa106_2.Visible := True;
         Wc106_2.Visible := False;
         WhpPIlot.Visible := WIhpliot.value;
         WlpPIlot.Visible := WIlpliot.value;
         end;
        6: begin
         Wact1combo.visible := False;
         Wact2combo.visible := False;
         Wa106_1.Visible := False;
         Wc106_1.Visible := False;
         Wa106_2.Visible := False;
         Wc106_2.Visible := True;
         WhpPIlot.Visible := WIhpliot.value;
         WlpPIlot.Visible := WIlpliot.value;
         end;
     end;
end;

procedure TFRunMode.WspyteststepnumberValueChange(Sender: TObject);
begin
case Wspyteststepnumber.Value of
    1: begin    //disabled step
          sleep(100);
         WIstartvlvtest.Visible := True;
         WIquitcal.Visible := False;
          Wtestseq.Visible := False;
          Wactuatorselected.Visible := False;
          WIvalvetestsel.IsMonitorOnly := False;
         end;
    2: begin   //enable step
          sleep(100);
          WIstartvlvtest.Visible := False;
          WIquitcal.Visible := True;
          Wtestseq.Visible := True;
          Wactuatorselected.visible := True;
          Wvlvtomin.visible := True;
          WIvlvtomax.visible := False;
          WIvlvtoman.visible := False;
          WIvlvcplted.visible := False;
          WIa106_ch1man.Visible :=False;
          WIc106_ch1man.Visible :=False;
          WIa106_ch2man.Visible :=False;
          WIc106_ch2man.Visible :=False;
          WIvalvetestsel.IsMonitorOnly :=True;
         end;
    3: begin   //goto min step step
          sleep(100);
          WIstartvlvtest.Visible := False;
          WIquitcal.Visible := False;
          Wtestseq.Visible := True;
          Wactuatorselected.visible := True;
          Wvlvtomin.visible := False;
          WIvlvtomax.visible := True;
           WIvlvtoman.visible := False;
          WIvlvcplted.visible := False;
          WIa106_ch1man.Visible :=False;
          WIc106_ch1man.Visible :=False;
          WIa106_ch2man.Visible :=False;
          WIc106_ch2man.Visible :=False;
          WIvalvetestsel.IsMonitorOnly :=True;
         end;
    4: begin   //goto max step
          sleep(100);
          WIstartvlvtest.Visible := False;
          WIquitcal.Visible := False;
          Wtestseq.Visible := True;
          Wactuatorselected.visible := True;
          Wvlvtomin.visible := False;
          WIvlvtomax.visible := False;
           WIvlvtoman.visible := True;
          WIvlvcplted.visible := False;
          WIa106_ch1man.Visible :=False;
          WIc106_ch1man.Visible :=False;
          WIa106_ch2man.Visible :=False;
          WIc106_ch2man.Visible :=False;
          WIvalvetestsel.IsMonitorOnly :=True;
         end;
    5: begin   //manual stroke step
          sleep(100);
          WIstartvlvtest.Visible := False;
          WIquitcal.Visible := False;
          Wtestseq.Visible := True;
          Wactuatorselected.visible := True;
          Wvlvtomin.visible := False;
          WIvlvtomax.visible := False;
          WIvlvtoman.visible := False;
          WIvlvcplted.visible := True;
          WIa106_ch1man.Visible :=True;
          WIc106_ch1man.Visible :=True;
          WIa106_ch2man.Visible :=True;
          WIc106_ch2man.Visible :=True;
          WIvalvetestsel.IsMonitorOnly :=True;
         end;

    end;


end;

procedure TFRunMode.Wspyact1propValueChange(Sender: TObject);
begin
if  Wspyact1prop.Value then begin
    WIpropAch1.Visible := True;
    WIpropCch1.Visible := True;
    WIintAch1.Visible := False;
    WIintCch1.Visible := False;
    end
    else begin
    WIpropAch1.Visible := False;
    WIpropCch1.Visible := False;
    WIintAch1.Visible := True;
    WIintCch1.Visible := True;
    end
end;

procedure TFRunMode.Wspyact2propValueChange(Sender: TObject);
begin
if  Wspyact2prop.Value then begin
    WIpropAch2.Visible := True;
    WIpropCch2.Visible := True;
    WIintAch2.Visible := False;
    WIintCch2.Visible := False;
    end
    else begin
    WIpropAch2.Visible := False;
    WIpropCch2.Visible := False;
    WIintAch2.Visible := True;
    WIintCch2.Visible := True;
    end

end;

procedure TFRunMode.WIvalvetestselChange(Sender: TObject);
begin

     sleep(100);
case WIvalvetestsel.Value of
     1: begin
        sleep(100);
        if   WIact1used.Value = false then   WIvalvetestsel.Value := 0;
     end;
     2: begin
        sleep(100);
        if   WIact2used.Value = false then   WIvalvetestsel.Value := 0;
     end;
     3: begin
        sleep(100);
        if   WIactfb1used.Value = false then   WIvalvetestsel.Value := 0;
     end;
     4: begin
        sleep(100);
        if   WIactfb1used.Value = false then   WIvalvetestsel.Value := 0;
     end;
     5: begin
        sleep(100);
        if   WIactfb2used.Value = false then   WIvalvetestsel.Value := 0;
     end;
     6: begin
        sleep(100);
        if   WIactfb2used.Value = false then   WIvalvetestsel.Value := 0;
     end;

    end;

end;

procedure TFRunMode.WIextrturbValueChange(Sender: TObject);
begin
Wuselp.Visible := WIextrturb.Value;
WPExtrAdmCntrl.TabVisible := WIextrturb.Value;
end;

procedure TFRunMode.e(Sender: TObject);
begin
usehp2.Visible :=  WIspyusehp2.Value;
end;

procedure TFRunMode.WIspylp2ValueChange(Sender: TObject);
begin
uselp2.Visible :=  WIspylp2.Value;
end;

procedure TFRunMode.WIspya106lvdt2ValueChange(Sender: TObject);
begin
if  (WIspya106lvdt2.Value = 1) then WIalvdt2.Visible := False
else WIalvdt2.Visible := True;

end;

procedure TFRunMode.WIspyc106lvdt2ValueChange(Sender: TObject);
begin
if  (WIspyc106lvdt2.Value = 1) then WIclvdt2.Visible := False
else WIclvdt2.Visible := True;

end;

procedure TFRunMode.WIspy2a106lvdt2ValueChange(Sender: TObject);
begin
if  (WIspy2a106lvdt2.Value = 1) then WIa2lvdt2.Visible := False
else WIa2lvdt2.Visible := True;
end;

procedure TFRunMode.WIspy2c106lvdt2ValueChange(Sender: TObject);
begin
if  (WIspy2c106lvdt2.Value = 1) then WIc2lvdt2.Visible := False
else WIc2lvdt2.Visible := True;
end;

procedure TFRunMode.WIhpdegValueChange(Sender: TObject);
begin
Lhpdegrated.Visible := WIhpdeg.Value;
WlagdegHP.Visible := WIhpdeg.Value;
LlagHPdeg.Visible := WIhpdeg.Value;
WleaddegHP.Visible := WIhpdeg.Value;
LleadHPdeg.Visible := WIhpdeg.Value;
end;

procedure TFRunMode.WIlpdegValueChange(Sender: TObject);
begin
Llpdegrated.Visible := WIlpdeg.Value;
WlagdegLP.Visible := WIlpdeg.Value;
LlagLPdeg.Visible := WIlpdeg.Value;
WleaddegLP.Visible := WIlpdeg.Value;
LleadLPdeg.Visible := WIlpdeg.Value;
end;

procedure TFRunMode.WIusedfdbkValueChange(Sender: TObject);
begin
if WIusedfdbk.Value then   WPRunButtons.Height := 89
else  WPRunButtons.Height := 41;
end;

procedure TFRunMode.WHPchkValueChange(Sender: TObject);
begin
if (WHPchk.Value > 2) then
Whpfdbk.Visible := true
else
Whpfdbk.Visible := false;
end;

procedure TFRunMode.WLPchkValueChange(Sender: TObject);
begin
if (WLPchk.Value > 2) then
Wlpfdbk.Visible := true
else
Wlpfdbk.Visible := false;
end;

procedure TFRunMode.WIspytrackextrValueChange(Sender: TObject);
begin
Wenottrack.Visible := WIspytrackextr.Value;
sleep(50);
Wetrack.Visible := not Wenottrack.Visible;

end;

procedure TFRunMode.WIspydcpltrackValueChange(Sender: TObject);
begin
dcplnottrack.Visible :=  WIspydcpltrack.Value;
sleep(50);
dcpltrack.Visible := not dcplnottrack.Visible;
end;

procedure TFRunMode.WIspyfwValueChange(Sender: TObject);
begin
WForward.Visible :=  WIspyfw.Value;
end;

procedure TFRunMode.Wspyred1ValueChange(Sender: TObject);
begin
Wred1.Visible := Wspyred1.Value;
end;

procedure TFRunMode.Wspyred2ValueChange(Sender: TObject);
begin
Wred2.Visible := Wspyred2.Value;
end;

procedure TFRunMode.WIcascadetrackValueChange(Sender: TObject);
begin
Wcasnotrack.Visible :=  WIcascadetrack.Value;
sleep(50);
Wcastrack.Visible := not Wcasnotrack.Visible;
end;

procedure TFRunMode.WIspyextmanValueChange(Sender: TObject);
begin
Wextrauto.Visible :=  WIspyextman.Value;
sleep(50);
Wextrman.Visible := not Wextrauto.Visible;
end;

procedure TFRunMode.WspydcplautoValueChange(Sender: TObject);
begin
WIauxauto.Visible :=  Wspydcplauto.Value;
sleep(50);
WIauxman.Visible := not WIauxauto.Visible;
end;

end.
